package ntnu.agent;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.Serializable;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import android.location.Location;
import android.location.LocationListener;
import android.location.GpsStatus.Listener;
import android.os.Bundle;
import android.util.Log;

import com.google.android.maps.GeoPoint;

import ntnu.model.Citynode;
import ntnu.model.Recommendation;
import ntnu.model.User;
import ntnu.model.UserModel;
import ntnu.util.XmlUtil;

public class RecommenderAgent implements Serializable{

	/*
	 * TODO: Remove all redundant code
	 */
	
	
	private URL hostUrl;
	
	
	private int sessionId; 
	
	public RecommenderAgent(URL hostLocation)
	{ 
		this.hostUrl = hostLocation; 
	}
	

	public boolean giveExplicitFeedback(Citynode rec, double rating)
	{ 
		
		
		
		
		String request = "<?xml version= \"1.0\"?>";                              
		request += "<Request type=\"giveexplicitfeedback\" feedback=\""+rating+"\" citynodeid=\""+rec.getId()+"\" sessionid=\""+this.sessionId+"\" >"; 
	
		request += "</Request>" ;
		
		Log.v("requset", request);
		
		
		Document doc =   XmlUtil.fromStringToXml(postData(request));
		
		/*
		Element recs = (Element)doc.getElementsByTagName("recommendationlist").item(0);
		
		
		NodeList recNodes = recs.getElementsByTagName("recommendation");
		

		ArrayList <Recommendation> returnNodes = new ArrayList();
		
		for (int i=0; i< recNodes.getLength();i++)
		{ 
			Element cNode =  (Element) recNodes.item(i); 
			
			returnNodes.add(Recommendation.fromXml(cNode)); 
		
		}
		*/
		
		Element respons = (Element) doc.getElementsByTagName("respons").item(0); 
		
		System.out.println(respons.getAttribute("respons"));
		
		return Boolean.valueOf(respons.getAttribute("respons")); 
		
		//return returnNodes;
		
	}
	
	
	public UserModel getUserModel()
	{ 
		String request = "<?xml version= \"1.0\"?>";
		request += "<Request sessionid=\""+this.sessionId+"\" type=\"getusermodel\" userid=\"1\">"; 
		
		request += "</Request>" ;
		
		Document doc =   XmlUtil.fromStringToXml(postData(request));

		Element list = (Element)doc.getElementsByTagName("usermodellist").item(0);
		
		Element usermodel = (Element) list.getElementsByTagName("usermodel").item(0); 
		
		return UserModel.fromXml(usermodel); 
	}
	
	
	
	public List<Recommendation> getRecommendations(String type,Location location,boolean forme, List <GeoPoint> fieldOfIntrest) {
	
		
		
		String request = "<?xml version= \"1.0\"?>";
		request += "<Request sessionid=\""+this.sessionId+"\" type=\"getrecommendations\" value=\""+type+"\" personal=\""+forme+"\">"; 
		request +=  "<Context location=\""+location.getLatitude() +" "+location.getLongitude()+"\" >";
		request +=  "<Field point1=\""+fieldOfIntrest.get(0).getLatitudeE6()/1E6 +" "+fieldOfIntrest.get(0).getLongitudeE6()/1E6 
					 +"\" point2=\""+fieldOfIntrest.get(1).getLatitudeE6()/1E6 +" "+fieldOfIntrest.get(1).getLongitudeE6()/1E6 +
					 "\" point3=\""+fieldOfIntrest.get(2).getLatitudeE6()/1E6 +" "+fieldOfIntrest.get(2).getLongitudeE6()/1E6 +
					 "\" point4=\""+fieldOfIntrest.get(3).getLatitudeE6()/1E6 +" "+fieldOfIntrest.get(3).getLongitudeE6()/1E6 +
					 "\" point5=\""+fieldOfIntrest.get(0).getLatitudeE6()/1E6 +" "+fieldOfIntrest.get(0).getLongitudeE6()/1E6+"\" />";
		request += "</Context>"; 
		request += "</Request>" ;
		
		Log.v("lat", String.valueOf(location.getLatitude()));
		Log.v("long", String.valueOf(location.getLongitude()));
		
		Document doc =   XmlUtil.fromStringToXml(postData(request));
		
		ArrayList <Recommendation> returnNodes = new ArrayList();
		
		if(doc!=null && doc.getElementsByTagName("recommendationlist").item(0)!=null)
		{
			Element recs = (Element)doc.getElementsByTagName("recommendationlist").item(0);
			
			
			NodeList recNodes = recs.getElementsByTagName("recommendation");
			
	
	
			
			for (int i=0; i< recNodes.getLength();i++)
			{ 
				Element cNode =  (Element) recNodes.item(i); 
				
				returnNodes.add(Recommendation.fromXml(cNode)); 
			
			}
		
		}
		return returnNodes;
		
		
	}
	
	public List<Recommendation> getTravelPlan(Location location) {
		
		String request = "<?xml version= \"1.0\"?>";
		request += "<Request sessionid=\""+this.sessionId+"\" type=\"gettravelplan\" >"; 
		request +=  "<Context location=\""+location.getLatitude() +" "+location.getLongitude()+"\" >";
		request += "</Context>"; 
		request += "</Request>" ;
		
		Log.v("lat", String.valueOf(location.getLatitude()));
		Log.v("long", String.valueOf(location.getLongitude()));
		
		Document doc =   XmlUtil.fromStringToXml(postData(request));
		Log.v("doc", doc.toString());
		Element recs = (Element)doc.getElementsByTagName("recommendationlist").item(0);
		
		
		NodeList recNodes = recs.getElementsByTagName("recommendation");
		

		ArrayList <Recommendation> returnNodes = new ArrayList();
		
		for (int i=0; i< recNodes.getLength();i++)
		{ 
			Element cNode =  (Element) recNodes.item(i); 
			
			returnNodes.add(Recommendation.fromXml(cNode)); 
		
		}
		
		return returnNodes;
		
	}
	
	
	
	
	
	
	public boolean login()
	{ 
		String request = "<?xml version= \"1.0\"?>";
		request += "<Request type=\"login\" password=\"marianne\" username=\"marianne\">"; 
		request += "</Request>" ;
		
		Document doc =   XmlUtil.fromStringToXml(postData(request)); 
		
		Element response = (Element)doc.getElementsByTagName("response").item(0); 
		
		if(response.hasAttribute("value") && response.getAttribute("value").equals("ok"))
		{ 
			Log.v("login", "logged in"); 
			
			this.sessionId = Integer.parseInt(response.getAttribute("sessionid"));
			
			Log.v("sessionid",String.valueOf(this.sessionId));
			
			return true; 
		}
		
		return false; 
		
	}
	
	public List <Recommendation> checkForTravelPlan(Location arg0)
	{ 
		
		String request = "<?xml version= \"1.0\"?>";
		request += "<Request sessionid=\""+this.sessionId+"\" type=\"update\">"; 
		request +=  "<Context location=\""+arg0.getLatitude() +" "+arg0.getLongitude()+"\" checkfortravelplan=\"1\">";
		request += "</Context>"; 
		request += "</Request>";
		
		
		Document doc =   XmlUtil.fromStringToXml(postData(request));
		Element recs = null;
		ArrayList <Recommendation> returnNodes = new ArrayList();
		if(doc!=null && doc.getElementsByTagName("recommendationlist")!=null)
		{
			recs = (Element)doc.getElementsByTagName("recommendationlist").item(0);
			NodeList recNodes = recs.getElementsByTagName("recommendation");
		
			for (int i=0; i< recNodes.getLength();i++)
			{ 
				Element cNode =  (Element) recNodes.item(i); 
				
				returnNodes.add(Recommendation.fromXml(cNode)); 
		
			}
		}
			return returnNodes;
		
	}
	
	public Recommendation addToTravelPlan(Recommendation r)
	{
		String request = "<?xml version= \"1.0\"?>";
		request += "<Request type=\"addtotravelplan\" recommendationid=\""+r.getId()+"\" sessionid=\""+this.sessionId+"\" >"; 
		request += "</Request>";
		
		
		Document doc =   XmlUtil.fromStringToXml(postData(request));
	
		
		Recommendation returnRec = null; 
		
		if(doc!=null && doc.getElementsByTagName("recommendation")!=null)
		{
			Element rec = (Element)doc.getElementsByTagName("recommendation").item(0);
			returnRec = Recommendation.fromXml(rec); 
		}
		
		return returnRec;
	}
	
	
	public Recommendation removeFromTravelPlan(Recommendation r)
	{ 
		
		String request = "<?xml version= \"1.0\"?>";
		request += "<Request type=\"removefromtravelplan\" recommendationid=\""+r.getId()+"\" sessionid=\""+this.sessionId+"\" >"; 
		request += "</Request>";
		
		
		Document doc =   XmlUtil.fromStringToXml(postData(request));
	
		
		Recommendation returnRec = null; 
		
		if(doc!=null && doc.getElementsByTagName("recommendation")!=null)
		{
			Element rec = (Element)doc.getElementsByTagName("recommendation").item(0);
			returnRec = Recommendation.fromXml(rec); 
		}
		
		return returnRec;
		
	}
	
	public Recommendation getRecFromCityNode(long ciynodeid, Location arg0)
	{ 
		
		String request = "<?xml version= \"1.0\"?>";
		request += "<Request sessionid=\""+this.sessionId+"\" type=\"getrecommendationfromcitymode\" ciynodeid=\""+ciynodeid+"\" >"; 
		request +=  "<Context location=\""+arg0.getLatitude() +" "+arg0.getLongitude()+"\" checkfortravelplan=\"0\" >";
		request += "</Context>"; 
		request += "</Request>";
		
		
		Document doc =   XmlUtil.fromStringToXml(postData(request));
	
		
		Recommendation returnRec = null; 
		
		if(doc!=null && doc.getElementsByTagName("recommendation")!=null)
		{
			Element rec = (Element)doc.getElementsByTagName("recommendation").item(0);
			returnRec = Recommendation.fromXml(rec); 
		}
		
		return returnRec;
		
	}
	
	
	

	public List<Recommendation> checkForRecommendaions(Location arg0) 
	{
		
		String request = "<?xml version= \"1.0\"?>";
		request += "<Request sessionid=\""+this.sessionId+"\" type=\"update\">"; 
		request +=  "<Context location=\""+arg0.getLatitude() +" "+arg0.getLongitude()+"\" checkfortravelplan=\"0\" >";
		request += "</Context>"; 
		request += "</Request>";
		
		
		Document doc =   XmlUtil.fromStringToXml(postData(request));
		Element recs = null;
		ArrayList <Recommendation> returnNodes = new ArrayList();
		if(doc!=null && doc.getElementsByTagName("recommendationlist")!=null)
		{
			recs = (Element)doc.getElementsByTagName("recommendationlist").item(0);
			NodeList recNodes = recs.getElementsByTagName("recommendation");
		
			for (int i=0; i< recNodes.getLength();i++)
			{ 
				Element cNode =  (Element) recNodes.item(i); 
				
				returnNodes.add(Recommendation.fromXml(cNode)); 
		
			}
		}
			return returnNodes;
		
	}
	
	public Citynode checkForNewPlacesToRate(Location arg0) 
	{
		
		System.out.println("sjekker etter nye steder  rate");
		
		String request = "<?xml version= \"1.0\"?>";
		request += "<Request sessionid=\""+this.sessionId+"\" type=\"newratings\">"; 
		request +=  "<Context location=\""+arg0.getLatitude() +" "+arg0.getLongitude()+"\" checkfortravelplan=\"0\" >";
		//request +=  "<Context location=\"13.434196 10.412869\" checkfortravelplan=\"0\" >";
		request += "</Context>"; 
		request += "</Request>";
		
		
		Document doc =   XmlUtil.fromStringToXml(postData(request));
		Citynode returnRec = null; 
		
		if(doc!=null && doc.getElementsByTagName("citynode").item(0)!=null)
		{
			System.out.println(doc.getElementsByTagName("citynode").toString());
			Element rec = (Element)doc.getElementsByTagName("citynode").item(0);
			returnRec = Citynode.fromXml(rec); 
		}
		
		return returnRec;
		
	}
	
	
	
	

	
	public boolean removeTravelPlan() 
	{
		String request = "<?xml version= \"1.0\"?>";
		request += "<Request sessionid=\""+this.sessionId+"\" type=\"removetravelplan\">"; 
	
		request += "</Request>";
		
		
		Document doc =   XmlUtil.fromStringToXml(postData(request));
		
		return true;
		
	}
	
	
	public User findUser(GeoPoint arg0,long userId)
	{ 
		String request = "<?xml version= \"1.0\"?>";
		request += "<Request sessionid=\""+this.sessionId+"\" type=\"finduser\" otheruserid=\""+userId+"\">"; 
		request +=  "<Context location=\""+(arg0.getLatitudeE6()/1E6) +" "+(arg0.getLongitudeE6()/1E6)+"\" >";
		request += "</Context>"; 
		request += "</Request>";
		
		Document doc =   XmlUtil.fromStringToXml(postData(request));
		
		User returnRec = null; 
		
		if(doc!=null && doc.getElementsByTagName("user")!=null)
		{
			Element rec = (Element)doc.getElementsByTagName("user").item(0);
			returnRec = User.fromXml(rec); 
		}
		
		return returnRec;
	}
	
	public List<Recommendation> findRatingsFromUser(Location arg0,long userId,List <GeoPoint> fieldOfIntrest)
	{ 
		String request = "<?xml version= \"1.0\"?>";
		request += "<Request sessionid=\""+this.sessionId+"\" type=\"ratingsfromuser\" otheruserid=\""+userId+"\">"; 
		request +=  "<Context location=\""+(arg0.getLatitude()) +" "+(arg0.getLongitude())+"\" >";
		request +=  "<Field point1=\""+fieldOfIntrest.get(0).getLatitudeE6()/1E6 +" "+fieldOfIntrest.get(0).getLongitudeE6()/1E6 
		 +"\" point2=\""+fieldOfIntrest.get(1).getLatitudeE6()/1E6 +" "+fieldOfIntrest.get(1).getLongitudeE6()/1E6 +
		 "\" point3=\""+fieldOfIntrest.get(2).getLatitudeE6()/1E6 +" "+fieldOfIntrest.get(2).getLongitudeE6()/1E6 +
		 "\" point4=\""+fieldOfIntrest.get(3).getLatitudeE6()/1E6 +" "+fieldOfIntrest.get(3).getLongitudeE6()/1E6 +
		 "\" point5=\""+fieldOfIntrest.get(0).getLatitudeE6()/1E6 +" "+fieldOfIntrest.get(0).getLongitudeE6()/1E6+"\" />";
		request += "</Context>"; 
		request += "</Request>";
		
		Document doc =   XmlUtil.fromStringToXml(postData(request));
		Element recs = null;
		ArrayList <Recommendation> returnNodes = new ArrayList();
		if(doc!=null && doc.getElementsByTagName("recommendationlist")!=null)
		{
			recs = (Element)doc.getElementsByTagName("recommendationlist").item(0);
			NodeList recNodes = recs.getElementsByTagName("recommendation");
		
			for (int i=0; i< recNodes.getLength();i++)
			{ 
				Element cNode =  (Element) recNodes.item(i); 
				
				returnNodes.add(Recommendation.fromXml(cNode)); 
		
			}
		}
			return returnNodes;
	}
	
	

	
	
	private String postData(String xml)
	{ 
			
			// Send data 
			URL url = this.hostUrl; 
			URLConnection conn;
			String returnLine  = "";  
			try {
				conn = url.openConnection();
		 
			conn.setDoOutput(true); OutputStreamWriter wr = new OutputStreamWriter(conn.getOutputStream());
		
			wr.write(xml);
			wr.flush(); 
			// Get the response 
			BufferedReader rd = new BufferedReader(new InputStreamReader(conn.getInputStream())); 
			String line; 
			
			while ((line = rd.readLine()) != null) { 
				 returnLine+=line;
				 Log.v("Response lines: ", line);
				} 
			
			Log.v("Dette er return line: ", returnLine);
			
			wr.close(); 
			rd.close(); 
			
				
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}	
	
		return returnLine;
		
	}








	
}
