package ntnu.client;

import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.security.KeyStore.LoadStoreParameter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.FactoryConfigurationError;
import javax.xml.parsers.ParserConfigurationException;

import ntnu.agent.RecommenderAgent;
import ntnu.model.Attribute;
import ntnu.model.Citynode;
import ntnu.model.Nodeholder;
import ntnu.model.Preference;
import ntnu.model.Recommendation;
import ntnu.model.SerializableCitynode;
import ntnu.model.UserModel;
import ntnu.ui.BaloonLayout;
import ntnu.ui.CitynodeItemizedOverlay;
import ntnu.ui.CitynodeMarker;
import ntnu.ui.CitynodeOverlayItem;
import ntnu.ui.IconManager;
import ntnu.ui.PathOverlay;

import ntnu.ui.RecommendationNotificationOverlay;
import ntnu.ui.Smiley;
import ntnu.ui.UserLocationOverlay;
import ntnu.util.ColorChangeUtil;
import ntnu.util.RoutePathUtil;


import com.google.android.maps.GeoPoint;
import com.google.android.maps.ItemizedOverlay;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;
import com.google.android.maps.OverlayItem;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.app.PendingIntent;
import android.content.ComponentName;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.res.ColorStateList;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Path;
import android.graphics.Point;
import android.graphics.drawable.AnimationDrawable;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.OvalShape;
import android.graphics.drawable.shapes.RectShape;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.opengl.Visibility;
import android.os.Bundle;
import android.os.Vibrator;
import android.util.Log;
import android.view.ContextMenu;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.SubMenu;
import android.view.View;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.View.OnTouchListener;
import android.view.ViewGroup.LayoutParams;
import android.view.animation.AccelerateDecelerateInterpolator;
import android.view.animation.Animation;
import android.view.animation.AnimationSet;
import android.view.animation.AnimationUtils;
import android.view.animation.LayoutAnimationController;
import android.view.animation.ScaleAnimation;
import android.view.animation.TranslateAnimation;
import android.widget.AbsoluteLayout;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.RatingBar;
import android.widget.RelativeLayout;
import android.widget.SlidingDrawer;
import android.widget.TextView;
import android.widget.Toast;




public class MapClient extends MapActivity implements ItemObserver, OnClickListener,  LocationListener ,OnTouchListener ,DialogInterface.OnClickListener {

	/*
	 * location 
	 */

	private LocationManager lmanager;  

	/*
	 * UI - elements 
	 */

	private boolean hasReviedRecs = false; 


	private TextView hideSearch;

	private MapView mapView; 

	private EditText search;

	private TextView textexp; 

	private TextView texteat; 

	private TextView textsleep;

	private Button searchbutton;

	private AbsoluteLayout layout; 

	private LinearLayout llayout; 

	private BaloonLayout noteBaloon; 

	private LinearLayout detailtedInformation; 

	private Button moreInfoButton; 

	private Button lessInfoButton;
	LinearLayout zoomLayout;

	private Button fromhere;

	private Button tohere;

	private RatingBar ratingbar;

	private LinearLayout feedback; 

	private Smiley smiley; 

	private BaloonLayout popupLayout; 

	private ImageView likeIcon; 

	private TextView likeText;

	private ImageView dislikeIcon; 

	private TextView dislikeText;

	private TextView travelPlanView; 

	private TextView pendingView; 

	private TextView mapwidth; 

	private View zoomView; 

	private Button addtoplan; 

	private Button rate; 

	private LinearLayout ratingView; 

	private RatingBar ratingBar;

	private Citynode newItemToRate; 

	private CheckBox forme; 


	private boolean lookForImplic = true;


	private HashMap <Long,Integer> proActiveRecs = new HashMap <Long,Integer>(); 
	private HashMap <Long,Integer> implicitRatings = new HashMap <Long,Integer>(); 

	private List <Citynode> pendingRatings;

	private int numberOfpending; 

	private ImageView quite;

	private SlidingDrawer drawer; 

	/////

	/*
	 * Overlays 
	 */

	 //used for drawing citynodes on top of the map
	 private CitynodeItemizedOverlay itemizedoverlay; 

	private UserLocationOverlay userLocationOverlay; 

	private UserModel userModel; 


	/*
	 * Various shit 
	 */

	 private  List<Overlay> mapOverlays; 

	 private List<Recommendation> citynodes; 

	 private List<Recommendation> travelPlan; 

	 private RecommenderAgent agent; 

	 private IconManager iconmanager;

	 private MapController mapController;

	 private Vibrator vibrator; 

	 private LayoutInflater inflater; 


	 private Dialog currentDialog;

	 /*
	  * state variables 
	  */

	  private TextView pressed; 


	  private Recommendation selectedRecommendation;

	  private boolean isDetailedInfo = true; 


	  public void onCreate(Bundle savedInstanceState)
	  {
		  super.onCreate(savedInstanceState);

		  this.lmanager = (LocationManager)getSystemService(Context.LOCATION_SERVICE);


		  this.iconmanager = new IconManager(this.getResources());
		  this.iconmanager.fillHashMap();
		  //init the recommender agent: 


			  URL url = null;
			  try 
			  {	

				  Log.v("Pecka", "Pre-url");
				  url = new URL("http://129.241.103.187:8080/rec47/recommender");
				  //				url = new URL("http://129.241.103.188:8080/rec25/recommender");
				  Log.v("Pecka", "Post-url");
				  DocumentBuilder d;
				  d = DocumentBuilderFactory.newInstance().newDocumentBuilder();
				  agent = new RecommenderAgent(url);
				  agent.login(); 
				  lmanager.requestLocationUpdates(LocationManager.GPS_PROVIDER,150000,30, this);
				  Log.v("Pecka", "Post-login");

			  } 
			  catch (MalformedURLException e)
			  {
				  e.printStackTrace();
			  }
			  catch (ParserConfigurationException e) {
				  // TODO Auto-generated catch block
				  e.printStackTrace();
			  } catch (FactoryConfigurationError e) {
				  // TODO Auto-generated catch block
				  e.printStackTrace();
			  } 
			  /*
			   * UI set up
			   */
			  setContentView(R.layout.main);

			  mapView = (MapView) findViewById(R.id.mapView);

			  mapController = this.mapView.getController();

			  this.zoomLayout = (LinearLayout)findViewById(R.id.zoom);  
			  this.zoomView = getMapView().getZoomControls(); 

			  this.zoomLayout.setOnTouchListener(this);

			  zoomLayout.addView(this.zoomView, 
					  new LinearLayout.LayoutParams(
							  LayoutParams.WRAP_CONTENT, 
							  LayoutParams.WRAP_CONTENT)); 
			  mapView.displayZoomControls(true);

			  mapView.getZoomControls().setOnTouchListener(this);

			  this.zoomView.setOnTouchListener(this);
			  this.userLocationOverlay = new UserLocationOverlay(this.lmanager.getLastKnownLocation(LocationManager.GPS_PROVIDER), BitmapFactory.decodeResource(
					  getResources(), R.drawable.gps),mapView); 
			  getMapView().getOverlays().add(this.userLocationOverlay); 

			  this.inflater = getLayoutInflater();



			  android.widget.FrameLayout.LayoutParams parms = new android.widget.FrameLayout.LayoutParams(320, 400);
			  parms.gravity = 0x00000050;
			  parms.height = 180;
			  FrameLayout l = (FrameLayout) inflater.inflate(R.layout.drawer, null);
			  this.drawer = (SlidingDrawer)l.findViewById(R.id.slide); 

			  mapOverlays =getMapView().getOverlays();
			  getWindow().addContentView(l, parms);
			  layout =(AbsoluteLayout) findViewById(R.id.content);
			  layout.setBackgroundColor(Color.WHITE);

			  l.setForegroundGravity(0x00000050);
			  search = (EditText)findViewById(R.id.search); 
			  search.setOnClickListener(this); 
			  textexp = (TextView) findViewById(R.id.textexp);
			  textexp.setOnClickListener(this);

			  texteat = (TextView) findViewById(R.id.texteat);
			  texteat.setOnClickListener(this);


			  textsleep = (TextView) findViewById(R.id.textsleep);
			  textsleep.setOnClickListener(this);

			  searchbutton = (Button)findViewById(R.id.searchbutton);
			  searchbutton.setOnClickListener(this); 

			  this.forme = (CheckBox)findViewById(R.id.widget123); 

			  this.forme.setOnClickListener(this); 

			  this.noteBaloon = (BaloonLayout) inflater.inflate( R.layout.baloonlayout, null);
			  RelativeLayout.LayoutParams layoutParams   = new RelativeLayout.LayoutParams(200,100);
			  layoutParams.addRule(RelativeLayout.CENTER_VERTICAL);
			  layoutParams.addRule(RelativeLayout.CENTER_HORIZONTAL);
			  noteBaloon.setLayoutParams(layoutParams);   


			  // this.likeIcon = (ImageView)noteBaloon.findViewById(R.id.like); 
			  //this.likeText = (TextView)noteBaloon.findViewById(R.id.liketext); 

			  //this.dislikeIcon = (ImageView)noteBaloon.findViewById(R.id.dislike); 
			  //this.dislikeText = (TextView)noteBaloon.findViewById(R.id.disliketext);

			  //  this.likeIcon.setOnClickListener(this); 
			  // this.likeText.setOnClickListener(this); 
			  //this.dislikeIcon.setOnClickListener(this); 
			  //this.dislikeText.setOnClickListener(this); 

			  this.ratingbar = (RatingBar)noteBaloon.findViewById(R.id.bar); 
			  this.rate = (Button)noteBaloon.findViewById(R.id.rate); 
			  this.rate.setOnClickListener(this);
			  this.addtoplan = (Button)noteBaloon.findViewById(R.id.addtoplan); 
			  addtoplan.setOnClickListener(this); 

			  //	    this.detailtedInformation = (LinearLayout) inflater.inflate( R.layout.moreinfosplash, null);
			  this.detailtedInformation = (LinearLayout) inflater.inflate( R.layout.info, null);
			  LinearLayout.LayoutParams l3 =new LinearLayout.LayoutParams(
					  LayoutParams.WRAP_CONTENT, 
					  LayoutParams.FILL_PARENT);

			  this.detailtedInformation.setLayoutParams(l3);
			  this.getWindow().addContentView(this.detailtedInformation,l3);
			  this.detailtedInformation.setVisibility(View.GONE);


			  this.popupLayout = (BaloonLayout) this.inflater.inflate( R.layout.popup, null);
			  LinearLayout.LayoutParams l4 =new LinearLayout.LayoutParams(
					  LayoutParams.WRAP_CONTENT, 
					  LayoutParams.WRAP_CONTENT);
			  this.popupLayout.setLayoutParams(l4); 

			  this.userLocationOverlay.setPopUp(popupLayout); 


			  this.fromhere = (Button)popupLayout.findViewById(R.id.fromherebutton); 
			  this.tohere = (Button)popupLayout.findViewById(R.id.toherebutton); 

			  fromhere.setOnClickListener(this); 
			  this.tohere.setOnClickListener(this);

			  this.pressed = this.texteat; 

			  getMapView().invalidate();

			  //  this.userModel = this.agent.getUserModel(); 

			  this.mapView.setOnTouchListener(this);

			  this.travelPlanView = (TextView)findViewById(R.id.custom); 

			  this.travelPlanView.setOnClickListener(this); 

			  this.ratingView = (LinearLayout) inflater.inflate( R.layout.ratingdialog, null);
			  this.ratingBar = (RatingBar)ratingView.findViewById(R.id.bar);

			  this.pendingView  = (TextView)findViewById(R.id.pending);
			  this.pendingView.setOnClickListener(this);



			  this.quite = (ImageView)noteBaloon.findViewById(R.id.quite);
			  this.quite.setOnTouchListener(this); 
			  Log.v("Pecka", "Pre location");
			  double lat = this.userLocationOverlay.getLocation().getLatitude(); 
			  double lng = this.userLocationOverlay.getLocation().getLongitude();

			  GeoPoint p = new GeoPoint(
					  (int) (lat * 1E6), 
					  (int) (lng * 1E6));

			  Log.v("Pecka", "Post location");
			  this.agent.checkForNewPlacesToRate(this.userLocationOverlay.getLocation());
			  this.mapwidth = (TextView)this.findViewById(R.id.mapwidth); 
			  this.mapView.getController().animateTo(p);
			  this.mapView.getController().setZoom(16); 
			  mapView.invalidate();

			  mapView.setOnTouchListener(this);

	  }



	  public void itemChange(Object o) 
	  {
		  if(o instanceof CitynodeOverlayItem)
		  { 
			  CitynodeOverlayItem node = (CitynodeOverlayItem)o;





			  getMapView().removeView(noteBaloon);
			  noteBaloon.setVisibility(View.VISIBLE);
			  ((TextView)noteBaloon.findViewById(R.id.note_label)).setText(((CitynodeOverlayItem) o).getNode().getNode().getTitle() + " (Distance:" + ((CitynodeOverlayItem) o).getNode().getDistance() +"m)");

			  Log.v("hva er dette naa",((CitynodeOverlayItem) o).getNode().getNode().getTitle());

			  ((TextView)noteBaloon.findViewById(R.id.note_text)).setText(((CitynodeOverlayItem) o).getNode().getNode().getTag().trim());
			  ((TextView)noteBaloon.findViewById(R.id.note_explanation)).setText(((CitynodeOverlayItem) o).getNode().getTextualExplanation().trim());

			  moreInfoButton = (Button)noteBaloon.findViewById(R.id.more_infobutton);
			  moreInfoButton.setOnClickListener(this);
			  mapController.animateTo(((CitynodeOverlayItem) o).getPoint()); 
			  getMapView().addView(noteBaloon, new MapView.LayoutParams(220,290,((CitynodeOverlayItem) o).getPoint(),MapView.LayoutParams.BOTTOM_CENTER));
			  this.selectedRecommendation = node.getNode();
			  this.newItemToRate = node.getNode().getNode();


			  float ratting = (Integer.valueOf(((CitynodeOverlayItem) o).getNode().getSystemRating())/10)/2; 

			  System.out.println("dette er rating:" + ratting);

			  if(((CitynodeOverlayItem) o).getNode().isPersonalized()) 
			  {
				  this.ratingbar.setVisibility(View.VISIBLE);
				  this.ratingbar.setRating(ratting);
			  }
			  else 
			  {
				  this.ratingbar.setVisibility(View.GONE); 
			  }
			  this.addtoplan.setText(this.selectedRecommendation.isInTravelPlan()?"Remove from plan" : "Add to plan"); 

			  List <PathOverlay> toRemove = new ArrayList<PathOverlay>();

			  for(Overlay overlay : mapView.getOverlays())
			  {
				  if(overlay instanceof PathOverlay)
				  {
					  //mapView.getOverlays().remove(overlay);
					  toRemove.add((PathOverlay) overlay);
				  }
			  }
			  mapView.getOverlays().removeAll(toRemove); 

			  if((Double.valueOf(((CitynodeOverlayItem) o).getNode().getDistance()))<4000)
				  mapView.getOverlays().add(RoutePathUtil.getPath(node.getPoint(),  new GeoPoint((int)(userLocationOverlay.getLocation().getLatitude()*1E6), (int)(userLocationOverlay.getLocation().getLongitude()*1E6))));


		  }

	  }

	  public synchronized void handleResult(boolean notify)
	  { 

		  if(!citynodes.equals(null) && citynodes.size()>0 )
		  {
			  noteBaloon.setVisibility(0x00000008);

			  Drawable drawable = this.getResources().getDrawable(R.drawable.up);
			  Context myContext = this;

			  itemizedoverlay = new CitynodeItemizedOverlay(drawable,myContext);
			  itemizedoverlay.setThumbsUp(BitmapFactory.decodeResource(
					  getResources(), R.drawable.vote_yes3));  

			  itemizedoverlay.setThubmsDown(BitmapFactory.decodeResource(
					  getResources(), R.drawable.vote_no3));  
			  itemizedoverlay.addObserver(this); 	

			  //itemizedoverlay.setDoAnimtation(true);

			  RecommendationNotificationOverlay overlay = new RecommendationNotificationOverlay(); 


			  for (Recommendation n : citynodes )
			  {

				  CitynodeOverlayItem cn= n.getNode().getOverlayItem();
				  Drawable marker =  this.iconmanager.changeBackground(this.iconmanager.findIcon(n.getNode()),Integer.parseInt(n.getSystemRating()),n.isPersonalized()); 
				  //marker.setAlpha(100);
				  marker.setBounds(0, 0, marker.getIntrinsicWidth(), marker.getIntrinsicHeight());

				  ShapeDrawable l; 

				  cn.setMarker(marker); 
				  cn.setNode(n);
				  itemizedoverlay.addOverlay(cn);

				  LayoutInflater inflater = getLayoutInflater();
			  }



			  for(Overlay i : getMapView().getOverlays() )
			  { 
				  if((i instanceof ItemizedOverlay)) //|| (i instanceof RecommendationNotificationOverlay) )
					  this.mapView.getOverlays().remove(i); 
			  }




			  for(Overlay i : getMapView().getOverlays() )
			  { 
				  if((i instanceof RecommendationNotificationOverlay) )
					  this.mapView.getOverlays().remove(i); 
			  }
			  List <Recommendation> proactive = new ArrayList<Recommendation>(); 

			  for(Recommendation potpro : this.citynodes)
			  {
				  if(potpro.isProactive())
				  {
					  proactive.add(potpro); 

				  }

			  }

			  overlay.setNotifications(proactive); 

			  mapOverlays.add(overlay);



			  mapOverlays.add(itemizedoverlay);



			  mapView.invalidate();

		  }

	  }


	  @Override
	  public void onClick(View v) {

		  if(v.equals(this.search))
		  {
			  this.pressed = null; 
		  }
		  else if(v.equals(this.textsleep))
		  {
			  this.texteat.setTextColor(Color.BLUE);
			  this.textexp.setTextColor(Color.BLUE);
			  this.textsleep.setTextColor(Color.BLACK);
			  this.search.setText("Sleep");
			  pressed = textsleep; 
		  }
		  else if(v.equals(this.textexp))
		  {
			  this.texteat.setTextColor(Color.BLUE);
			  this.textexp.setTextColor(Color.BLACK);
			  this.textsleep.setTextColor(Color.BLUE);
			  this.search.setText("Experience");
			  pressed = textexp; 

		  }
		  else if(v.equals(this.texteat))
		  {
			  this.texteat.setTextColor(Color.BLACK);
			  this.texteat.setPressed(true);

			  this.textexp.setTextColor(Color.BLUE);
			  this.textsleep.setTextColor(Color.BLUE);
			  search.setText("Eat");
			  pressed = this.texteat; 

		  }
		  else if(v.equals(this.searchbutton))
		  { 

			  boolean forme = this.forme.isChecked()?true:false;
			  this.drawer.animateClose();
			  this.mapView.invalidate();


			  //List <Recommendation> result = null; 

			  if(this.pressed!=null && this.pressed.equals(this.texteat))
			  {
				  citynodes  = this.agent.getRecommendations("Restaurant",this.lmanager.getLastKnownLocation(LocationManager.GPS_PROVIDER),forme,this.getIntrestField());
				  Log.v("gr inn", "msg");
			  }
			  else if(this.pressed!=null && this.pressed.equals(this.textexp))
			  { 

				  citynodes  = this.agent.getRecommendations("Activity",this.lmanager.getLastKnownLocation(LocationManager.GPS_PROVIDER),forme,this.getIntrestField());

			  }
			  else if(this.pressed!=null && this.pressed.equals(this.textsleep))
			  { 
				  citynodes  = this.agent.getRecommendations("Hotel",this.lmanager.getLastKnownLocation(LocationManager.GPS_PROVIDER),forme,this.getIntrestField());
			  }
			  else 
			  { 
				  Log.v("searchstring", this.search.getText().toString()); 
				  citynodes = this.agent.getRecommendations("Dronningens",this.lmanager.getLastKnownLocation(LocationManager.GPS_PROVIDER),forme,this.getIntrestField());



			  }
			  if(this.citynodes==null || this.citynodes.size()==0)
				  showDialog(6);

			  handleResult(false);

		  }
		  else if(v.equals(this.hideSearch))
		  { 
			  if(this.layout.getVisibility()==0x00000000)
			  { 
				  this.layout.setVisibility(0x00000008); 
				  this.hideSearch.setText("Show search bar");

			  }
			  else 
			  { 
				  this.layout.setVisibility(0x00000000); 
				  this.hideSearch.setText("Hide search bar");
			  }
		  }
		  else if(v.equals(this.moreInfoButton))
		  { 

			  Intent intent = new Intent(this, RecommendationDetial.class);
			  Bundle b = new Bundle();

			  b.putSerializable("recommendation", this.selectedRecommendation.getSerializableRecommendation()); 
			  b.putSerializable("usermodel", this.userModel); 
			  b.putDouble("latitude", this.userLocationOverlay.getLocation().getLatitude());
			  b.putDouble("longitude", this.userLocationOverlay.getLocation().getLongitude());
			  b.putSerializable("agent",this.agent); 
			  b.putSerializable("usermode",this.userModel);
			  intent.putExtras(b);

			  System.out.println("lat:" + this.userLocationOverlay.getLocation().getLatitude());
			  System.out.println("lat:" + this.userLocationOverlay.getLocation().getLongitude());

			  //	startActivityForResult(intent, requestCode)

			  startActivityForResult(intent,1);


		  }


		  else if(v.equals(this.travelPlanView))
		  { 

			  Intent intent = new Intent(this, TravelPlanView.class);
			  Bundle b = new Bundle();

			  b.putSerializable("agent",this.agent); 
			  b.putSerializable("usermode",this.userModel); 
			  //b.putSerializable("recommendation", this.selectedRecommendation.getSerializableRecommendation()); 
			  //b.putSerializable("usermodel", this.userModel); 

			  intent.putExtras(b);


			  startActivity(intent);


		  }
		  else if(v.equals(this.addtoplan))
		  { 



			  if(this.selectedRecommendation.isInTravelPlan())
			  {
				  this.agent.removeFromTravelPlan(this.selectedRecommendation);
				  this.selectedRecommendation.setInTravelPlan(false);
				  this.noteBaloon.setVisibility(View.GONE); 
				  this.travelPlanView.setAnimation(AnimationUtils.loadAnimation( this, R.anim.magnify ));
				  this.travelPlanView.startAnimation(AnimationUtils.loadAnimation( this, R.anim.magnify )); 
			  }
			  else 
			  { 
				  this.agent.addToTravelPlan(this.selectedRecommendation);
				  this.selectedRecommendation.setInTravelPlan(true);
				  this.noteBaloon.setVisibility(View.GONE); 
				  this.travelPlanView.setAnimation(AnimationUtils.loadAnimation( this, R.anim.magnify ));
				  this.travelPlanView.startAnimation(AnimationUtils.loadAnimation( this, R.anim.magnify )); 
			  }

			  this.mapView.invalidate();



		  }
		  else if(  v.equals(this.rate))
		  {
			  System.out.println("kommer inn her");
			  this.showDialog(0);
		  }


		  else if(v.equals(this.pendingView))
		  {
			  Intent intent = new Intent(this, PendingRatings.class);
			  Bundle b = new Bundle();

			  b.putSerializable("agent",this.agent); 
			  b.putSerializable("usermode",this.userModel); 

			  List <SerializableCitynode> citynodes = new ArrayList<SerializableCitynode>();

			  if(this.pendingRatings!=null)
			  {
				  for(Citynode c : this.pendingRatings)
				  {
					  citynodes.add(c.getSerializableCitynode()); 
				  }
			  }

			  Nodeholder n = new Nodeholder(); 
			  n.setNodes(citynodes); 

			  b.putSerializable("citynodes", n); 
			  b.putSerializable("agent", this.agent); 
			  //b.putSerializable("usermodel", this.userModel); 

			  this.citynodes = null;
			  this.pendingView.setText("Pending ratings"); 
			  this.numberOfpending = 0;
			  intent.putExtras(b);


			  startActivity(intent);
		  }
		  else if(v.equals(this.forme))
		  {
			  if(this.forme.isChecked())
			  {
				  showDialog(7); 
			  }
			  else
			  {
				  //showDialog(8); 
			  }


		  }
	  }
	  

	  @Override
	  protected void onActivityResult(int requestCode, int resultCode,
			  Intent data) {
		  // TODO Auto-generated method stub
		  if(resultCode==Activity.RESULT_OK)
		  {
			  long citynodeid = data.getIntExtra("citynodeid", -1); 

			  System.out.println("dette er userid" + citynodeid);

			  if(citynodeid>-1)
			  {
				  Recommendation l= this.agent.getRecFromCityNode(citynodeid, this.userLocationOverlay.getLocation());
				  System.out.println("Dette er l " + l);
				  if(l!=null)
				  {
					  if(this.citynodes==null)
					  {
						  this.citynodes = new ArrayList<Recommendation>();
						  this.citynodes.add(l); 
					  }

					  else 
					  {
						  citynodes.add(l);
					  }
					  handleResult(false);

					  this.mapController.animateTo(l.getNode().getPosition());
				  }
			  }


			  //finish();
		  }
	  }



	  protected Dialog onCreateDialog(int i)
	  {
		  if(i==0)
		  { 
			  System.out.println("kommer hit");
			  System.out.println("lager ny");
			  AlertDialog.Builder builder = new AlertDialog.Builder(this);
			  builder.setView(this.ratingView);

			  builder.setMessage("Rate "+ this.newItemToRate.getTitle())
			  .setCancelable(false)
			  .setPositiveButton("Rate", this)

			  .setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
				  public void onClick(DialogInterface dialog, int id) {
					  dialog.cancel();
				  }
			  });

			  return  builder.create();

		  }
		  else if(i==2)
		  {
			  AlertDialog.Builder builder = new AlertDialog.Builder(this);
			  builder.setMessage("Your rating of " + this.selectedRecommendation.getNode().getTitle() + " was successfully updated");
			  builder.setCancelable(true);
			  return builder.create(); 
		  }
		  else if(i==3) 
		  {
			  AlertDialog.Builder builder = new AlertDialog.Builder(this);
			  builder.setMessage("Network error. Check the status of your wireless conection");
			  builder.setCancelable(true);
			  return  builder.create(); 
		  }
		  else if(i==4)
		  {
			  AlertDialog.Builder builder = new AlertDialog.Builder(this);
			  builder.setMessage("You have received new recommendations")
			  .setNegativeButton("Back to map", new DialogInterface.OnClickListener() {
				  public void onClick(DialogInterface dialog, int id) {
					  dialog.cancel();
				  }
			  });
			  builder.setCancelable(true);
			  return builder.create(); 
		  }
		  else if(i==5)
		  {
			  AlertDialog.Builder builder = new AlertDialog.Builder(this);
			  builder.setView(this.ratingView);
			  builder.setMessage("Did you visit "+ this.newItemToRate.getTitle() + " ? ")
			  .setCancelable(false)
			  .setPositiveButton("Rate", this)
			  .setNegativeButton("Canel", new DialogInterface.OnClickListener() {
				  public void onClick(DialogInterface dialog, int id) {
					  dialog.cancel();
				  }
			  });
			  return  builder.create();


		  }

		  else if(i==6)
		  {
			  AlertDialog.Builder builder = new AlertDialog.Builder(this);

			  builder.setMessage("Your search gave no result. Try to zoom out to search in a different area or deselect \"Only stuff recommended for me\" ")
			  .setCancelable(true)
			  .setPositiveButton("Back to map", new DialogInterface.OnClickListener() {
				  public void onClick(DialogInterface dialog, int id) {
					  dialog.cancel();
				  }
			  })      
			  .setNegativeButton("Don't tell me this again", new DialogInterface.OnClickListener() {
				  public void onClick(DialogInterface dialog, int id) {
					  dialog.cancel();
				  }
			  });       

			  return  builder.create();


		  }

		  else if(i==7)
		  {
			  AlertDialog.Builder builder = new AlertDialog.Builder(this);

			  builder.setMessage("You are now only searching for stuff recommended for you. This will give you a few, higly recommended places as result")
			  .setCancelable(true)
			  .setPositiveButton("Back to map", new DialogInterface.OnClickListener() {
				  public void onClick(DialogInterface dialog, int id) {
					  dialog.cancel();
				  }
			  })      
			  .setNegativeButton("Don't tell me this again", new DialogInterface.OnClickListener() {
				  public void onClick(DialogInterface dialog, int id) {
					  dialog.cancel();
				  }
			  });       
			  return  builder.create();


		  }





		  return null;
	  }



	  @Override
	  protected void onPrepareDialog(int id, Dialog d) 
	  {
		  System.out.println("kommer hit");


		  if(id==0)
		  { 
			  System.out.println("kommer hit");
			  System.out.println("lager ny");

			  ((AlertDialog) d).setMessage("Rate "+ this.newItemToRate.getTitle());

		  }
		  else if(id==2)
		  {
			  ((AlertDialog) d).setMessage("Your rating of " + this.selectedRecommendation.getNode().getTitle() + " was successfully updated");

		  }
		  else if(id==3) 
		  {
			  ((AlertDialog) d).setMessage("Network error. Check the status of your wireless conection");


		  }
		  else if(id==4)
		  {
			  ((AlertDialog) d).setMessage("You have received new recommendations");
		  }
		  else if(id==5)
		  {


		  }

	  }



	  private List <GeoPoint> getIntrestField()
	  {


		  List <GeoPoint> points = new ArrayList<GeoPoint>();
		  this.mapView.invalidate();

		  GeoPoint bottomLeft = mapView.getProjection().fromPixels(
				  0,0);

		  GeoPoint bottomRight =  mapView.getProjection().fromPixels(
				  this.mapView.getWidth(),0);

		  GeoPoint topLeft = mapView.getProjection().fromPixels(
				  0,this.mapView.getHeight());

		  GeoPoint topRight = mapView.getProjection().fromPixels(
				  this.mapView.getWidth() ,this.mapView.getHeight());


		  points.add(bottomLeft); 
		  points.add(bottomRight);
		  points.add(topRight);
		  points.add(topLeft);


		  return points; 
	  }


	  @Override
	  protected boolean isRouteDisplayed() {
		  // TODO Auto-generated method stub
		  return false;
	  }



	  @Override
	  public void onLocationChanged(Location location) {

		  this.userLocationOverlay.setLocation(location); 


		  List<Recommendation> l = new ArrayList<Recommendation>();

		  if(!hasReviedRecs)
			  l = this.agent.checkForRecommendaions(location);


		  //List<Recommendation> l = new ArrayList();
		  Citynode rec = null;

		  if(lookForImplic)
			  rec = this.agent.checkForNewPlacesToRate(location); 


		  List <Recommendation> toAdd = new ArrayList<Recommendation>(); 

		  if(l!=null && l.size()>0)
		  {
			  for(Recommendation rr : l)
			  {
				  if(!this.proActiveRecs.containsKey(rr.getNode().getId()))
				  {
					  toAdd.add(rr);
					  this.proActiveRecs.put(rr.getNode().getId(),1);
				  }
			  }
		  }


		  Log.v("dette er sorelse paa lista",String.valueOf(l.size()));
		  if(toAdd.size()>0)
		  {
			  //((Vibrator)getSystemService(Context.VIBRATOR_SERVICE)).vibrate(1000);
			  hasReviedRecs = true;
			  showDialog(4); 
			  if(this.citynodes==null)
				  citynodes = toAdd;
			  else 
			  {
				  citynodes.addAll(toAdd);
			  }
			  handleResult(true);

		  }
		  if(rec!=null && !this.implicitRatings.containsValue(rec.getId())) 
		  {
			  this.numberOfpending++;
			  //newItemToRate = rec; 
			  //		((Vibrator)getSystemService(Context.VIBRATOR_SERVICE)).vibrate(1000);
			  //showDialog(5);
			  this.pendingView.setAnimation(AnimationUtils.loadAnimation( this, R.anim.magnify ));
			  this.pendingView.setText(this.pendingView.getText()+"("+1+")");
			  if(this.pendingRatings!=null)
				  pendingRatings.add(rec); 
			  else 
			  {
				  this.pendingRatings = new ArrayList<Citynode>(); 
				  this.pendingRatings.add(rec);
			  }

			  lookForImplic  = false; 
			  this.implicitRatings.put(rec.getId(),1); 
		  }






		  this.mapView.invalidate(); 	

	  }



	  @Override
	  public void onProviderDisabled(String provider) {
		  // TODO Auto-generated method stub

	  }



	  @Override
	  public void onProviderEnabled(String provider) {
		  // TODO Auto-generated method stub

	  }



	  @Override
	  public void onStatusChanged(String provider, int status, Bundle extras) {
		  // TODO Auto-generated method stub

	  }


	  protected synchronized MapView getMapView()
	  {
		  return this.mapView; 
	  }


	  private Drawable ImageOperations(Context ctx, String url, String saveFilename) {
		  try {
			  InputStream is = (InputStream) this.fetch(url);
			  Drawable d = Drawable.createFromStream(is, "src");
			  return d;
		  } catch (MalformedURLException e) {
			  e.printStackTrace();
			  return null;
		  } catch (IOException e) {
			  e.printStackTrace();
			  return null;
		  }
	  }

	  private Object fetch(String address) throws MalformedURLException,IOException {
		  URL url = new URL(address);
		  Object content = url.getContent();
		  return content;
	  }



	  @Override
	  public boolean onTouch(View v, MotionEvent event) {


		  if (event.getAction() == 1 && (event.getEventTime()-event.getDownTime())>1000) {

			  /*
		    	Citynode rec = this.agent.checkForNewPlacesToRate(this.userLocationOverlay.getLocation()); 
		    	if(rec!=null)
				{
		    		this.numberOfpending++;
					//newItemToRate = rec; 

					//showDialog(5);
					this.pendingView.setAnimation(AnimationUtils.loadAnimation( this, R.anim.magnify ));
					this.pendingView.setText(this.pendingView.getText()+"("+this.numberOfpending+")");
					if(this.pendingRatings!=null)
						pendingRatings.add(rec); 
					else 
					{
						this.pendingRatings = new ArrayList<Citynode>(); 
						this.pendingRatings.add(rec);
					}*/
//			  this.onLocationChanged(this.lmanager.getLastKnownLocation(LocationManager.GPS_PROVIDER));
		  }



		  System.out.println("inn her");
		  if(v.equals(this.quite))
		  {
			  this.noteBaloon.setVisibility(View.GONE);

		  }
		  else if(v.equals(mapView))
		  {

			  GeoPoint bottomLeft = mapView.getProjection().fromPixels(
					  0,0);

			  GeoPoint bottomRight =  mapView.getProjection().fromPixels(
					  this.mapView.getWidth(),0);

			  double distance = Math.floor(distance(((double)bottomLeft.getLatitudeE6()/1E6), ((double)bottomLeft.getLongitudeE6()/1E6), ((double)bottomRight.getLatitudeE6()/1E6), ((double)bottomRight.getLongitudeE6()/1E6), 'M')); 

			  if(distance==0)
				  this.mapwidth.setText("Map width: less than 1 km"); 
			  else
				  this.mapwidth.setText("Map width:" + distance + "km");
		  }



		  return false;
	  }



	  @Override
	  public void onClick(DialogInterface arg0, int arg1) {

		  System.out.println("kommer inn her");
		  System.out.println(arg1);

		  if(arg1 == -1)
		  {
			  System.out.println(("rating:" + MapClient.this.ratingBar.getRating()/5));
			  boolean sucess = this.agent.giveExplicitFeedback( MapClient.this.newItemToRate, (MapClient.this.ratingBar.getRating()/5));
			  if(sucess)
			  {
				  MapClient.this.showDialog(2);
			  }
			  else 
			  {
				  MapClient.this.showDialog(3);
			  }
		  }

	  }


	  private double distance(double lat1, double lon1, double lat2, double lon2, char unit) {
		  double theta = lon1 - lon2;
		  double dist = Math.sin(deg2rad(lat1)) * Math.sin(deg2rad(lat2)) + Math.cos(deg2rad(lat1)) * Math.cos(deg2rad(lat2)) * Math.cos(deg2rad(theta));
		  dist = Math.acos(dist);
		  dist = rad2deg(dist);
		  dist = dist * 60 * 1.1515;
		  dist = dist * 1.609344;

		  return (dist);
	  }

	  /*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
	  /*::  This function converts decimal degrees to radians             :*/
	  /*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
	  private double deg2rad(double deg) {
		  return (deg * Math.PI / 180.0);
	  }

	  /*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
	  /*::  This function converts radians to decimal degrees             :*/
	  /*:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
	  private double rad2deg(double rad) {
		  return (rad * 180.0 / Math.PI);
	  }










}