package ntnu.client;

import java.io.IOException;
import java.io.InputStream;
import java.io.Serializable;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.zip.Inflater;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapView;

import ntnu.agent.RecommenderAgent;
import ntnu.client.R.id;
import ntnu.model.Attribute;
import ntnu.model.Citynode;
import ntnu.model.Nodeholder;
import ntnu.model.Preference;
import ntnu.model.Rating;
import ntnu.model.Recommendation;
import ntnu.model.SerializableCitynode;
import ntnu.model.SerializableRecommendation;
import ntnu.model.User;
import ntnu.model.UserModel;
import ntnu.ui.GraphView;
import ntnu.ui.Smiley;
import ntnu.util.ColorChangeUtil;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.DialogInterface.OnClickListener;
import android.graphics.Color;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnTouchListener;
import android.view.ViewGroup.LayoutParams;
import android.widget.Button;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RatingBar;
import android.widget.ScrollView;
import android.widget.SeekBar;
import android.widget.TabHost;
import android.widget.TextView;

public class PendingRatings extends Activity implements android.view.View.OnClickListener, OnTouchListener, OnClickListener
{
	
	
	
	private ViewGroup infoPanel; 
	
	
	private TextView travelPlanView; 
	
	private TextView searchView; 
	
	
	private LinearLayout adjustPanel; 

	private List<SerializableCitynode> citynodes;  
	
	private LayoutInflater inflater;
	
	private RecommenderAgent agent;
	

	
	private String title; 
		
	
	
	  
	private LinearLayout ratingView; 
	
	
	private List <LinearLayout> ratingsLayouts;
	
	public RecommenderAgent getAgent() {
		return agent;
	}

	public void setAgent(RecommenderAgent agent) {
		this.agent = agent;
	}

	@Override
	protected void onCreate(Bundle savedInstanceState) 
	{
		  super.onCreate(savedInstanceState);
		  setContentView(R.layout.pending);
		  
		  
		  this.inflater = this.getLayoutInflater(); 
	
		
		Bundle b = getIntent().getExtras();

		Nodeholder n = (Nodeholder) b.get("citynodes");
		 citynodes = n.getNodes();
	
		  this.ratingView = (LinearLayout) inflater.inflate( R.layout.ratingdialog, null);
		
		
	
		  this.inflater = getLayoutInflater();

		 this.searchView = (TextView)findViewById(R.id.info); 
		 this.searchView.setOnClickListener(this);
		
		
	
		 
		//agent = (RecommenderAgent) b.get("agent");
		 

		
		 this.travelPlanView = (TextView)findViewById(R.id.custom); 
		    
		    this.travelPlanView.setOnClickListener(this); 
		    
		    createPendingEntries();
		    
		    
	}

	

	
	public void createPendingEntries()
	{
		if(citynodes!=null)
		{
			for(SerializableCitynode node : citynodes)
			{
				
				LinearLayout l = (LinearLayout) inflater.inflate(R.layout.pendingentry, null);
				
				((TextView) l.findViewById(R.id.title)).setText("Did you visit "+node.getTitle()+"?"); 
				((ViewGroup) this.findViewById(R.id.pendingentry)).addView(l);
				((Button) this.findViewById(R.id.rate)).setOnClickListener(this);
				this.title = node.getTitle();
			}
		}
	}
	
	

	
	

	
	


	@Override
	public void onClick(View v) {
		
			
		if(v.equals(this.travelPlanView))
		{ 
			
			Intent intent = new Intent(this, TravelPlanView.class);
			Bundle b = new Bundle();

			//b.putSerializable("agent",this.agent); 
			//b.putSerializable("usermode",this.userModel); 
			//b.putSerializable("recommendation", this.selectedRecommendation.getSerializableRecommendation()); 
			//b.putSerializable("usermodel", this.userModel); 

			intent.putExtras(b);
			
			
			startActivity(intent);
			finish();
		
			
		}
		if(v.equals(this.searchView))
		{ 
				finish();
				
		}
		if(v instanceof Button)
		{
			showDialog(0);
		}
	}

	protected Dialog onCreateDialog(int i)
	{
		if(i==0)
		{ 
			System.out.println("kommer hit");
			System.out.println("lager ny");
			AlertDialog.Builder builder = new AlertDialog.Builder(this);
			builder.setView(this.ratingView);
			
			builder.setMessage("Rate "+ this.title)
			       .setCancelable(false)
			       .setPositiveButton("Rate", this)
			      
			       .setNegativeButton("Canel", new DialogInterface.OnClickListener() {
			           public void onClick(DialogInterface dialog, int id) {
			                dialog.cancel();
			           }
			       });
			
			return  builder.create();
		}
	
		return null;
	}

	@Override
	public boolean onTouch(View arg0, MotionEvent arg1) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public void onClick(DialogInterface dialog, int which) {
	
		finish();
		
		
	}

	
}
