package ntnu.client;

import java.io.IOException;
import java.io.InputStream;
import java.io.Serializable;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.zip.Inflater;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapView;

import ntnu.agent.RecommenderAgent;
import ntnu.client.R.id;
import ntnu.model.Attribute;
import ntnu.model.Citynode;
import ntnu.model.Preference;
import ntnu.model.Rating;
import ntnu.model.Recommendation;
import ntnu.model.SerializableCitynode;
import ntnu.model.SerializableRecommendation;
import ntnu.model.User;
import ntnu.model.UserModel;
import ntnu.ui.GraphView;
import ntnu.ui.Smiley;
import ntnu.util.ColorChangeUtil;
import android.app.Activity;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.DialogInterface.OnClickListener;
import android.graphics.Color;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnTouchListener;
import android.view.ViewGroup.LayoutParams;
import android.widget.Button;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RatingBar;
import android.widget.ScrollView;
import android.widget.SeekBar;
import android.widget.TabHost;
import android.widget.TextView;

public class RecommendationDetial extends Activity implements android.view.View.OnClickListener, OnTouchListener
{
	
	
	
	private ViewGroup infoPanel; 
	
	
	
	private LinearLayout adjustPanel; 

	private SerializableRecommendation recommendation;  
	
	private UserModel usermodel; 
	
	private TextView adjustText;
	
	private TextView infoText;
	
	private Button lessInfo; 
	
	private Drawable image;
	
	private View currentView; 
	
	private LayoutInflater inflater;
	
	private GraphView graphView; 
	
	private int numberOfRaters; 
	
	private Rating selected; 
	
	private TextView userName; 
	
	private TextView explantion; 
	
	private ImageView icon; 
	
	private LinearLayout ratings;
	
	private RecommenderAgent agent;
	
	private GeoPoint location;
	
	private Button exploreButton;
	
	
	private HashMap <LinearLayout,Rating> ratingMap = new HashMap<LinearLayout,Rating>(); 
	
	
	
	
	private List <LinearLayout> ratingsLayouts;
	
	public RecommenderAgent getAgent() {
		return agent;
	}

	public void setAgent(RecommenderAgent agent) {
		this.agent = agent;
	}

	@Override
	protected void onCreate(Bundle savedInstanceState) 
	{

		
	
		
		Bundle b = getIntent().getExtras();

		 recommendation = (SerializableRecommendation) b.get("recommendation");
		usermodel  = (UserModel)b.get("usermodel"); 
		
		 setContentView(R.layout.info);
		
		 this.inflater = getLayoutInflater();

		
		 this.lessInfo = (Button) this.findViewById(R.id.less_infobutton); 
		 
		 lessInfo.setOnClickListener(this); 
		
		 createInfoPanel(); 
		 
		agent = (RecommenderAgent) b.get("agent");
		 
		super.onCreate(savedInstanceState);
	
		double longitude = b.getDouble("longitude");
		double latitude = b.getDouble("latitude");
		
		this.location = new GeoPoint(  (int) ( latitude * 1E6),(int) ( longitude * 1E6));
		
		
	}

	private Drawable ImageOperations(Context ctx, String url, String saveFilename) {
		try {
			InputStream is = (InputStream) this.fetch(url);
			Drawable d = Drawable.createFromStream(is, "src");
			return d;
		} catch (MalformedURLException e) {
			e.printStackTrace();
			return null;
		} catch (IOException e) {
			e.printStackTrace();
			return null;
		}
	}

	private Object fetch(String address) throws MalformedURLException,IOException {
		URL url = new URL(address);
		Object content = url.getContent();
		return content;
	}

/*
	public void createAdjustPanel()
	{
		this.adjustPanel = (LinearLayout) inflater.inflate( R.layout.adjust, null);
	    LinearLayout.LayoutParams l3 =new LinearLayout.LayoutParams(
                LayoutParams.WRAP_CONTENT, 
                LayoutParams.FILL_PARENT);
	    adjustText.setLayoutParams(l3); 
	    
	    ((LinearLayout)this.findViewById(R.id.dummy)).removeAllViews();
	    ((LinearLayout)this.findViewById(R.id.dummy)).addView(this.adjustPanel);
	    
	    //TextView tittle = (TextView)this.findViewById(R.id.titletext);
		 //tittle.setText(this.recommendation.getNode().getTitle().trim()); 
		 
	    LinearLayout container = (LinearLayout) this.findViewById(R.id.container);
	    container.removeAllViews(); 
	    
	    SerializableCitynode citynode = this.recommendation.getNode(); 
	    //TextView tag = (TextView)this.findViewById(R.id.ratingtag);
		//tag.setBackgroundColor(ColorChangeUtil.rateColor((int)(Integer.valueOf(this.recommendation.getSystemRating()))));
	   
	     int counter = 0; 
	     
	     this.exploreButton = (Button) this.adjustPanel.findViewById(R.id.explore);
	     this.exploreButton.setOnClickListener(this); 
	     this.exploreButton.setVisibility(View.GONE); 
	     
	     
	     List <Rating> raters = this.recommendation.getSelectedRatigns(); 
	     
	     numberOfRaters = raters.size(); 
	     
	     this.ratings = (LinearLayout)this.findViewById(R.id.container3);
	     
	     
	     if(numberOfRaters>0)
	     {
	    
	         ((TextView) this.adjustPanel.findViewById(R.id.widget31)).setText("The graph show the ratings of users similar to you. Clik on a bar to learn more");  
	    	 
	     float[] values = new float[numberOfRaters ] ;
	     String[] verlabels = new String[] { "High", "", "Low"};
			
		 String[] horlabels = new String[numberOfRaters ];
		 

		
		 
		 for(int i=0;i<numberOfRaters;i++)
		 {
			 values[i] = ((float)raters.get(i).getRating());
			 horlabels[i] = "User "+(i+1); 
		 }
		 
			graphView = new GraphView(this, values, "Ratings",horlabels, verlabels, GraphView.BAR);

			
			graphView.setOnTouchListener(this); 
			container.addView(graphView); 
	     
			
			this.userName = (TextView)this.adjustPanel.findViewById(R.id.userid); 
		
	 
		
			this.userName.setText(""); 
		
	     }
	    
	    
	}
	
	*/

	
	
	
	public void createInfoPanel()
	{ 
		
		 this.ratings = (LinearLayout)this.findViewById(R.id.container3);
		System.out.println("selected " + this.recommendation.getSelectedRatigns());
		
		 setContentView(R.layout.info);
			
		 this.lessInfo = (Button) this.findViewById(R.id.less_infobutton); 
		 
		 lessInfo.setOnClickListener(this); 
		//LinearLayout tags =  (LinearLayout)this.findViewById(R.id.tags); 
		 LinearLayout properties = (LinearLayout)this.findViewById(R.id.properties); 
		 
		
		 properties.removeAllViews(); 
		 
		 //set title and prediction color 
		 TextView tittle = (TextView)this.findViewById(R.id.titletext);
		
		
		 tittle.setText(this.recommendation.getNode().getTitle().trim()); 
		 
		 //set image 
		 if(!this.recommendation.getNode().getPicutre().trim().equals(""))
		 {
			if(image==null)
			 	image = ImageOperations(this,recommendation.getNode().getPicutre(),"image.jpg");
			 
			 ImageView imgView = (ImageView)findViewById(R.id.image);
			// imgView.se
			 imgView.setImageDrawable(image);
			 
		 }
		 
		 
		 ((TextView)this.findViewById(R.id.description)).setText(this.recommendation.getNode().getDescription());
		
		 //set properties based on values that are 
		 
		 
		 
		 if(!this.recommendation.getDistance().trim().equals(""))
		 {
			 TextView distance = new TextView(this); 
			 distance.setTextColor(Color.BLACK); 
			 distance.setText("Distance: " +this.recommendation.getDistance()); 
			 properties.addView(distance); 
		 }
		 if(!this.recommendation.getNode().getPhoneNumber().trim().equals(""))
		 {
			 TextView getPhoneNumber = new TextView(this); 
			 getPhoneNumber.setTextColor(Color.BLACK); 
			 getPhoneNumber.setText("Phone number: " +this.recommendation.getNode().getPhoneNumber()); 
			 properties.addView(getPhoneNumber); 
		 }
		 if(!this.recommendation.getNode().getAdresse().trim().equals(""))
		 {
			 TextView adresse = new TextView(this); 
			 adresse.setTextColor(Color.BLACK); 
			 adresse.setText("Adresse: " +this.recommendation.getNode().getAdresse()); 
			 properties.addView(adresse); 
		 }
		 if(this.recommendation.isPersonalized())
		 {
			 ((TextView)findViewById(R.id.explantion)).setText( this.recommendation.getTextualExplanation());
		 }
		 else 
		 { 
			 ((RatingBar)findViewById(R.id.bar)).setVisibility(View.GONE);
			 ((TextView)findViewById(R.id. custom)).setVisibility(View.GONE);
		 }
		
			 
		 if(!this.recommendation.getNode().getOpeningHours().trim().equals(""))
		 {
			 TextView adresse = new TextView(this); 
			 adresse.setTextColor(Color.BLACK); 
			 adresse.setText("Opening hours: " +this.recommendation.getNode().getOpeningHours()); 
			 properties.addView(adresse); 
		 }
	
		// this.ratings.invalidate();
		 
			//this.adjustText =  ((TextView)this.findViewById(R.id.custom));adjustText.setOnClickListener(this); 
			//this.infoText =  ((TextView)this.findViewById(R.id.info));infoText.setOnClickListener(this); 
		 
			 if(this.recommendation.getSelectedRatigns()!=null && this.recommendation.getSelectedRatigns().size()>0)
			 {
				 	//this.ratings.removeAllViews(); 
					
				 	TextView info = new TextView(this); 
				 	info.setTextColor(Color.BLACK); 
				 	info.setText("Users who liked this place, also liked the following places in your current area(click on a title to get more information) "); 
				 	
				 	((ViewGroup) this.findViewById(R.id.dummy)).addView(info);
					List <Rating> ratingsSorteted = this.recommendation.getSelectedRatigns();
					
					Collections.sort(ratingsSorteted); 
					
					
					Collections.reverse(ratingsSorteted); 
					
					int number = ratingsSorteted.size()>6?6:ratingsSorteted.size();
					
					for(int i=0;i<number;i++)
					{
						
						
						
						Rating ratingFromUser =  ratingsSorteted.get(i); 
						
						
						
						
						
						LinearLayout l = (LinearLayout) inflater.inflate(R.layout.ratingbar, null);
						l.setOnTouchListener(this); 
						RatingBar rating =(RatingBar) l.findViewById(R.id.small_ratingbar);
						
						TextView view = (TextView)l.findViewById(R.id.title);
						view.setText(ratingFromUser.getTitle().trim());
						
						rating.setNumStars(5);
						rating.setIsIndicator(true); 
						rating.setRating(((float) ratingFromUser.getRating())*5); 
						
						//TextView t = new TextView(this); 
						//t.setText(ratingFromUser.getTitle()); 
						
						this.ratingMap.put(l,ratingFromUser); 
						
						l.setOnClickListener(this);
						
						
					
						((ViewGroup) this.findViewById(R.id.dummy)).addView(l);
					//	properties.addView(l);
						//ratingsLayouts.add(l); 
					}
					
					
					
					
			 }	
			
			
		 //generate explanation tags based on matching attributes 
		 SerializableCitynode citynode = this.recommendation.getNode(); 

	
		 this.infoPanel = ((LinearLayout) this.findViewById(R.id.dummy)); 
	}
	
	
	
	


	@Override
	public void onClick(View v) {
		
			
		if(v.equals(this.adjustText))
		{ 
		
		    
		   
				    
		    this.adjustText.setBackgroundColor(Color.WHITE); 
		    this.adjustText.setTextColor(Color.BLACK); 
		    this.infoText.setBackgroundColor(Color.BLUE); 
		    this.infoText.setTextColor(Color.WHITE); 
		    
		 
		   // createAdjustPanel();
		    
		}
		else if(v.equals(this.infoText))
		{ 
		
			 
		
			  this.adjustText.setBackgroundColor(Color.BLUE); 
			    this.adjustText.setTextColor(Color.WHITE); 
			    this.infoText.setBackgroundColor(Color.WHITE); 
			    this.infoText.setTextColor(Color.BLACK); 
			   
			createInfoPanel(); 
		}
		
		else if(v.equals(this.lessInfo))
		{ 
			this.finish(); 
		
			
			
		}
		else if(v instanceof LinearLayout)
		{
			if(this.ratingMap.containsKey(v))
			{
				Intent intent = new Intent(this, MapView.class);
				Bundle b = new Bundle();
				
				b.putInt("citynodeid", (int)this.ratingMap.get(v).getCitynodeId());
				 
				intent.putExtras(b);
				
				 this.setResult(Activity.RESULT_OK,intent);
				 
				 

				this.finish(); 
			}
		}
		
		else if(v.equals(this.exploreButton))
		{
			Intent intent = new Intent(this, MapView.class);
			Bundle b = new Bundle();
			
			b.putInt("userid", (int)this.selected.getUserid());
			 
			intent.putExtras(b);
			
			 this.setResult(Activity.RESULT_OK,intent);
			 
			 

			this.finish(); 
		}
		
		else { 
		
			this.finish(); 
		}
	}

	@Override
	public boolean onTouch(View v, MotionEvent event) {
		
		
		
		if(v.equals(this.graphView))
		{
			 this.exploreButton.setVisibility(View.VISIBLE); 
			int sizeOfOneBar = graphView.getWidth()/numberOfRaters; 
			int barNumber = (int)event.getX()/sizeOfOneBar;
			
			System.out.println(barNumber);
			
			Rating r = this.recommendation.getSelectedRatigns().get(barNumber);
			
			this.userName.setVisibility(View.VISIBLE); 
			this.userName.setText("User "+(String.valueOf(barNumber+1))+ "s ratings in your area."); 
	
			this.graphView.setSelected(barNumber);
			this.graphView.invalidate();
			this.selected = r; 

			System.out.println("user id:" + selected.getUserid());
			
			User u = agent.findUser(location, selected.getUserid()); 
			
			this.ratings.removeAllViews(); 
			
			
			List <Rating> ratingsSorteted = u.getRatings();
			
			Collections.sort(ratingsSorteted); 
			
			Collections.reverse(ratingsSorteted); 
			
			int number = ratingsSorteted.size()>6?6:ratingsSorteted.size();
			
			
			if(true)
			{
				
				ratingsLayouts = new ArrayList<LinearLayout>();
				
				for(int i=0;i<number;i++)
				{
					
					
					Rating ratingFromUser =  ratingsSorteted.get(i); 
					
					
					LinearLayout l = (LinearLayout) inflater.inflate(R.layout.ratingbar, null);
					l.setOnTouchListener(this); 
					RatingBar rating =(RatingBar) l.findViewById(R.id.small_ratingbar);
					
					TextView view = (TextView)l.findViewById(R.id.title);
					view.setText(ratingFromUser.getTitle().trim());
					
					rating.setNumStars(5);
					rating.setIsIndicator(true); 
					rating.setRating(((float) ratingFromUser.getRating())*5); 
					
					//TextView t = new TextView(this); 
					//t.setText(ratingFromUser.getTitle()); 
					
				
					
					
				
					//ll.addView(t); 
					this.ratings.addView(l);
					ratingsLayouts.add(l); 
				}
			
			}
			else 
			{ 
				for(int i=0;i<number;i++)
				{
					
					
					Rating ratingFromUser =  ratingsSorteted.get(i); 
					
				
						LinearLayout l = ratingsLayouts.get(i);
						
						RatingBar rating =(RatingBar) l.findViewById(R.id.small_ratingbar);
						
						TextView view = (TextView)l.findViewById(R.id.title);
						view.setText(ratingFromUser.getTitle().trim());
						
						rating.setNumStars(5);
						rating.setIsIndicator(true); 
						rating.setRating(((float) ratingFromUser.getRating())*5); 
						
						//TextView t = new TextView(this); 
						//t.setText(ratingFromUser.getTitle()); 
						
					//	Button b = new Button(this); 
						
						//b.setText("View in map"); 
						
						
					
						//ll.addView(t); 
						//ll.addView(b);
						l.removeAllViews();
						
						this.ratings.removeAllViews();
						this.ratings.addView(l);
					//ratingsLayouts.add(l); 
				}
			}
		
			
			
			  
			  
			  
			
		}
		else {
			
			
		}
		
		return false;
	}
	
	
}
