package ntnu.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;


public class Recommendation implements Serializable {

	private String id; 

	private String userRating; 
	
	private String systemRating; 
	
	private Citynode node; 
	
	private String textualExplanation;
	
	private String distance; 
	
	private int rateChange;
	
	private List <Rating> selectedRatings; 
	
	boolean isPersonalized;
	
	boolean isProactive; 
	
	public boolean isProactive() {
		return isProactive;
	}


	public void setProactive(boolean isProactive) {
		this.isProactive = isProactive;
	}


	public boolean isPersonalized() {
		return isPersonalized;
	}


	public void setPersonalized(boolean isPersonalized) {
		this.isPersonalized = isPersonalized;
	}


	public List<Rating> getSelectedRatings() {
		return selectedRatings;
	}


	public void setSelectedRatings(List<Rating> selectedRatings) {
		this.selectedRatings = selectedRatings;
	}

	private boolean inTravelPlan; 
	

	public String getTextualExplanation() {
		return textualExplanation;
	}


	public void setTextualExplanation(String textualExplanation) {
		this.textualExplanation = textualExplanation;
	}


	public Recommendation() 
	{ 
		
	}


	public String getId() {
		return id;
	}


	public void setId(String id) {
		this.id = id;
	}


	public String getUserRating() {
		return userRating;
	}


	public void setUserRating(String userRating) {
		this.userRating = userRating;
	}


	public String getSystemRating() {
		return systemRating;
	}


	public void setSystemRating(String systemRating) {
		this.systemRating = systemRating;
	}


	public Citynode getNode() {
		return node;
	}


	public void setNode(Citynode node) {
		this.node = node;
	}
	
	public int getRateChange() {
		return rateChange;
	}


	public void setRateChange(int rateChange) {
		this.rateChange = rateChange;
	}


	public String getDistance() {
		return distance;
	}


	public void setDistance(String distance) {
		this.distance = distance;
	}
	
	
	

	
	public boolean isInTravelPlan() {
		return inTravelPlan;
	}


	public void setInTravelPlan(boolean inTravelPlan) {
		this.inTravelPlan = inTravelPlan;
	}


	public SerializableRecommendation getSerializableRecommendation()
	{
		SerializableRecommendation rec = new SerializableRecommendation();
		rec.setDistance(this.getDistance()); 
		rec.setNode(this.node.getSerializableCitynode()); 
		rec.setRateChange(this.getRateChange()); 
		rec.setSystemRating(this.systemRating); 
		rec.setTextualExplanation(this.getTextualExplanation());
		rec.setUserRating(this.getUserRating()); 
		rec.setSelectedRatigns(this.getSelectedRatings()); 
		rec.setPersonalized(this.isPersonalized);
		
		return rec;
		
	}

	public static Recommendation fromXml(Element node)
	{ 
		Recommendation newRec = new Recommendation(); 
		
		newRec.setId(node.getAttribute("id")); 
		newRec.setSystemRating(node.getAttribute("systemrating")); 
		newRec.setTextualExplanation(node.getAttribute("textualdescription")); 
		newRec.setUserRating(node.getAttribute("userrating")); 
		newRec.setRateChange(Integer.valueOf(node.getAttribute("ratechange"))); 
		newRec.setDistance(node.getAttribute("distance"));
		newRec.setInTravelPlan(Integer.valueOf(node.getAttribute("istravelPlanRecommendation"))==1?true:false); 
		newRec.setNode(Citynode.fromXml((Element)node.getElementsByTagName("citynode").item(0))); 
		newRec.setPersonalized(Boolean.valueOf(node.getAttribute("ispersonalized")));
		newRec.setProactive(Integer.valueOf(node.getAttribute("isproactive"))==1);
		
		Element ats = (Element)node.getElementsByTagName("ratings").item(0);
		NodeList ratings = ats.getElementsByTagName("rating");
		
		ArrayList <Rating> selectedRatings = new ArrayList<Rating>(); 
		
		for(int i = 0;i<ratings.getLength();i++)
		{
			selectedRatings.add(Rating.fromXml((Element)ratings.item(i))); 
		}
		
		newRec.setSelectedRatings(selectedRatings);
		
		
		return newRec; 
	}
}
