package ntnu.ui;

import java.util.HashMap;

import ntnu.client.R;
import ntnu.model.Attribute;
import ntnu.model.Citynode;
import android.content.res.Resources;
import android.graphics.Bitmap;
import android.graphics.Color;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.util.Log;

public class IconManager {

	
	private HashMap<String,Integer> iconMap = new  HashMap<String,Integer>();
	
	private Resources resources;
	
	
	public IconManager (Resources resources)
	{
		this.resources = resources;
	}
	
	
	//find the icon that best illustrates the citynode
	//that is the icon that maps to the citynode attribute most specifically  
	public Drawable findIcon(Citynode n)
	{
		
	
		
		int bestDepth = -1; 
		Drawable bestIcon = null;
		/*
		for(Attribute a : n.getAttributes())
		{
			Log.v("icon", a.getType()); 
			Log.v("level",String.valueOf(a.getLevel())); 
			Log.v("bestlevel",String.valueOf(bestDepth)); 
			
			while (a!=null)
			{
				if(iconMap.containsKey(a.getType()) && a.getLevel()>bestDepth)
				{
					bestIcon = resources.getDrawable(iconMap.get(a.getType()));
					bestDepth = a.getLevel();
				}
				a = a.getParent();
				
			}
			
		}*/
		
		System.out.println(n.getType().trim());
		
					
			return resources.getDrawable(iconMap.get(n.getType().trim()));
		
		
	}
	
	public static Drawable changeBackground(Drawable d, int rating, boolean doColor)
	{ 	
		   int to; 
		   //TODO: Do something smarter 
		   Color c = new Color(); 
		   if(doColor)
		   {
			   if(rating>80)
				   to = c.argb(255, 0, 204, 51); 
			   else if(rating>70)
				   to = c.argb(255, 0, 204, 0); 
			   else if(rating>60)
				   to = c.argb(255, 153, 255, 0); 
			   else if(rating>50)
				   to =  c.argb(255, 255, 255, 0);
			   else if(rating>40)
				   to= c.argb(255, 255, 153, 0);
			   else if(rating>30)
				   to = c.argb(255, 255, 102, 0);
			   else
				   to = c.argb(255, 204, 0, 51);
				   
			
	
			    //Need to copy to ensure that the bitmap is mutable.
			    Bitmap src = ((BitmapDrawable) d).getBitmap();
			    Bitmap bitmap = src.copy(Bitmap.Config.ARGB_8888, true);
			    
			    //sample a pixel that should be the background color
			    int fromColor = bitmap.getPixel((int)bitmap.getWidth()/2, 5); 
			    
			  
			    for(int x = 0;x < bitmap.getWidth();x++)
			        for(int y = 0;y < bitmap.getHeight();y++)
			            if((bitmap.getPixel(x, y)==fromColor)) 
			                bitmap.setPixel(x, y, to);

			    return new BitmapDrawable(bitmap);
		   }
		   
		   return d;
	}
	

	
	public void fillHashMap() 
	{ 
		iconMap.put("fastfood",R.drawable.fastfood);
		iconMap.put("restaurantchinese", R.drawable.restaurantchinese);
		iconMap.put("bar", R.drawable.bar);
		iconMap.put("hotel", R.drawable.hotel);
		iconMap.put("museumhistorical",R.drawable.museumhistorical);
		iconMap.put("museumwar",R.drawable.museumhistorical);
		iconMap.put("restaurant", R.drawable.restaurant);
		iconMap.put("restaurantmexican", R.drawable.restaurantmexican);
		iconMap.put("restaurantitalian", R.drawable.restaurantitalian);
		iconMap.put("pizza", R.drawable.pizza);
		iconMap.put("theater", R.drawable.theater);
		iconMap.put("runis", R.drawable.ruins);
		iconMap.put("cathedral",R.drawable.cathedral);
		iconMap.put("cinema",R.drawable.cinema);
		iconMap.put("cafe",R.drawable.cafe);
		iconMap.put("barbeque",R.drawable.barbeque);
		iconMap.put("university",R.drawable.university);
		iconMap.put("bar",R.drawable.bar);
		iconMap.put("sight",R.drawable.sight);
		
		
		
	}
	
	
	
	
}
