package ntnu.ui;

import java.util.ArrayList;
import java.util.List;

import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Point;
import android.util.Log;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;
import com.google.android.maps.Projection;

public class PathOverlay extends Overlay {

	List <GeoPoint> pathList; 
	
	public void setPathList(ArrayList<GeoPoint> pathList) 
	{
		this.pathList = pathList;
	}

	@Override
	public void draw(Canvas c, MapView mapView, boolean shadow)
	{ 
		Projection projection = mapView.getProjection();
		
		Paint p = new Paint();
		p.setColor(Color.GREEN);
		p.setStrokeWidth(5);
		p.setAlpha(120);
		
		for(int i = 0;i<pathList.size();i++)
		{ 
			
			
			GeoPoint gp1; 
			GeoPoint gp2;
			
			if(i+1<pathList.size())
			{
				gp1 = pathList.get(i); 
				gp2 = pathList.get(i+1); 
			}
			else 
			{ 
				gp1 = pathList.get(i); 
				gp2 = pathList.get(i); 
			}
				
			Point point1 = new Point();
			projection.toPixels(gp1, point1);
			
			Point point2 = new Point();
			projection.toPixels(gp2, point2);
			
			c.drawLine(point1.x, point1.y, point2.x,point2.y, p);
			
		}
		
		
	}


}
