package ntnu.client;

import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.ConcurrentModificationException;
import java.util.List;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.FactoryConfigurationError;
import javax.xml.parsers.ParserConfigurationException;

import ntnu.agent.RecommenderAgent;
import ntnu.model.Recommendation;
import ntnu.model.SerializableRecommendation;
import ntnu.model.UserModel;
import ntnu.ui.BaloonLayout;
import ntnu.ui.CitynodeItemizedOverlay;
import ntnu.ui.CitynodeOverlayItem;
import ntnu.ui.IconManager;
import ntnu.ui.PathOverlay;
import ntnu.ui.RecommendationNotificationOverlay;
import ntnu.ui.Smiley;
import ntnu.ui.UserLocationOverlay;
import ntnu.util.RoutePathUtil;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.ItemizedOverlay;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.graphics.drawable.Drawable;
import android.graphics.drawable.ShapeDrawable;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.os.Vibrator;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnTouchListener;
import android.view.ViewGroup.LayoutParams;
import android.view.animation.AnimationUtils;
import android.widget.AbsoluteLayout;
import android.widget.Button;
import android.widget.EditText;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RatingBar;
import android.widget.RelativeLayout;
import android.widget.TextView;

public class TravelPlanView extends MapActivity implements ItemObserver, OnClickListener,  LocationListener ,OnTouchListener, DialogInterface.OnClickListener {


	   private LocationManager lmanager;  
	   
	   /*
	    * UI - elements 
	    */
		
	   private TextView hideSearch;
	
	   private MapView mapView; 
	   
	   private EditText search;
	   
	   private TextView textexp; 
	   
	   private TextView texteat; 
	   
	   private TextView textsleep;
	   
	   private Button searchbutton;
	   
	   private AbsoluteLayout layout; 
	   
	   private LinearLayout llayout; 
	   
	   private BaloonLayout noteBaloon; 
	   
	   private LinearLayout detailtedInformation; 
	   
	   private Button moreInfoButton; 
	   
	   private RatingBar ratingbar;
	   
	   private Button fromhere;
	   
	   private Button tohere;
	   
	   
	   private ImageView quite; 
	   
	   private Button rate; 
	   
	   
	   
	   private BaloonLayout popupLayout; 
	   

	   private Button addtoplan; 
	   
	   private TextView searchView; 
	   
	   
	   private Button removeplan; 
	   
	   private Button getnewplan;
	   
	   private RatingBar ratingBar;
	   
	   private LinearLayout ratingView; 
	   
	   
	   private TextView  pendingView;
	   
	   /////
	   
	   /*
	    * Overlays 
	    */
	   
	   //used for drawing citynodes on top of the map
	   private CitynodeItemizedOverlay itemizedoverlay; 
	   
	   private UserLocationOverlay userLocationOverlay; 
	   
	   private UserModel userModel; 
	   

	   /*
	    * Various shit 
	    */
	   	
	   private  List<Overlay> mapOverlays; 
	   
	   
	   private List<Recommendation> travelplan; 
	   
	   
	   private RecommenderAgent agent; 
	   
	   private IconManager iconmanager;
	   
	   private MapController mapController;
	   
	   private Vibrator vibrator; 
	   
	   private LayoutInflater inflater; 
	   
	   
	   /*
	    * state variables 
	    */
	   
	   private TextView pressed; 
	   

	   private Recommendation selectedRecommendation;
	   
	   private boolean isDetailedInfo = true; 
	   
	   
	   public void onCreate(Bundle savedInstanceState)
	    {
	       super.onCreate(savedInstanceState);
	       
	       this.lmanager = (LocationManager)getSystemService(Context.LOCATION_SERVICE);
	      
	       this.iconmanager = new IconManager(this.getResources());
	       this.iconmanager.fillHashMap();
	       //init the recommender agent: 
	       
	        URL url = null;
	    	Bundle b = getIntent().getExtras();
			agent = (RecommenderAgent) b.get("agent");
		    this.userModel =(UserModel) b.get("usermodel");
				
		  lmanager.requestLocationUpdates(LocationManager.GPS_PROVIDER,0,20, this); 
	
	       
		   /*
		    * UI set up
		    */
		   setContentView(R.layout.travelplan);
	        
	        mapView = (MapView) findViewById(R.id.mapView);
	        
	        mapController = this.mapView.getController();
	   
	        LinearLayout zoomLayout = (LinearLayout)findViewById(R.id.zoom);  
	        View zoomView = getMapView().getZoomControls(); 
	 
	        zoomLayout.addView(zoomView, 
	            new LinearLayout.LayoutParams(
	                LayoutParams.WRAP_CONTENT, 
	                LayoutParams.WRAP_CONTENT)); 
	        mapView.displayZoomControls(true);
	        
	       
	        this.userLocationOverlay = new UserLocationOverlay(this.lmanager.getLastKnownLocation(LocationManager.GPS_PROVIDER), BitmapFactory.decodeResource(
	                getResources(), R.drawable.gps),mapView); 
	        getMapView().getOverlays().add(this.userLocationOverlay); 

	        this.inflater = getLayoutInflater();
	        
	
		      
		       
		    this.noteBaloon = (BaloonLayout) inflater.inflate( R.layout.baloonlayout, null);
		    RelativeLayout.LayoutParams layoutParams   = new RelativeLayout.LayoutParams(200,100);
		    layoutParams.addRule(RelativeLayout.CENTER_VERTICAL);
		    layoutParams.addRule(RelativeLayout.CENTER_HORIZONTAL);
		    noteBaloon.setLayoutParams(layoutParams);   
		    
		    this.ratingbar = (RatingBar)noteBaloon.findViewById(R.id.bar); 
		    this.addtoplan = (Button)noteBaloon.findViewById(R.id.addtoplan); 
		    addtoplan.setOnClickListener(this); 
		    this.ratingbar = (RatingBar)noteBaloon.findViewById(R.id.bar); 
		    // this.likeIcon = (ImageView)noteBaloon.findViewById(R.id.like); 
		    //this.likeText = (TextView)noteBaloon.findViewById(R.id.liketext); 
		    
		    //this.dislikeIcon = (ImageView)noteBaloon.findViewById(R.id.dislike); 
		    //this.dislikeText = (TextView)noteBaloon.findViewById(R.id.disliketext);
		    
		  //  this.likeIcon.setOnClickListener(this); 
		   // this.likeText.setOnClickListener(this); 
		    //this.dislikeIcon.setOnClickListener(this); 
		    //this.dislikeText.setOnClickListener(this); 
		    
	//	    this.detailtedInformation = (LinearLayout) inflater.inflate( R.layout.moreinfosplash, null);
		    this.detailtedInformation = (LinearLayout) inflater.inflate( R.layout.info, null);
		    LinearLayout.LayoutParams l3 =new LinearLayout.LayoutParams(
	                LayoutParams.WRAP_CONTENT, 
	                LayoutParams.FILL_PARENT);
		 
		    this.detailtedInformation.setLayoutParams(l3);
		    this.getWindow().addContentView(this.detailtedInformation,l3);
		    this.detailtedInformation.setVisibility(View.GONE);

		    
		    this.popupLayout = (BaloonLayout) this.inflater.inflate( R.layout.popup, null);
		    LinearLayout.LayoutParams l4 =new LinearLayout.LayoutParams(
	                LayoutParams.WRAP_CONTENT, 
	                LayoutParams.WRAP_CONTENT);
		    this.popupLayout.setLayoutParams(l4); 
		    
		    this.userLocationOverlay.setPopUp(popupLayout); 
		    
		    
		    this.fromhere = (Button)popupLayout.findViewById(R.id.fromherebutton); 
		    this.tohere = (Button)popupLayout.findViewById(R.id.toherebutton); 
		    
		    fromhere.setOnClickListener(this); 
		    this.tohere.setOnClickListener(this);
		    
		    this.pressed = this.texteat; 
		   
		   // this.vibrator = new Vibrator();
		    
		    getMapView().invalidate();
		    
	       
		    
		    this.mapView.setOnTouchListener(this);
		    
		    this.searchView = (TextView)findViewById(R.id.info); 
		    
		    this.searchView.setOnClickListener(this); 
		    
//		    this.travelplan = agent.checkForTravelPlan(this.userLocationOverlay.getLocation());
		    this.travelplan = agent.checkForTravelPlan(this.userLocationOverlay.getLocation());
		    
		    this.removeplan  = (Button)this.findViewById(R.id.removeplan); 
		    
		    this.getnewplan = (Button)this.findViewById(R.id.getnewplan); 
		    
		    removeplan.setOnClickListener(this); 
		    getnewplan.setOnClickListener(this); 
		    this.ratingView = (LinearLayout) inflater.inflate( R.layout.ratingdialog, null);
		    this.ratingBar = (RatingBar)ratingView.findViewById(R.id.bar);
		    
		    this.rate = (Button)noteBaloon.findViewById(R.id.rate); 
		    this.rate.setOnClickListener(this);
		    this.pendingView  = (TextView)findViewById(R.id.pending);
		    this.pendingView.setOnClickListener(this);
		    this.handleResult(false);
		    
		    
		    String coordinates[] = {
		    		"63.434566","10.398439"};
	        double lat = Double.parseDouble(coordinates[0]);
	        double lng = Double.parseDouble(coordinates[1]);
	 
	        GeoPoint p = new GeoPoint(
	            (int) (lat * 1E6), 
	            (int) (lng * 1E6));
		    
		   this.mapView.getController().animateTo(p); 
		   this.mapView.getController().setZoom(12);
		   
		   
		   this.quite = (ImageView)this.noteBaloon.findViewById(R.id.quite);
		   this.quite.setOnTouchListener(this);
		    
	    }
	   
	   public void itemChange(Object o) 
		{
			if(o instanceof CitynodeOverlayItem)
			{ 
				CitynodeOverlayItem node = (CitynodeOverlayItem)o;
			
				
	
				
				
				getMapView().removeView(noteBaloon);
				noteBaloon.setVisibility(View.VISIBLE);
				((TextView)noteBaloon.findViewById(R.id.note_label)).setText(((CitynodeOverlayItem) o).getNode().getNode().getTitle() + " (Distance:" + ((CitynodeOverlayItem) o).getNode().getDistance() +"m)");
				
				Log.v("hva er dette naa",((CitynodeOverlayItem) o).getNode().getNode().getTitle());
				
				((TextView)noteBaloon.findViewById(R.id.note_text)).setText(((CitynodeOverlayItem) o).getNode().getNode().getTag().trim());
				((TextView)noteBaloon.findViewById(R.id.note_explanation)).setText(((CitynodeOverlayItem) o).getNode().getTextualExplanation().trim());
				
				moreInfoButton = (Button)noteBaloon.findViewById(R.id.more_infobutton);
				moreInfoButton.setOnClickListener(this);
				mapController.animateTo(((CitynodeOverlayItem) o).getPoint()); 
				getMapView().addView(noteBaloon, new MapView.LayoutParams(240,290,((CitynodeOverlayItem) o).getPoint(),MapView.LayoutParams.BOTTOM_CENTER));
				this.selectedRecommendation = node.getNode();
				
				float ratting = (Integer.valueOf(((CitynodeOverlayItem) o).getNode().getSystemRating())/10)/2; 
				
				if(ratting!=0) 
				{
					this.ratingbar.setVisibility(View.VISIBLE);
					this.ratingbar.setRating(ratting);
				}
				else 
				{
					this.ratingbar.setVisibility(View.GONE); 
				}
				
				
		
				System.out.println("dette er rating:" + ratting);
				
				//this.ratingbar.setRating(ratting);
				
				this.addtoplan.setText(this.selectedRecommendation.isInTravelPlan()?"Remove from plan" : "Add to plan"); 
				
				try{
				for(Overlay overlay : mapView.getOverlays())
				{
					if(overlay instanceof PathOverlay)
					{
						mapView.getOverlays().remove(overlay);
					}
				}
				} catch (ConcurrentModificationException e){
					
				}
				
					mapView.getOverlays().add(RoutePathUtil.getPath(node.getPoint(),  new GeoPoint((int)(userLocationOverlay.getLocation().getLatitude()*1E6), (int)(userLocationOverlay.getLocation().getLongitude()*1E6))));
			
			
			}
				
		}
	 
	
		public synchronized void handleResult(boolean notify)
		{ 
			
			noteBaloon.setVisibility(0x00000008);
			
			Drawable drawable = this.getResources().getDrawable(R.drawable.up);
	        Context myContext = this;
			
			itemizedoverlay = new CitynodeItemizedOverlay(drawable,myContext);
			itemizedoverlay.setThumbsUp(BitmapFactory.decodeResource(
             getResources(), R.drawable.vote_yes3));  
			
			itemizedoverlay.setThubmsDown(BitmapFactory.decodeResource(
	                getResources(), R.drawable.vote_no3));  
		    itemizedoverlay.addObserver(this); 	
		     
		    //itemizedoverlay.setDoAnimtation(true);
		    
		    RecommendationNotificationOverlay overlay = new RecommendationNotificationOverlay(); 
		    
		    if(!travelplan.equals(null))
		    {
			     for (Recommendation n : travelplan )
			        {
			    	 
			    	    CitynodeOverlayItem cn= n.getNode().getOverlayItem();
			         	Drawable marker =  this.iconmanager.changeBackground(this.iconmanager.findIcon(n.getNode()),Integer.parseInt(n.getSystemRating()),n.isPersonalized()); 
			         	//marker.setAlpha(100);
			        	 marker.setBounds(0, 0, marker.getIntrinsicWidth(), marker.getIntrinsicHeight());
	
			        	 ShapeDrawable l; 
			        	 
			        	 cn.setMarker(marker); 
			        	 cn.setNode(n);
			        	 itemizedoverlay.addOverlay(cn);
			        	 
			        	  LayoutInflater inflater = getLayoutInflater();
			     }
			     
		    }
		    try{
		    for(Overlay i : getMapView().getOverlays() )
		    { 
		    	if((i instanceof ItemizedOverlay)) //|| (i instanceof RecommendationNotificationOverlay) )
		    		 this.mapView.getOverlays().remove(i); 
		    }
		    } catch (ConcurrentModificationException e){
		    	
		    }
		    
		    if(notify)
		    {
		    	
		    	  for(Overlay i : getMapView().getOverlays() )
				    { 
				    	if((i instanceof RecommendationNotificationOverlay) )
				    		 this.mapView.getOverlays().remove(i); 
				    }
		    	overlay.setNotifications(travelplan); 
		    //	((Vibrator)getSystemService(Context.VIBRATOR_SERVICE)).vibrate(1000);
		    	getMapView().getOverlays().add(overlay);
		    }
			
		    if(this.travelplan.size()>0)
		    	getMapView().getOverlays().add(itemizedoverlay);


		    mapView.invalidate();
		     
		}
		

		@Override
		public void onClick(View v) {
		

			if(v.equals(this.searchView))
			{ 
				
			    double lat = this.userLocationOverlay.getLocation().getLatitude(); 
		        double lng = this.userLocationOverlay.getLocation().getLongitude();
				   GeoPoint p = new GeoPoint(
				            (int) (lat * 1E6), 
				            (int) (lng * 1E6));
				        
				        
				      
					 this.mapView.getController().animateTo(p);
					 this.mapView.getController().setZoom(16); 
				        mapView.invalidate();
				finish();
				
			}
			else if(v.equals(this.getnewplan))
			{
				this.travelplan = this.agent.getTravelPlan(this.userLocationOverlay.getLocation());
				handleResult(false); 
			}
			else if(v.equals(this.removeplan))
			{
				Log.v("Pecka", "Removing travel plan");
				this.agent.removeTravelPlan();
				this.travelplan = new ArrayList<Recommendation>();
				handleResult(false);
			}
			else if(v.equals(this.addtoplan))
			{ 
				
					
					Recommendation r  = null; 
					
					if(this.selectedRecommendation.isInTravelPlan())
					{
						r = this.agent.removeFromTravelPlan(this.selectedRecommendation);
						this.noteBaloon.setVisibility(View.GONE); 
						this.travelplan.remove(this.selectedRecommendation);
						
					}
				
					
			
					
					
					handleResult(false);
					
			}
			else if(  v.equals(this.rate))
			{
				
				this.showDialog(0);
			}
			else if(v.equals(this.pendingView))
			{
//				Intent intent = new Intent(this, PendingRatings.class);
//				Bundle b = new Bundle();
//
//				b.putSerializable("agent",this.agent); 
//				b.putSerializable("usermode",this.userModel); 
//				//b.putSerializable("recommendation", this.selectedRecommendation.getSerializableRecommendation()); 
//				//b.putSerializable("usermodel", this.userModel); 
//
//				intent.putExtras(b);
//				
//				
//				startActivity(intent);
			}
			else if(v.equals(this.moreInfoButton))
			{ 
			
				Intent intent = new Intent(this, RecommendationDetial.class);
				Bundle b = new Bundle();

				b.putSerializable("recommendation", this.selectedRecommendation.getSerializableRecommendation()); 
				b.putSerializable("usermodel", this.userModel); 
				b.putDouble("latitude", this.userLocationOverlay.getLocation().getLatitude());
				b.putDouble("longitude", this.userLocationOverlay.getLocation().getLongitude());
				b.putSerializable("agent",this.agent); 
				b.putSerializable("usermode",this.userModel);
				intent.putExtras(b);
				
				System.out.println("lat:" + this.userLocationOverlay.getLocation().getLatitude());
				System.out.println("lat:" + this.userLocationOverlay.getLocation().getLongitude());
				
			//	startActivityForResult(intent, requestCode)
				
				startActivityForResult(intent,1);
			
				
			}
			
			

		}
		

		
		protected Dialog onCreateDialog(int i)
		{
			if(i==0)
			{ 
				System.out.println("kommer hit");
				System.out.println("lager ny");
				AlertDialog.Builder builder = new AlertDialog.Builder(this);
				builder.setView(this.ratingView);
				
				builder.setMessage("Rate "+ this.selectedRecommendation.getNode().getTitle())
				       .setCancelable(false)
				       .setPositiveButton("Rate", this)
				      
				       .setNegativeButton("Canel", new DialogInterface.OnClickListener() {
				           public void onClick(DialogInterface dialog, int id) {
				                dialog.cancel();
				           }
				       });
				
				return  builder.create();
				
			}
			else if(i==2)
			{
				AlertDialog.Builder builder = new AlertDialog.Builder(this);
				builder.setMessage("Your rating of " + this.selectedRecommendation.getNode().getTitle() + " was sucsessfully updated");
				builder.setCancelable(true);
				return builder.create(); 
			}
			else if(i==3) 
			{
				AlertDialog.Builder builder = new AlertDialog.Builder(this);
				builder.setMessage("Network error. Check the status of your wireless conection");
				builder.setCancelable(true);
				return  builder.create(); 
			}
			else if(i==4)
			{
				AlertDialog.Builder builder = new AlertDialog.Builder(this);
				builder.setMessage("We found some places we think you might find intersting");
				builder.setCancelable(true);
				return builder.create(); 
			}
			else if(i==5)
			{
				AlertDialog.Builder builder = new AlertDialog.Builder(this);
				builder.setView(this.ratingView);
				builder.setMessage("Did you visit "+ this.selectedRecommendation.getNode().getTitle() + " ? ")
				       .setCancelable(false)
				       .setPositiveButton("Rate", this)
				       .setNegativeButton("Canel", new DialogInterface.OnClickListener() {
				           public void onClick(DialogInterface dialog, int id) {
				                dialog.cancel();
				           }
				       });
				return  builder.create();
				
			
			}
			return null;
		}
	
		
		
       @Override
		protected void onPrepareDialog(int id, Dialog d) 
		{
			System.out.println("kommer hit");
			
	
			if(id==0)
			{ 
				System.out.println("kommer hit");
				System.out.println("lager ny");
				
				((AlertDialog) d).setMessage("Rate "+ this.selectedRecommendation.getNode().getTitle());
		
			}
			else if(id==2)
			{
				((AlertDialog) d).setMessage("Your rating of " + this.selectedRecommendation.getNode().getTitle() + " was sucsessfully updated");
			
			}
			else if(id==3) 
			{
				((AlertDialog) d).setMessage("Network error. Check the status of your wireless conection");
			
		
			}
			else if(id==4)
			{
				((AlertDialog) d).setMessage("We found some places we think you might find intersting");
			}
			else if(id==5)
			{
			
			
			}
			
		}


		
		
		
		
		@Override
		protected boolean isRouteDisplayed() {
			// TODO Auto-generated method stub
			return false;
		}



		@Override
		public void onLocationChanged(Location location) {
		
			this.userLocationOverlay.setLocation(location); 
			/*
			
			
			List<Recommendation> l = this.agent.update(location);
			Log.v("dette er sorelse paa lista",String.valueOf(l.size()));
			if(l.size()>0)
			{
				if(this.citynodes==null)
					citynodes = l;
				else 
				{
					citynodes.addAll(l);
				}
				handleResult(true);
			}
			
		

			
			this.mapView.invalidate(); 	
			/*
			 * 
			 */
		}



		@Override
		public void onProviderDisabled(String provider) {
			// TODO Auto-generated method stub
			
		}



		@Override
		public void onProviderEnabled(String provider) {
			// TODO Auto-generated method stub
			
		}



		@Override
		public void onStatusChanged(String provider, int status, Bundle extras) {
			// TODO Auto-generated method stub
			
		}


		protected synchronized MapView getMapView()
		{
			return this.mapView; 
		}
		

		private Drawable ImageOperations(Context ctx, String url, String saveFilename) {
			try {
				InputStream is = (InputStream) this.fetch(url);
				Drawable d = Drawable.createFromStream(is, "src");
				return d;
			} catch (MalformedURLException e) {
				e.printStackTrace();
				return null;
			} catch (IOException e) {
				e.printStackTrace();
				return null;
			}
		}

		private Object fetch(String address) throws MalformedURLException,IOException {
			URL url = new URL(address);
			Object content = url.getContent();
			return content;
		}





		
		@Override
		public void onClick(DialogInterface arg0, int arg1) {
			
			System.out.println("kommer inn her");
			System.out.println(arg1);
		
			if(arg1 == -1)
			{
				  System.out.println(("rating:" + TravelPlanView.this.ratingBar.getRating()/5));
	        	  boolean sucess = this.agent.giveExplicitFeedback( TravelPlanView.this.selectedRecommendation.getNode(), (TravelPlanView.this.ratingBar.getRating()/5));
	        	  if(sucess)
	        	  {
	        		  TravelPlanView.this.showDialog(2);
	        	  }
	        	  else 
	        	  {
	        		  TravelPlanView.this.showDialog(3);
	        	  }
			}
			
		}


		
		@Override
		public boolean onTouch(View v, MotionEvent event) {
			
			/*
		    if (event.getAction() == 1 && (event.getEventTime()-event.getDownTime())>1000) {
	        	
		    	Citynode rec = this.agent.checkForNewPlacesToRate(null); 
		    	if(rec!=null)
				{
		    		this.numberOfpending++;
					//newItemToRate = rec; 
					
					//showDialog(5);
					this.pendingView.setAnimation(AnimationUtils.loadAnimation( this, R.anim.magnify ));
					this.pendingView.setText(this.pendingView.getText()+"("+this.numberOfpending+")");
					if(this.pendingRatings!=null)
						pendingRatings.add(rec); 
					else 
					{
						this.pendingRatings = new ArrayList<Citynode>(); 
						this.pendingRatings.add(rec);
					}
	        }}
				*/
			
			System.out.println("inn her");
			if(v.equals(this.quite))
			{
				this.noteBaloon.setVisibility(View.GONE);
		    
			}
			return false;
		}

	
}


