package ntnu.model;

import java.io.Serializable;

import org.w3c.dom.Element;

import android.util.Log;

import com.google.android.maps.GeoPoint;

public class Attribute implements Serializable{

	private String description;
	
	private Attribute parent;
	
	private String type; 
	
	private String id; 
	
	public String getId() {
		return id;
	}


	public void setId(String id) {
		this.id = id;
	}


	private int level; 
	
	public int getLevel() {
		return level;
	}


	public void setLevel(int level) {
		this.level = level;
	}


	public Attribute()
	{ 
		
	}
	
	
	public String getType() {
		return type;
	}


	public void setType(String type) {
		this.type = type;
	}


	public Attribute (String description,String type,Attribute parent)
	{ 
		this.description = description; 
		this.type = type; 
		this.parent = parent; 
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public Attribute getParent() {
		return parent;
	}

	public void setParent(Attribute parent) {
		this.parent = parent;
	}
	
	
	public static Attribute fromXml(Element e)
	{ 
	
		
		Attribute a = new Attribute(); 
		a.setDescription(e.getAttribute("description")); 
		a.setType(e.getAttribute("type")); 
		a.setLevel(Integer.parseInt(e.getAttribute("level")));
		a.setId(e.getAttribute("id")); 

		
		
		Element xmlparent = (Element)e.getElementsByTagName("parent").item(0); 
		if(xmlparent!=null)
		{
			Element xmlparentat = (Element)xmlparent.getElementsByTagName("attribute").item(0); 
	
		
			if(xmlparentat.hasAttribute("level") && Integer.parseInt(xmlparentat.getAttribute("level"))==a.getLevel()-1)
			a.setParent(Attribute.fromXml(xmlparentat)); 
		}
		
		/*
		while(tempXml.getElementsByTagName("parent")!=null)
		{ 
			Element xmlparent = (Element)tempXml.getElementsByTagName("parent").item(0); 
			tempXml = null;
			Attribute parent = new Attribute(); 
			temp.setParent(parent); 
			parent.setDescription(xmlparent.getAttribute("description")); 
			parent.setType(xmlparent.getAttribute("type"));
			
			temp = parent; 
			tempXml = xmlparent;
			Log.v("parent",tempXml.toString());
		}
		*/
	
		
		return a; 
	}
	
}
