package ntnu.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import ntnu.ui.CitynodeOverlayItem;

import android.R;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.ColorFilter;
import android.graphics.Paint;
import android.graphics.Picture;
import android.graphics.Rect;
import android.graphics.RectF;
import android.graphics.drawable.Drawable;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.OvalShape;
import android.graphics.drawable.shapes.RectShape;
import android.util.Log;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.OverlayItem;



public class Citynode implements Serializable{

	private GeoPoint position; 
	
	private String description; 
	
	private String type; 
	
	private String adresse; 
	
	private String openingHours; 
	
	private String category; 
	
	private String picutre; 
	
	private String phoneNumber; 
	
	private String tag; 

	private List<Attribute> attributes; 
	
	private long user; 
	
	
	public long getUser() {
		return user;
	}

	public void setUser(long user) {
		this.user = user;
	}


	private long id; 
	
	
	public long getId() {
		return id;
	}

	public void setId(long id) {
		this.id = id;
	}

	public String getPhoneNumber() {
		return phoneNumber;
	}

	public void setPhoneNumber(String phoneNumber) {
		this.phoneNumber = phoneNumber;
	}
	
	
	public String getTag() {
		return tag;
	}

	public void setTag(String tag) {
		this.tag = tag;
	}

	public String getAdresse() {
		return adresse;
	}

	public void setAdresse(String adresse) {
		this.adresse = adresse;
	}

	public String getOpeningHours() {
		return openingHours;
	}

	public void setOpeningHours(String openingHours) {
		this.openingHours = openingHours;
	}

	public String getPicutre() {
		return picutre;
	}

	public void setPicutre(String picutre) {
		this.picutre = picutre;
	}
	
	
	

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public String getCategory() {
		return category;
	}

	public void setCategory(String category) {
		this.category = category;
	}

	public String getTitle() {
		return title;
	}

	public void setTitle(String title) {
		this.title = title;
	}


	private String title; 
	
	
	
	public Citynode(GeoPoint position,String desc)
	{ 
		this.position = position;
		this.description = desc; 
		
	}

	public GeoPoint getPosition() {
		return position;
	}

	public void setPosition(GeoPoint position) {
		this.position = position;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public CitynodeOverlayItem getOverlayItem()
	{ 
		CitynodeOverlayItem retur = new CitynodeOverlayItem(this.position, description, description);	
		
		return retur;
		
	}


	public static Citynode fromXml(Element e)
	{ 
		Element pos = (Element)e.getElementsByTagName("position").item(0); 
		double lng = Double.parseDouble(pos.getAttribute("long")); 
		double lat = Double.parseDouble(pos.getAttribute("lat"));
				
		GeoPoint p = new GeoPoint(
			            (int) (lat * 1E6), 
			            (int) (lng * 1E6));
			
		String description = e.getAttribute("description");
		
		Citynode c =  new Citynode(p,description);
		

		c.setTitle(e.getAttribute("title")); 
		c.setCategory(e.getAttribute("category")); 
		c.setType(e.getAttribute("type")); 
		c.setPhoneNumber(e.getAttribute("phoneumber"));
		c.setPicutre(e.getAttribute("illustation"));
		c.setOpeningHours(e.getAttribute("openinghours"));
		c.setAdresse(e.getAttribute("address")); 
		c.setTag(e.getAttribute("tag"));
		c.setId(Long.valueOf(e.getAttribute("id"))); 
		
		//if(e.hasAttribute("user"))
			//c.user = Long.valueOf("user"); 
		
		Element ats = (Element)e.getElementsByTagName("attributes").item(0);
		NodeList xmlAttributes = ats.getElementsByTagName("attribute");
		
		if(xmlAttributes!=null)
		{ 
			Log.v("length", String.valueOf(xmlAttributes.getLength()));
			List <Attribute> attributes = new ArrayList<Attribute>();
			
			for(int i=0;i<xmlAttributes.getLength();i++)
			{ 
				
				Log.v("citynode","ogs jer");
				Element attribute = (Element)xmlAttributes.item(i); 
				if(attribute.getAttribute("xmlns").equals("leaf"))
					attributes.add(Attribute.fromXml(attribute)); 
			}
			
			c.setAttributes(attributes);
		}
		Log.v("kommer seg ut","citynode"); 
		
		return c; 
	}
	public List<Attribute> getAttributes() {
		return attributes;
	}

	public void setAttributes(List<Attribute> attributes) {
		this.attributes = attributes;
	}

	
	
	public SerializableCitynode getSerializableCitynode()
	{ 
		SerializableCitynode node = new SerializableCitynode(this.description); 
		node.setAdresse(this.adresse); 
		node.setAttributes(this.getAttributes()); 
		node.setCategory(this.category); 
		node.setDescription(this.description); 
		node.setOpeningHours(this.getOpeningHours()); 
		node.setPhoneNumber(this.getPhoneNumber()); 
		node.setPicutre(this.picutre); 
		node.setTag(this.tag); 
		node.setTitle(this.title);
		node.setType(this.type); 
		node.setid(this.id);
		
		return node;
		
		
	}
	
	
	
}


