package ntnu.ui;

import java.util.ArrayList;
import java.util.List;

import ntnu.client.ItemObserver;


import android.R;
import android.app.AlertDialog;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Point;
import android.graphics.RectF;
import android.graphics.drawable.Drawable;
import android.util.Log;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.google.android.maps.ItemizedOverlay;
import com.google.android.maps.MapView;
import com.google.android.maps.OverlayItem;

public class CitynodeItemizedOverlay extends ItemizedOverlay<CitynodeOverlayItem>  {

	private ArrayList <CitynodeOverlayItem> citynodes = new ArrayList<CitynodeOverlayItem>();; 
	
	private RelativeLayout infoSplash; 
	
	private Context context; 
	
	private ArrayList <ItemObserver> observers = new ArrayList<ItemObserver>();
	
	private boolean doAnimtation;
	




	private int numberOfCycles = 10; 
	
	private int currentCycle = 0; 
	
	
	private long animateCycletime =10; 
	
	private long cycleLength = 200; 
	
	private long lastTimeStamp = 0; 
	
	
	private float maxRadius = 45;
	
	private float minRadius = 0;
	
	private float radius = 0; 
	

	private float minAplaha = 0;
	
	private float maxAplaha = 190;
	
	
	private float alpha = 0; 
	
	
	private Bitmap thumbsUp;
	
	private Bitmap thubmsDown;
	
	
	


	@Override
	public void draw(Canvas canvas, MapView mapView, boolean shadow) {
		// TODO Auto-generated method stub
		//super.draw(canvas, mapView, shadow);
	}

	@Override
	public boolean draw(Canvas canvas, MapView mapView, boolean shadow,long when) {
		//canvas.translate(-5, -20);
		
		
		
		for(CitynodeOverlayItem node : this.citynodes)
		{
	
			if(node.getNode().getRateChange()!=0)
			{ 
				float radiusOffset = this.maxRadius/this.cycleLength; 
				float aplhaOffset = this.maxAplaha/this.cycleLength; 
				
				//super.draw(canvas, mapView, shadow, when);
				
				if(when-lastTimeStamp>animateCycletime && currentCycle<numberOfCycles)
				{
				
					
					
					if(this.alpha<this.minAplaha || this.radius>this.maxRadius)
					{ 
						this.currentCycle++; 
						
						this.alpha = 200; 
						this.radius = 0; 
					}
					else 
					{
						this.alpha = this.alpha - aplhaOffset; 
						this.radius = this.radius + radiusOffset; 
					}
					
					Paint   panelPaint = new Paint(); 
					
					panelPaint.setColor(node.getNode().getRateChange()>0?Color.GREEN:Color.RED);
					panelPaint.setAlpha((int)this.alpha); 
				    RectF baloonRect = new RectF();
					
				    Point screenPts2 = new Point(); 
				    
				    mapView.getProjection().toPixels(node.getPoint(), screenPts2);
				
				    canvas.drawCircle(screenPts2.x+14,screenPts2.y+15,this.radius, panelPaint); 
				    
				}
				else if(currentCycle==numberOfCycles)
				{ 
					doAnimtation = false; 
					currentCycle = 0; 
				}
			}
		}
		currentCycle++; 
		
		lastTimeStamp = when; 
		
		super.draw(canvas, mapView, shadow); 
		
		for(CitynodeOverlayItem node : this.citynodes)
		{
	
			//super.draw(canvas, mapView, shadow);
			//node.getMarker(0).setAlpha(50);
			
			Point screenPts = new Point();
	        mapView.getProjection().toPixels(node.getPoint(), screenPts);
	        
			if(Integer.parseInt(node.getNode().getUserRating())==1)
			{
				canvas.drawBitmap(this.thumbsUp,screenPts.x,screenPts.y, null);
			}
			else if(Integer.parseInt(node.getNode().getUserRating())==0)
			{
				canvas.drawBitmap(this.thubmsDown,screenPts.x,screenPts.y, null);
			}
			
			
		}
	
		
		return true;
		//canvas.translate(5, 20);
	}

	@Override
	public int size() 
	{
		return citynodes.size();
	}
	
	public void addOverlay(CitynodeOverlayItem overlay) 
	{
		this.citynodes.add(overlay);
	    populate();
	   
	}

	@Override
	protected boolean onTap(int index) {
	  CitynodeOverlayItem item = citynodes.get(index);
	  
	  
	  for (ItemObserver o : observers)
	  {
		  item.getPoint(); 
		  o.itemChange(item);
	  }
	  
	
	  return true;
	}
	
	public Bitmap getThumbsUp() {
		return thumbsUp;
	}

	public void setThumbsUp(Bitmap thumbsUp) {
		this.thumbsUp = thumbsUp;
	}

	public Bitmap getThubmsDown() {
		return thubmsDown;
	}

	public void setThubmsDown(Bitmap thubmsDown) {
		this.thubmsDown = thubmsDown;
	}

	public CitynodeItemizedOverlay(Drawable defaultMarker) {
		  super(boundCenterBottom(defaultMarker));
		}
	
	public CitynodeItemizedOverlay(Drawable defaultMarker, Context context) {
		  super(boundCenterBottom(defaultMarker));
		  
		  this.context = context;
		}
	protected CitynodeOverlayItem createItem(int i) 
	{
		return citynodes.get(i);
	}

	public boolean isDoAnimtation() {
		return doAnimtation;
	}

	public void setDoAnimtation(boolean doAnimtation) {
		this.doAnimtation = doAnimtation;
	}
	
	
	public void setCityNodes(ArrayList <CitynodeOverlayItem> nodes)
	{
		this.citynodes = nodes;
		this.populate();
	}
	
	public void addObserver(ItemObserver obs)
	{
		this.observers.add(obs);
	}
	



	public void infoSplash(RelativeLayout s)
	{ 
		this.infoSplash = s; 
	}
	
}
