package ntnu.ui;

import java.util.List;

import ntnu.client.R;
import ntnu.model.Recommendation;

import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Point;
import android.graphics.RectF;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.animation.Animation;
import android.view.animation.AnimationUtils;

import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;

public class RecommendationNotificationOverlay extends Overlay {

	
	
	private List <Recommendation> notifications;
	
	private Animation blueFade; 


	private int numberOfCycles = 10; 
	
	private int currentCycle = 0; 
	
	
	private long animateCycletime = 10; 
	
	private long cycleLength = 50; 
	
	private long lastTimeStamp = 0; 
	
	
	private float maxRadius = 40;
	
	private float minRadius = 0;
	
	private float radius = 0; 
	

	private float minAplaha = 0;
	
	private float maxAplaha = 150;
	private float alpha = 0; 
	

	@Override
	public boolean draw(Canvas canvas, MapView mapView, boolean shadow,long when) {
		
		
		float radiusOffset = this.maxRadius/this.cycleLength; 
		float aplhaOffset = this.maxAplaha/this.cycleLength; 
		
		//super.draw(canvas, mapView, shadow, when);
		
		if(when-lastTimeStamp>animateCycletime && currentCycle<numberOfCycles)
		{
		
			lastTimeStamp = when; 
			
			if(this.alpha<this.minAplaha || this.radius>this.maxRadius)
			{ 
				this.currentCycle++; 
				
				this.alpha = 200; 
				this.radius = 0; 
			}
			else 
			{
				this.alpha = this.alpha - aplhaOffset; 
				this.radius = this.radius + radiusOffset; 
			}
		
			
			
			
			for(Recommendation r : notifications)
			{
				// this.blueFade.setDuration(600);
				//r.startAnimation(this.blueFade); 
				
				Paint   panelPaint = new Paint(); 
				
				panelPaint.setColor(Color.BLUE);
				panelPaint.setAlpha((int)this.alpha); 
			    RectF baloonRect = new RectF();
			//    baloonRect.set(0,0, 20,20);
			  //  canvas.drawOval(baloonRect, panelPaint);
			    
			    Point screenPts = new Point(); 
			    
			    mapView.getProjection().toPixels(r.getNode().getPosition(), screenPts);
			
			    canvas.drawCircle(screenPts.x+14,screenPts.y+15,this.radius, panelPaint); 
			   // canvas.drawCircle(0,0,20, panelPaint); 
			
			}
		}
		
		return true; 
		
	} 
	
	public List<Recommendation> getNotifications() {
		return notifications;
	}



	public void setNotifications(List<Recommendation> notifications) {
		this.notifications = notifications;
	}

	public Animation getBlueFade() {
		return blueFade;
	}

	public void setBlueFade(Animation blueFade) {
		this.blueFade = blueFade;
	}
	
	
	
	
	
	
}
