package ntnu.ui;

import java.util.ArrayList;
import java.util.List;

import ntnu.client.ItemObserver;
import ntnu.client.R;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Point;
import android.graphics.drawable.Drawable;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.location.LocationProvider;
import android.os.Bundle;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;
import android.view.animation.AccelerateDecelerateInterpolator;
import android.view.animation.Animation;
import android.view.animation.RotateAnimation;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;

public class UserLocationOverlay extends Overlay 
{
	
	
	
	private Location location; 
	
	private Bitmap icon; 
	
	private MapView mapView;
	
	private LinearLayout popUp; 
	
	MotionEvent prevEvent; 
	
	long lastTouchTime = 0;
	
	private List <GeoPoint> pickedLocations = new ArrayList<GeoPoint>(); 
	
	
	

	public LinearLayout getPopUp() {
		return popUp;
		
	}
  

	public void setPopUp(LinearLayout popUp) {
		this.popUp = popUp;
	}
	
	// NOT ORIGINAL METHOD, USED FOR TEST-PURPOSES FOR SIMULATING LOCATION ONLY
	public UserLocationOverlay()
	{ 
			
	}

	// NOT ORIGINAL METHOD, USED FOR TEST-PURPOSES FOR SIMULATING LOCATION ONLY
//	public UserLocationOverlay(Location intialLocation,Bitmap icon,MapView m)
//	{ 
//		this.location = getLocation(); 
//		this.icon = icon;
//		this.mapView = m; 
//		
//	
//	}
	
	// ORIGINAL METHOD, REPLACED FOR TESTING PURPOSES
	public UserLocationOverlay(Location intialLocation,Bitmap icon,MapView m)
	{ 
		this.location = intialLocation; 
		this.icon = icon;
		this.mapView = m; 
		
	
	} 
	
	
    public boolean draw(Canvas canvas, MapView mapView, 
            boolean shadow, long when) 
            {
                super.draw(canvas, mapView, false);         
//                GeoPoint p = new GeoPoint((int)(63.46*1E6), (int)(10.43*1E6));
                
                if (this.location == null){
                	Location loc = new Location("t");
                	loc.setLatitude(63.429632);
                	loc.setLongitude(10.39735);

                	this.location = loc;
                }
            	
                GeoPoint p = new GeoPoint((int)(location.getLatitude()*1E6), (int)(location.getLongitude()*1E6));
                
                Point screenPts = new Point();
                mapView.getProjection().toPixels(p, screenPts);
                
            //    canvas.drawCircle( screenPts.x,screenPts.y, 30, new Paint()); 
                canvas.drawBitmap(icon, screenPts.x, screenPts.y, null);  
                
           
                
                if(this.getPickedLocations()!=null && this.getPickedLocations().size()>0)
                {
                	for(GeoPoint geop:this.getPickedLocations())
                	{
                		Paint paint = new Paint(); 
                
                		paint.setColor(Color.RED); 
                		screenPts = mapView.getProjection().toPixels(geop, screenPts);; 
                		canvas.drawCircle(screenPts.x, screenPts.y, 5, paint); 
                	}
                }
                
                return true;
            }

    
    
    /*

    @Override
    public boolean onTouchEvent(MotionEvent event, MapView mapView) 
    {   
    	
        //---when user lifts his finger---
        if (event.getAction() == 1 && (event.getEventTime()-event.getDownTime())>1000) {
        	
        	System.out.println("time:" + (event.getEventTime()-event.getDownTime())); 
            GeoPoint p = mapView.getProjection().fromPixels(
                (int) event.getX(),
                (int) event.getY());
              System.out.println( "trykk:" + p.getLatitudeE6() / 1E6+ " "   +p.getLongitudeE6() /1E6);
              
              
                   
        }                            
        return false;
    }        

*/
    
 // NOT ORIGINAL METHOD, USED FOR TEST-PURPOSES FOR SIMULATING LOCATION ONLY
    public Location getLocation(String str) {


    	Location newLocation = new Location(LocationManager.GPS_PROVIDER);

    	newLocation.setLatitude(63.429632);
    	newLocation.setLongitude(10.39735);

    	newLocation.setAccuracy(500);

    	if (this.location == null){
    		Log.v("Pecka", "this.location == null");
    		return newLocation;
    		
    	} else {
    		Log.v("Pecka", "location: " + location.getLatitude());
    		return this.location;
    	}
    	
    }
    
    // NOT ORIGINAL METHOD, USED FOR TEST-PURPOSES FOR SIMULATING LOCATION ONLY
    public Location getLocation() {


    	Location newLocation = new Location(LocationManager.GPS_PROVIDER);

    	newLocation.setLatitude(63.429632);
    	newLocation.setLongitude(10.39735);

    	newLocation.setAccuracy(500);

    	if (this.location == null){
    		Log.v("Pecka", "this.location == null");
    		return newLocation;
    		
    	} else {
    		Log.v("Pecka", "location: " + location.getLatitude());
    		return this.location;
    	}
    }

//    // NOT ORIGINAL METHOD, USED FOR TEST-PURPOSES FOR SIMULATING LOCATION ONLY
//	public Location getLocation() {
//		
//		Location loc = new Location("test");
//		loc.setLatitude(63.429632);
//		loc.setLongitude(10.39735);
//		
//		
//		Log.v("Pecka", String.valueOf(loc.getLatitude()));
//		return loc;
//	}
	
	// ORIGINAL METHOD, REPLACED FOR TESTING PURPOSES
//	public Location getLocation() {
//		return location;
//	}


	public void setLocation(Location location) {
		this.location = location;
	}


	public boolean onTouchEvent2(MotionEvent ev,MapView mapView)
	{ 

		  if (ev.getAction() == MotionEvent.ACTION_DOWN) {

		      long thisTime = System.currentTimeMillis();
		  if (thisTime - lastTouchTime < 250) {

			  Log.v("double","trouble");
		        // Double tap
		      // this.getController().zoomInFixing((int) ev.getX(), (int) ev.getY());
		        lastTouchTime = -1;
		        
		        GeoPoint p = mapView.getProjection().fromPixels(
	                    (int) ev.getX(),
	                    (int) ev.getY());

		        
		        if(popUp.getVisibility()==View.GONE)
				{
		        	mapView.removeView(popUp);
					popUp.setVisibility(View.VISIBLE);
					mapView.addView(popUp, new MapView.LayoutParams(110,202,p,MapView.LayoutParams.BOTTOM_CENTER));
				}
				
		        if(this.getPickedLocations().size()==2)
		        { 
		        	this.pickedLocations = null; 
		        	this.pickedLocations = new ArrayList<GeoPoint>();
		        	getPickedLocations().add(p); 
		        }
		        else 
		        { 
		        	getPickedLocations().add(p); 
		        }

		      } else {

		  // Too slow :)
		    		popUp.setVisibility(View.GONE);  	  
		  lastTouchTime = thisTime;
		  }
		    }

		 

		    return super.onTouchEvent(ev,mapView);

	}



	
	
	public List<GeoPoint> getPickedLocations() {
		return pickedLocations;
	}


	

	public void setPickedLocations(List<GeoPoint> pickedLocations) {
		this.pickedLocations = pickedLocations;
	}
	
	
	
	public GeoPoint getFrom()
	{ 
		if(getPickedLocations().size()==1)
		{ 
			GeoPoint p = new GeoPoint((int)(location.getLatitude()*1E6), (int)(location.getLongitude()*1E6));
			return p; 
		}
		else 
		{
			Log.v("prover","kanskje");
			return getPickedLocations().get(1); 
		}
		
	}
	
	public GeoPoint getTo()
	{ 
	//	if(getPickedLocations().size()==1)
	//	{ 
			return getPickedLocations().get(0); 
//		}
	//	else 
	//		return getPickedLocations().get(1); 
		
	}
	
  
	
	
}
