package ntnu.util;

import java.io.IOException;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import ntnu.ui.PathOverlay;

import org.w3c.dom.Document;
import org.xml.sax.SAXException;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapView;

public class RoutePathUtil {

	
	public static PathOverlay getPath(GeoPoint src,GeoPoint dest)
	{
		
		PathOverlay pOverLay =new PathOverlay(); 
		ArrayList <GeoPoint>  pathList = new ArrayList<GeoPoint>(); 
		
		StringBuilder urlString = new StringBuilder();
		urlString.append("http://maps.google.com/maps?f=w&hl=en");
		urlString.append("&saddr=");//from
		urlString.append( Double.toString((double)src.getLatitudeE6()/1.0E6 ));
		urlString.append(",");
		urlString.append( Double.toString((double)src.getLongitudeE6()/1.0E6 ));
		urlString.append("&daddr=");//to
		urlString.append( Double.toString((double)dest.getLatitudeE6()/1.0E6 ));
		urlString.append(",");
		urlString.append( Double.toString((double)dest.getLongitudeE6()/1.0E6 ));
		urlString.append("&ie=UTF8&0&om=0&output=kml");
		
		
		Document doc = null;
		HttpURLConnection urlConnection= null;
		URL url = null;
		try
		{
			url = new URL(urlString.toString());
			urlConnection=(HttpURLConnection)url.openConnection();
			urlConnection.setRequestMethod("GET");
			urlConnection.setDoOutput(true);
			urlConnection.setDoInput(true);
			urlConnection.connect();
	
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			DocumentBuilder db = dbf.newDocumentBuilder();
			doc = db.parse(urlConnection.getInputStream());
	
			if(doc.getElementsByTagName("GeometryCollection").getLength()>0)
			{
				String path = doc.getElementsByTagName("GeometryCollection").item(0).getFirstChild().getFirstChild().getFirstChild().getNodeValue() ;
				String [] pairs = path.split(" ");
			
				for(int i=1;i<pairs.length;i++) // the last one would be crash
				{
					String [] lngLat = pairs[i].split(",");
					GeoPoint p = new GeoPoint((int)(Double.parseDouble(lngLat[1])*1E6),(int)(Double.parseDouble(lngLat[0])*1E6));
					pathList.add(p); 
				}

				pOverLay.setPathList(pathList); 
			}
			
			return pOverLay; 
		}
		catch (MalformedURLException e)
		{
			e.printStackTrace();
			return null; 
		}
		catch (IOException e)
		{
		    e.printStackTrace();
		    return null; 
		    
		}
		catch (ParserConfigurationException e)
		{
			e.printStackTrace();
			return null; 
		}
		catch (SAXException e)
		{
			e.printStackTrace();
			return null;
		}

	
	}
	
	
}
