package dao;

import java.io.Serializable;
import java.util.List;

import org.apache.lucene.queryParser.ParseException;

import model.Context;

public interface GenericDAO <T, ID extends Serializable>{

	T findByID(ID id,boolean lock); 
	
	List <T> findBySearch(String searchString,Context context); 
	
	List <T> findAll(); 
	
	T makePersistent(T entity); 
	
	void makeTransient(T entity); 
	
	void flush(); 
	void clear(); 
	
	
	
}
