package dao.impl;

import java.util.ArrayList;
import java.util.List;

import model.Citynode;
import model.Context;

import org.apache.lucene.analysis.standard.StandardAnalyzer;
import org.apache.lucene.queryParser.MultiFieldQueryParser;
import org.apache.lucene.queryParser.ParseException;
import org.hibernate.Transaction;
import org.hibernate.criterion.Restrictions;
import org.hibernatespatial.criterion.SpatialRestrictions;


import com.vividsolutions.jts.geom.Coordinate;
import com.vividsolutions.jts.geom.CoordinateSequence;
import com.vividsolutions.jts.geom.GeometryFactory;
import com.vividsolutions.jts.geom.LinearRing;
import com.vividsolutions.jts.geom.Point;
import com.vividsolutions.jts.geom.Polygon;
import com.vividsolutions.jts.geom.impl.CoordinateArraySequence;

import dao.CitynodeDAO;

public class CitynodeDAOimpl extends GenericDAOimpl<Citynode,Long> implements CitynodeDAO {

	private String[] fields = new String[]{"title"};
	
	
	public List<Citynode> findCityNodeWithin(Point p, double radius) 
	{
		return findByCriteria(SpatialRestrictions.within("location",p.buffer(0.005,4))); 
	}

	public Citynode findByID(Long id, boolean lock) {
		return super.findById(id, lock); 
	}

	@Override
	public List<Citynode> contains(Point userPosition) {
		
      //  testCriteria.add(SpatialRestrictions.contains("coveringArea",userPosition));
        
        List results = findByCriteria(SpatialRestrictions.contains("coveringArea",userPosition));//testCriteria.list();
        
        System.out.println("The size of the results: " + results.size());
        
        if(results==null || results.size()==0)
        	return null; 
        else  
        	return results;
	}

	@Override
	public List <Citynode> findBySearch(String searchString, Context context)  
	{
		
		   Transaction tx = this.getFullTextSession().beginTransaction();
	
		MultiFieldQueryParser parser = new MultiFieldQueryParser(fields, new StandardAnalyzer());
		org.apache.lucene.search.Query query;
		query = null;  
		try {
			query = parser.parse( searchString );
		} 
		catch (ParseException e) 
		{
			e.printStackTrace();
		}
		
		org.hibernate.Query hibQuery = getFullTextSession().createFullTextQuery(query, Citynode.class);

		List <Citynode> result = hibQuery.list();
		System.out.println("antall shit som ble funnet:" + result.size());  
		
		for(Citynode n : result)
		 { 
			 System.out.println(n.getTitle());
		 }
		   
		//   session.close();  
		
		tx.commit();
		return result;
	}

	@Override
	public List<Citynode> findCitynodeExperience(Context c) 
	{
		
		if(c.getIntrestField()==null)
			return findByCriteria(Restrictions.eq("category", "Activity")); 
		else
			return findByCriteria(Restrictions.eq("category", "Activity"),SpatialRestrictions.within("location",c.getIntrestField())); 
	}
	
	@Override
	public List<Citynode> findCitynodesEat(Context c) 
	{
		if(c.getIntrestField()==null)
			return findByCriteria(Restrictions.eq("category", "Restaurant")); 
		else
			return findByCriteria(Restrictions.eq("category", "Restaurant"),SpatialRestrictions.within("location",c.getIntrestField())); 
	}
	
	@Override
	public List<Citynode> findCitynodesSleep(Context c) 
	{
		
		if(c.getIntrestField()==null)
			return findByCriteria(Restrictions.eq("category", "Hotel")); 
		else
			return findByCriteria(Restrictions.eq("category", "Hotel"),SpatialRestrictions.within("location",c.getIntrestField())); 
	}
	
	
	
	
	
	
	// -------- METHODS BELOW ARE NOT SAFE AND ONLY USED FOR DEBUGGING --------
	
//	@Override
//	public List<Citynode> findCitynodeExperience(Context c) 
//	{
//		
//		if(c.getIntrestField()==null)
//			return findByCriteria(Restrictions.eq("category", "Activity")); 
//		else {
//			System.out.println("Interest field's SRID: " + c.getIntrestField().getSRID());
//			
//			 List<Citynode> list = null;
//			    try{
//			    	System.out.println("in try...");
//			    	list = findByCriteria(Restrictions.eq("category", "Hotel"),SpatialRestrictions.within("location",c.getIntrestField()));
//			    } catch (Exception e) {
//			    	System.out.println("CRASH! \n ");
//			    	e.printStackTrace();
//			    }
//			    
//			List<Citynode> listAll = findByCriteria(Restrictions.eq("category", "Activity")); 
//			
//			System.out.println("Size of list: " + list.size());
//			System.out.println("Size of listAll: " + listAll.size());
//			
//			for(Citynode cn : listAll){
//				System.out.println("SRID: " + cn.getLocation().getSRID());
//			}
//			
//			return list;
//		}
//	}
//
//	@Override
//	public List<Citynode> findCitynodesEat(Context c) 
//	{
//		System.out.println("Interest field's SRID: " + c.getIntrestField().getSRID());
//		List<Citynode> list = findByCriteria(Restrictions.eq("category", "Restaurant"));
//		for(Citynode cn : list){
//			System.out.println("SRID: " + cn.getLocation().getSRID());
//		}
//		return list;
//
////		if(c.getIntrestField()==null){
////			return findByCriteria(Restrictions.eq("category", "Restaurant")); 
////		} else
////			return findByCriteria(Restrictions.eq("category", "Restaurant"),SpatialRestrictions.within("location",c.getIntrestField())); 
//	}
//		
//
//	@Override
//	public List<Citynode> findCitynodesSleep(Context c)
//	{
//		if(c.getIntrestField()==null)
//			return findByCriteria(Restrictions.eq("category", "Hotel")); 
//		else {
//			
////			return findByCriteria(Restrictions.eq("category", "Hotel"),Restrictions.eq("title", "Yes da"));
//			
//			System.out.println("Interest field: " + c.getIntrestField().toText());
//			System.out.println("Interest field's SRID: " + c.getIntrestField().getSRID());
//			
//			final GeometryFactory gf = new GeometryFactory();
//			
//			final ArrayList<Coordinate> points = new ArrayList<Coordinate>();
//		    points.add(new Coordinate(63.47474487486235, 10.308609008789062));
//		    points.add(new Coordinate(63.482869960180494, 10.591850280761719));
//		    points.add(new Coordinate(63.34997345185443, 10.587730407714844));
//		    points.add(new Coordinate(63.35058942069822, 10.270156860351562));
//		    points.add(new Coordinate(63.47474487486235, 10.308609008789062));
//		    final Polygon polygon = gf.createPolygon(new LinearRing(new CoordinateArraySequence(points
//		        .toArray(new Coordinate[points.size()])), gf), null);
//		    		    
//		    System.out.println("polygon's SRID: " + polygon.getSRID());
//		    
//		    List<Citynode> list = null;
//		    try{
//		    	System.out.println("in try...");
//		    	list = findByCriteria(Restrictions.eq("category", "Hotel"),SpatialRestrictions.within("location",polygon));
////		    	list = findByCriteria(Restrictions.eq("category", "Hotel"),SpatialRestrictions.within("location",c.getIntrestField()));
//		    } catch (Exception e) {
//		    	System.out.println("CRASH! \n ");
//		    	e.printStackTrace();
//		    }
//
//			System.out.println("Size of list: " + list.size());
//			if(list.size()>0)
//				System.out.println("Hotel SRID: " + list.get(0).getLocation().getSRID());
//			return list;
//			
////			return findByCriteria(Restrictions.eq("category", "Hotel"),SpatialRestrictions.within("location",c.getIntrestField()));
//		}
//	}

}
