package matrixPacket;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;

import Jama.Matrix;

public class RecommenderInputHandler {
	
	public static ArrayList<User> readUserMovieLensData(String arg) {
		ArrayList<User> userList = new ArrayList<User>();
		File file = new File(arg);
	    FileInputStream fis;
	    BufferedInputStream bis;
	    BufferedReader dis;
	    String nextLine;
	    String[] occupationList = {"administrator","artist","doctor","educator","engineer","entertainment","executive","healthcare","homemaker","lawyer","librarian",
	    		"marketing","none","other","programmer","retired","salesman","scientist","student","technician","writer"};
	    int[] ageGroups = {25,45,65};
	    
	    try {
	      fis = new FileInputStream(file);
	      bis = new BufferedInputStream(fis);
	      dis = new BufferedReader(new InputStreamReader(bis));
	      
	      
	      while ((nextLine = dis.readLine()) != null) {
	    	  User user = new User(new Matrix(new double[6+occupationList.length][1]));
	    	  
	    	  String[] fields = nextLine.split("\\|");
	    	  int age = Integer.parseInt(fields[1]);
	    	  if(age<ageGroups[0]) user.getUserFeatures().set(0, 0, 1.);
	    	  else if(age<ageGroups[1]) user.getUserFeatures().set(1, 0, 1.);
	    	  else if(age<ageGroups[2]) user.getUserFeatures().set(2, 0, 1.);
	    	  else user.getUserFeatures().set(3, 0, 1.);
	    	  
	    	  if(fields[2].equalsIgnoreCase("M")) user.getUserFeatures().set(4, 0, 1.);
	    	  else user.getUserFeatures().set(5, 0, 1.);
	    	  
	    	  for (int i = 0; i < occupationList.length; i++) {
	    		  if(fields[3].equalsIgnoreCase(occupationList[i])){
	    			  user.getUserFeatures().set(6+i, 0, 1.);
	    			  break;
	    		  }
	    	  }
	    	  userList.add(user);
	    	  
	      }

	      fis.close();
	      bis.close();
	      dis.close();

	    } catch (FileNotFoundException e) {
	      e.printStackTrace();
	    } catch (IOException e) {
	      e.printStackTrace();
	    }
	    return userList;
	}
}

