package matrixPacket;

import java.util.ArrayList;

import Jama.Matrix;

public class Test {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
//		double[][] eatingArray = {{0.,0.,0.,1.,1.,1.,1.,1.,0.,0.,0.,0.,0.,0.,0.}};
//		Matrix eatingFilter = new Matrix(eatingArray);
//		double[][] sleepingArray = {{1.,1.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,0.}};
//		Matrix sleepFilter = new Matrix(sleepingArray);
//		double[][] sightsArray = {{0.,0.,0.,0.,0.,0.,0.,0.,1.,1.,1.,1.,0.,0.,0.}};
//		Matrix sightsFilter = new Matrix(sightsArray);
		
		ArrayList<User> users = new ArrayList<User>();
		for (int i = 0; i < 200; i++) {
			users.add(new User(createPseudoUser()));
		}
		ArrayList<Item> items = new ArrayList<Item>();
		for (int i = 0; i < 50; i++) {
			items.add(new Item(createPseudoItem()));
		}
		
		for(int i = 0; i< 1000; i++) {
			int randU = (int) Math.round(Math.random()*199);
			try {
				Thread.sleep(1);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			int randI = (int) Math.round(Math.random()*49);
			Rating r = createRating(users.get(randU), items.get(randI), randI);
			users.get(randU).addRating(r);
		}
		
	    RecommenderAlgorithm rec = new RecommenderAlgorithm(users, items);
	   // rec.createProbabilisticModel();
	    rec.optimizeWeights();
//	    for (int i = 0; i < 5; i++) {
//			for (int j = 0; j <9; j++) {
//				System.out.println("Prediction user "+i+" on item "+j+ ": ");
//				rec.rateItem(i, j);
//			}
//		}
	    rec.rateGetBudgetCorrelation();
	    User temp = users.get(0);
	    System.out.println("Type of user .."+temp.getUserFeatures().get(31, 0)+","+temp.getUserFeatures().get(32, 0)+","+temp.getUserFeatures().get(33, 0));
	    for (Rating ratings : temp.ratings) {
//	    	System.out.println("True rating is "+ratings.rating);
//	    	for (int i = -10; i < 10; i++) {
//	    		System.out.println("Predicted rating is "+rec.calculateProbabilityContinuous((double)i/10., 0, ratings.item)+" for " +(double)i/10.);
//			}
			System.out.println(rec.calculateProbabilityDiscrete(1, 0, ratings.item)+"Actual rating was "+ratings.rating);
		}
	}
	
	public static Matrix createPseudoUser()
	{
		Matrix userM = new Matrix(new double[34][1]);
		double[][] occupationProbabilities = {{.55,.58,.65,.68,.75,.77,.85,.85,.95,1.},{.04,.20,.35,.57,.68,.75,.94,.95,.96,1.},{.01,.20,.25,.27,.28,.35,.40,.95,.96,1.}};
		
		// Set the age according to probabilities
		double rand = Math.random();
		if(rand<3./26.) userM.set(0, 0, 1.);
		else if(rand<14./26.) userM.set(1, 0, 1.);	
		else if(rand<23./26.) userM.set(2, 0, 1.);	
		else userM.set(3, 0, 1.);
		
		// Set the gender
		rand = Math.random();
		if(rand<11./28.) userM.set(4, 0, 1.);
		else userM.set(5, 0, 1.);
		
		// Set location
		rand = Math.random();
		if(rand<18.6/26.3) userM.set(6, 0, 1.);
		else if (rand<20.6/26.3) userM.set(7, 0, 1.);
		else if (rand<21.4/26.3) userM.set(8, 0, 1.);
		else if (rand<23.0/26.3) userM.set(9, 0, 1.);
		else if (rand<23.5/26.3) userM.set(10, 0, 1.);
		else if (rand<24.5/26.3) userM.set(11, 0, 1.);
		else if (rand<24.8/26.3) userM.set(12, 0, 1.);
		else if (rand<25.6/26.3) userM.set(13, 0, 1.);
		else if (rand<25.65/26.3) userM.set(14, 0, 1.);
		else if (rand<25.7/26.3) userM.set(15, 0, 1.);
		else if (rand<26.25/26.3) userM.set(16, 0, 1.);
		else userM.set(17, 0, 1.);
		
		// Set vacation type
		rand = Math.random();
		if(userM.get(0, 0)==1.){
			if(rand<0.4) userM.set(17,0,1.);
			else if (rand<0.8) userM.set(18,0,1.);
			else userM.set(19,0,1.);
		}
		else{
			if(rand<0.02) userM.set(17,0,1.);
			else if (rand<0.65) userM.set(18,0,1.);
			else userM.set(19,0,1.);
		}
		
		// Set occupation
		rand = Math.random();
		int age;
		if(userM.get(0, 0)==1.) age=0;
		else if(userM.get(3, 0)==1.) age = 2;
		else age = 1;
		
		for (int i = 0; i < occupationProbabilities[age].length; i++) {
			if(rand>=occupationProbabilities[age][i]){
				userM.set(19+i, 0, 1.);
				break;
			}
		}
		
		// Set budget
		rand = Math.random();
		if(userM.get(0, 0)==1.){
			if(rand<0.6) userM.set(31,0,1.);
			else if (rand<0.9) userM.set(32,0,1.);
			else userM.set(33,0,1.);
		}
		else{
			if(rand<0.1) userM.set(31,0,1.);
			else if (rand<0.7) userM.set(32,0,1.);
			else userM.set(33,0,1.);
		}
		
		return userM;
	}
	
	public static Matrix createPseudoItem(){
		/*
		 * 0 = Hotel
		 * 1 = Hostel
		 * 2 = Alcohol
		 * 3 = norwegiancouisine
		 * 4 = italiancouisine
		 * 5 = mexicancouisine
		 * 6 = asiancouisine
		 * 7 = fast-food
		 * 8 = nightclub
		 * 9 = artmuseum
		 * 10= othermuseum
		 * 11= architecturallandmark
		 * 
		 */
		
		Matrix itemM = new Matrix(new double[15][1]);
		double rand = Math.random();
		
		// Check if hotel, sightseeing or eating
		if(rand<0.2){
			// Hotel stuff
			if(rand<0.15){
				itemM.set(0, 0, 1.);
				//set budget
				if(rand<0.07){
					itemM.set(12, 0, 1.);
				}
				else if(rand<0.12){
					itemM.set(13, 0, 1.);
				}else itemM.set(14, 0, 1.);
			}
			else{
				itemM.set(1, 0, 1.);
				itemM.set(0, 0, 1.);
			}
			if(rand<0.16)itemM.set(2, 0, 1.);
			if(rand<0.13)itemM.set(3, 0, 1.);
			
		}
		else if (rand<0.4){
			// Eating
			if(rand<0.36)itemM.set(2, 0, 1.);
			if(rand<0.25)itemM.set(3, 0, 1.);
			else if(rand<0.30)itemM.set(4, 0, 1.);
			else if(rand<0.33)itemM.set(5, 0, 1.);
			else if(rand<0.36)itemM.set(6, 0, 1.);
			else itemM.set(7, 0, 1.);
			
			//set budget
			rand = Math.random();
			if(rand<0.22){
				itemM.set(12, 0, 1.);
			}
			else if(rand<0.9){
				itemM.set(13, 0, 1.);
			}else itemM.set(14, 0, 1.);
			
			
		}else {
			// Sightseeing stuff
			if(rand<0.5){
				itemM.set(2, 0, 1.);
				itemM.set(8, 0, 1.);
				//set budget
				if(rand<0.42){
					itemM.set(12, 0, 1.);
				}
				else if(rand<0.48){
					itemM.set(13, 0, 1.);
				}else itemM.set(14, 0, 1.);
			}
			if(rand<0.6)itemM.set(9, 0, 1.);
			else if(rand<0.7)itemM.set(10, 0, 1.);
			else itemM.set(11, 0, 1.);
			
			//set budget
			rand = Math.random();
			if(rand<0.22){
				itemM.set(12, 0, 1.);
			}
			else if(rand<0.9){
				itemM.set(13, 0, 1.);
			}else itemM.set(14, 0, 1.);
		}
		
		return itemM;
	}
	
	public static Rating createRating(User user, Item item, int index){
		double rating = 0.;
		
		//Simple check if budget correlations are caught
		
		if(user.getUserFeatures().get(31, 0)==1.){
			if(item.getItemFeatures().get(12, 0)==1.) rating = 1.0;
			else if(item.getItemFeatures().get(13, 0)==1.) rating = .5;
			else rating = .1;
		}
		if(user.getUserFeatures().get(32, 0)==1.){
			if(item.getItemFeatures().get(12, 0)==1.) rating = .2;
			else if(item.getItemFeatures().get(13, 0)==1.) rating = 1.0;
			else rating = .3;
		}
		if(user.getUserFeatures().get(33, 0)==1.){
			if(item.getItemFeatures().get(12, 0)==1.) rating = .1;
			else if(item.getItemFeatures().get(13, 0)==1.) rating = .4;
			else rating = 1.0;
		}
		
		return new Rating(index, rating);
	}
	
	

}
