package model;

import java.util.List;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;


public class Attribute implements XmlNode {
	
	
	private long id; 

	private Attribute parent; 
	
	private String type;
	
	private String description;
	
	private int level; 

	boolean isLeaf; 
	
	private List <Attribute> childeren; 
	
	public List<Attribute> getChilderen() {
		return childeren;
	}



	public void setChilderen(List<Attribute> childeren) {
		this.childeren = childeren;
	}



	public Attribute()
	{ 
		
	}
	
	
	
	public Attribute (long id,Attribute parent,String type,boolean isRoot,String description,int level)
	{ 
		this.id = id; 
		this.parent = parent; 
		this.type = type; 
		this.isLeaf = isRoot; 
		this.description = description;
		this.level = level;
	}
	
	public long getId() {
		return id;
	}

	public void setId(long id) {
		this.id = id;
	}

	public Attribute getParent() {
		return parent;
	}

	public void setParent(Attribute parent) {
		this.parent = parent;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}
	
	public boolean getisLeaf() {
		return isLeaf;
	}

	public void setisLeaf(boolean isRoot) {
		this.isLeaf = isRoot;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	@Override
	public Node getXmlRepresentation(Document dom) {
		Element attribute; 
		
		if(this.getisLeaf())
			attribute = dom.createElementNS("leaf","attribute"); 
		else 
			attribute = dom.createElement("attribute"); 
		
		attribute.setAttribute("id", String.valueOf(getId()));
		attribute.setAttribute("description", getDescription()); 
		attribute.setAttribute("type", getType()); 
		attribute.setAttribute("level",String.valueOf(getLevel()));
		
		if(this.getParent()!=null)
		{ 
			Element parent = dom.createElement("parent");
			parent.appendChild(getParent().getXmlRepresentation(dom)); 
			attribute.appendChild(parent); 
		}
		
		return attribute; 
	}

	public int getLevel() {
		return level;
	}



	public void setLevel(int level) {
		this.level = level;
	}



	@Override
	public String getNodeType() {
		// TODO Auto-generated method stub
		return "attribute";
	}
	
	
	
}
