package model;

import java.util.ArrayList;
import java.util.List;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class Recommendation implements XmlNode,Comparable<Recommendation> {
	
	
	private long id; 

	//default value (unrated) 
	private int userRating  = -1;  
	
	private int systemRating; 
	
	private int rateChange = 0; 
	
	//distance in meters
	
	private int distanceToUser;  
	
	private Citynode node; 
	
	private String textualExplanation;
	
	private User user; 
	
	private int isTravelPlanRecommendation; 
	
	private List <Rating> selectedRatings = new ArrayList<Rating>(); 

	private boolean isPersonalized  = true;

	private int isProactive  =0; 

	//private List <Rating>  
	

	
	public int getIsProactive() {
		return isProactive;
	}


	public void setIsProactive(int isProactive) {
		this.isProactive = isProactive;
	}


	public boolean isPersonalized() {
		return isPersonalized;
	}


	public void setPersonalized(boolean isPersonalized) {
		this.isPersonalized = isPersonalized;
	}


	public List<Rating> getSelectedRatings() {
		return selectedRatings;
	}


	public void setSelectedRatings(List<Rating> selectedRatings) {
		this.selectedRatings = selectedRatings;
	}


	public String getTextualExplanation() {
		return textualExplanation;
	}


	public void setTextualExplanation(String textualExplanation) {
		this.textualExplanation = textualExplanation;
	}


	public Recommendation() 
	{ 
		
	}


	public long getId() {
		return id;
	}


	public void setId(long id) {
		this.id = id;
	}


	public int getUserRating() {
		return userRating;
	}


	public void setUserRating(int userRating) {
		this.userRating = userRating;
	}


	public int getSystemRating() {
		return systemRating;
	}


	public void setSystemRating(int systemRating) {
		this.systemRating = systemRating;
	}


	public Citynode getNode() {
		return node;
	}


	public void setNode(Citynode node) {
		this.node = node;
	}

	
	public int getRateChange() {
		return rateChange;
	}


	public void setRateChange(int rateChange) {
		this.rateChange = rateChange;
	}


	public User getUser() {
		return user;
	}


	public void setUser(User user) {
		this.user = user;
	}
	
	public double getDistanceToUser() {
		return distanceToUser;
	}


	public void setDistanceToUser(int distanceToUser) {
		this.distanceToUser = distanceToUser;
	}
	
	
	public int getIsTravelPlanRecommendation() {
		return isTravelPlanRecommendation;
	}


	public void setIsTravelPlanRecommendation(int isTravelPlanRecommendation) {
		this.isTravelPlanRecommendation = isTravelPlanRecommendation;
	}

	@Override
	public Node getXmlRepresentation(Document dom) {
		
		Element rec = dom.createElement("recommendation"); 
		rec.setAttribute("systemrating", String.valueOf(this.getSystemRating()));
		rec.setAttribute("textualdescription", String.valueOf(this.getTextualExplanation()));  
		rec.setAttribute("id",String.valueOf(this.id)); 
		rec.setAttribute("userrating",String.valueOf(userRating)); 
		rec.setAttribute("ratechange", String.valueOf(rateChange)); 
		rec.setAttribute("distance", String.valueOf(getDistanceToUser())); 
		rec.setAttribute("istravelPlanRecommendation", String.valueOf(getIsTravelPlanRecommendation()));
		rec.setAttribute("ispersonalized",String.valueOf(this.isPersonalized));
		rec.setAttribute("isproactive", String.valueOf(this.isProactive));
		rec.appendChild(this.node.getXmlRepresentation(dom)); 
		
		Element ratings = dom.createElement("ratings"); 
		if(this.selectedRatings!=null)
		{
			for(Rating rateing : this.selectedRatings)
			{
				ratings.appendChild(rateing.getXmlRepresentation(dom));
			}
		}
		
		rec.appendChild(ratings); 
		
		
			
		return rec; 
		
	}


	@Override
	public String getNodeType() {
		// TODO Auto-generated method stub
		return "recommendation"; 
	}


	@Override
	public int compareTo(Recommendation o) {
		if(o.getSystemRating()>this.getSystemRating())
			return -1;
		else if(o.getSystemRating()<this.getSystemRating())
			return 1; 
		else 
			return 0;
	}
	
	
	
}
