package model;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

import Jama.Matrix;


public class User implements XmlNode{

	private long id; 
	
	private String username; 
	
	private String password; 
	
	private UserModel userModel;  

	private Set<Visit> visits; 
	
	private Visit currentVisit; 
	
	private Set <Recommendation> currentRecommendations; 
	
	private Set <Recommendation> travelPlan; 

	public Set <Rating> ratings = new HashSet<Rating>();
	
	public ArrayList <Rating> userRatings = new ArrayList<Rating>(); 
	
	public ArrayList<Rating> getUserRatings() {
		return userRatings;
	}

	public void setUserRatings(ArrayList<Rating> userRatings) {
		this.userRatings = userRatings;
	}



	private Date recivedTravelPlan; 

	private List <Recommendation> ratetedSet; 
	
	private String userFeatures;
	
	private Matrix userMatrix;
	
	
	public Matrix getUserMatrix() {
		return userMatrix;
	}

	public void setUserMatrix(Matrix userMatrix) {
		this.userMatrix = userMatrix;
	}
	
	public String getUserFeatures() {
		return userFeatures;
	}

	public void setUserFeatures(String userFeatures) {
		this.userFeatures = userFeatures;
	}

	public List<Recommendation> getRatetedSet() {
		return ratetedSet;
	}



	public void setRatetedSet(List<Recommendation> ratetedSet) {
		this.ratetedSet = ratetedSet;
	}



	public Set<Rating> getRatings() {
		return ratings;
	}
	
	public void addRating(Rating r){
		this.ratings.add(r);
	}



	public void setRatings(Set<Rating> ratings) {
		this.ratings = ratings;
	}

	
	
	
	public Date getRecivedTravelPlan() {
		return recivedTravelPlan;
	}



	public void setRecivedTravelPlan(Date recivedTravelPlan) {
		this.recivedTravelPlan = recivedTravelPlan;
	}



	public Visit getCurrentVisit() {
		return currentVisit;
	}



	public void setCurrentVisit(Visit currentVisit) {
		this.currentVisit = currentVisit;
	}



	public User() 
	{ 
		
	}
	
	
	public Rating getRating(Citynode n)
	{
		for(Rating r : this.ratings)
		{
			System.out.println(r.getCitynode().getTitle() + " "+ n.getTitle());
			if(r.getCitynode().getId()==n.getId())
			{
				System.out.println("kommer faktisk inn her ogs");
				return r; 
			}
		}
		
		return null; 
	}
	
	
	
	public UserModel getUserModel() {
		return userModel;
	}

	public void setUserModel(UserModel userModel) {
		this.userModel = userModel;
	}

	public long getId() {
		return id;
	}

	public void setId(long id) {
		this.id = id;
	}

	public String getUsername() {
		return username;
	}

	public void setUsername(String username) {
		this.username = username;
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}
	
	public Set<Visit> getVisits() {
		return visits;
	}



	public void setVisits(Set<Visit> visits) {
		this.visits = visits;
	}
	
	
	public Set<Recommendation> getCurrentRecommendations() {
		return currentRecommendations;
	}



	public void setCurrentRecommendations(
			Set<Recommendation> currentRecommendations) {
		this.currentRecommendations = currentRecommendations;
	}
	
	public Set<Recommendation> getTravelPlan() {
		return travelPlan;
	}



	public void setTravelPlan(Set<Recommendation> travelPlan) {
		this.travelPlan = travelPlan;
	}



	@Override
	public String getNodeType() {
		// TODO Auto-generated method stub
		return null;
	}



	@Override
	public Node getXmlRepresentation(Document dom) {
		
		
		Element user = dom.createElement("user"); 
		Element ratings = dom.createElement("ratings");
		
		user.setAttribute("id", String.valueOf(id)); 
		
		for(Rating r: this.ratings)
		{
			ratings.appendChild(r.getXmlRepresentation(dom)); 
		}

		user.appendChild(ratings); 
		
		return user;
	}

	public boolean isEqual(User us){
//		System.out.println("Checking: " + this.getUsername() + " VS " + us.getUsername());
		if (this.getUsername().equals(us.getUsername())){
//			System.out.println("Equal");
			return true;
		} else {
//			System.out.println("Not equal");
			return false;
		}
	}

	
}
