package model;

import java.util.List;
import java.util.Set;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class UserModel implements XmlNode
{
	

	private long id; 
	
	private Set<Preference> preferences;
	



	public long getId() {
		return id;
	}

	public void setId(long id) {
		this.id = id;
	}

	public Set<Preference> getPreferences() {
		return preferences;
	}

	public void setPreferences(Set<Preference> preferences) {
		this.preferences = preferences;
	} 


	@Override
	public String getNodeType() {
		return "usermodel";
	}

	@Override
	public Node getXmlRepresentation(Document dom) {
		
		Element userModelXmlElement = dom.createElement("usermodel"); 
		userModelXmlElement.setAttribute("id", String.valueOf(getId()));
		
		Element preflist = dom.createElement("preferences"); 
		
		for (Preference p : getPreferences())
		{ 
			preflist.appendChild(p.getXmlRepresentation(dom));
		}
		
		userModelXmlElement.appendChild(preflist); 
		
		return userModelXmlElement;
	}
	
	public boolean hasPrefernce(long attributeId)
	{ 
		for(Preference p : this.preferences)
		{ 
			if(p.getAttribute().getId()==attributeId)
			{ 
				return true; 
			}
		}
		return false; 
	}
	
	
	public Preference getPreferenceByAttributeId(long attributeId)
	{ 
		for(Preference p : this.preferences)
		{ 
			if(p.getAttribute().getId()==attributeId)
			{ 
				return p;  
			}
		}
		return null; 
	}
	
}
