package recommendersystem;

import java.util.HashMap;
import java.util.List;

import model.Citynode;
import model.Context;
import model.Rating;
import model.Recommendation;
import model.User;
import model.UserModel;

import org.w3c.dom.Document;

import com.vividsolutions.jts.geom.Point;

public interface RecommenderSystem {

	/*
	 * Returns a complete travel plan 
	 */
	public List<Recommendation> getTravelPlan(User user, Context context);
	
	/*
	 * Returns true or false depending on whether the removal was successful 
	 */
	public boolean removeTravelPlan(User user); 
	
	
	public Recommendation addRecommendationToPlan(User user,long recommendationId); 
	
	
	public Recommendation removeRecommendationFromList(User user,long recommendationId); 
	
	
	public List<Recommendation> getRecommendations(User user, Context context, String searchstring, boolean filterOnUserPreferences);
	

	public List <Recommendation> getRecommendationsForSpesificPoint(User u,Point p); 
	
	
	public boolean handleExplicitFeedback(Citynode n,User user,double feeback);
	
	
	public Citynode handleImplicitFeedback(User user,Context context); 
	
	
	public List<Recommendation> handleContextChange(User user,Context context); 
	
	
	public UserModel updateUserModel(HashMap <Long,Double> profileInformation,User user);
	
	
	public UserModel getUserModel(User user); 
	
	
	public User createUser(); 

	
	public List <Citynode> getInitSet(); 
	
	
	public User findUser(Context c,long userId,User u);
	

	
	
	

	
}
