package recommendersystem.impl;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import org.hibernate.dialect.SAPDBDialect;
import org.w3c.dom.Node;

import matrixPacket.RecommenderAlgorithm;
import model.Citynode;
import model.Context;
import model.Rating;
import model.Recommendation;
import model.User;
import model.UserModel;

import Jama.Matrix;
import matrixPacket.RecommenderAlgorithm;
import matrixPacket.Item;
import matrixPacket.matrix;

import com.vividsolutions.jts.geom.Point;
import com.vividsolutions.jts.operation.distance.DistanceOp;

import dao.CitynodeDAO;
import dao.RatingDAO;
import dao.RecommendationDAO;
import dao.UserDAO;
import dao.UserModelDAO;
import dao.VisitDAO;

import recommendersystem.AbstractRecommenderSystem;
import recommendersystem.RecommenderSystem;

public class CollaborativeRecommenderSystem extends AbstractRecommenderSystem {



	private boolean isBinaryFeedback = true; 

	private double correlationTreshhold = 0.5; 


	private HashMap <String,String> explantionTemp = new HashMap<String,String>(); 

	private HashMap <String,Double> diffMap =  new HashMap<String,Double>(); 
	
	// ADDED AI-VARIABLES
	Matrix Sij;
	Matrix Wab;
	ArrayList<matrixPacket.User> users;
	ArrayList<matrixPacket.Item> items;
	double noise=0.8;
	double meanWeight=0.;
	double varianceWeight=0.;
	double tradeoff=.001;
	private double likeliTradeOff=.709;
	int methodology = 4;
	
	

	public CollaborativeRecommenderSystem  (CitynodeDAO cdao,RecommendationDAO rdao,UserDAO udao,UserModelDAO umdao,VisitDAO vdao,RatingDAO ratingdao)
	{ 
		super(cdao,rdao,udao,umdao,vdao,ratingdao); 

	}

	// Ports user, from userFeatures (String) to userMatrix (Matrix)
	public void userPortToMatrix(User us){
		Matrix m = new Matrix(us.getUserFeatures().length(), 1);
		
		for(int x=0; x < us.getUserFeatures().length(); x++){
			if (us.getUserFeatures().substring(x, x+1).equals("1")){
				m.set(x, 0, 1);
			}
		}
		
//		// Print user matrix
//		for(int i=0; i<m.getRowDimension(); i++){
//			System.out.println("Usermatrix at " + i + ": " + m.get(i, 0));
//		}
		
		us.setUserMatrix(m);
	}
	
	
	// Ports item, from itemFeatures (String) to itemMatrix (Matrix)
	public void itemPortToMatrix(Citynode cn){
		Matrix m = new Matrix(cn.getItemFeatures().length(), 1);
		
		for(int x=0; x < cn.getItemFeatures().length(); x++){
			if (cn.getItemFeatures().substring(x, x+1).equals("1")){
				m.set(x, 0, 1);
			}
		}
		
//		// Print item matrix
//		for(int i=0; i<m.getRowDimension(); i++){
//			System.out.println("Itemsmatrix at " + i + ": " + m.get(i, 0));
//		}
		
		cn.setItemMatrix(m);
	}
	

	//private HashMap <Citynode,List<User>> buildUserRatingMap(List <Citynode> nodes,User u)

	protected List<Recommendation> buildRecommendationList(List <Citynode> nodes,User u,Context c)
	{

		HashMap <Citynode,List<User>> userRatings = getNodeUserMap(nodes,u); 


		List <Recommendation> returnRecommendation = new ArrayList<Recommendation>();

		System.out.println("kommer inn her");
		
		if(methodology > 10){
			// Gr gjennom alle citynodes(?), og legger de til i en liste med Citynode og ratings(?)
			for(Citynode n:userRatings.keySet())
			{ 

				Recommendation newRec = new Recommendation();

				newRec.setNode(n); 

				double rating = 0; 
				int numberOfraters = 0; 

				List <Rating> selected = null;

				for(User user :userRatings.get(n))
				{
					Rating r =  user.getRating(n);

					if(r!=null)
					{
						r.setUserId(user.getId());
						if(	newRec.getSelectedRatings()!=null)
							newRec.getSelectedRatings().add(r); 
						else 
						{
							ArrayList <Rating> rs = new ArrayList<Rating>(); 
							rs.add(r); 
							newRec.setSelectedRatings(rs);
						}
						rating+=r.getRating(); 
						numberOfraters++; 
						if(user.getRating(n).getRating()>0.7 && selected==null)
						{
							selected = this.getRatingsInArea(user.getRatings(),n, c); 
						}
					}
				}




				newRec.setTextualExplanation("Recommended to you because of high average rating from "+ numberOfraters +" users that have rated places like " + this.explantionTemp.get(n.getCategory()) +" similarly as you"); 
				newRec.setSelectedRatings(selected);
				newRec.setSystemRating((int)((rating/numberOfraters)*100)); 
				
				if(rating>0.7)
				{
					returnRecommendation.add(newRec);
				}
				//	else 
				//	{
				//	}
			}
		} else {
			System.out.println("Getting recommendations with upgrading AI");  // Currently only get one Recommendation. Could get more by running the recommendations algorithm several times, but a lot of time so is not currently implemented. Alternative should be found
			
			// Creation and conversion of necessary entities
			ArrayList<matrixPacket.User> userList = new ArrayList<matrixPacket.User>();
			Set<matrixPacket.User> tempUserList = new HashSet<matrixPacket.User>();
			ArrayList<Item> itemList = new ArrayList<Item>();
			
			// Get Citynodes/Items
			System.out.println("Getting items...");
			for(Citynode node : nodes){
				// Get features from node and create an AI-Item based on those
//				items.add(new matrixPacket.Item(node.getItemMatrix()));
				
				itemPortToMatrix(node);
				
				matrixPacket.Item it = new matrixPacket.Item(node.getItemMatrix());
				it.setCitynode(node);
				
				itemList.add(it);
			}
			
			
			// Get users
			System.out.println("Getting users...");
			for(Citynode node : nodes)
			{
				
				Set <User> raters = node.getRaters(); 
				for(User rater : raters)
				{
					// Get features from user and create an AI-User based on those
					userPortToMatrix(rater);
					
					matrixPacket.User mUser = new matrixPacket.User();
					mUser.setUserFeatures(rater.getUserMatrix());
					mUser.modelUser = rater;
					
					// Convert ratings
					for(Rating r : rater.ratings){
						int item = 0;
						
						// Search for index of Item/Citynode
						for(Item it : itemList){
							if(it.getCitynode().getLocation().equals(r.getCitynode().getLocation())){
								item = itemList.indexOf(it);
								it.setItem(item);
								System.out.println("item: " + item);
								break;
							}
						}
						
						double rating = r.getRating();
						
						System.out.println("Adding rating: " + rating);
						mUser.addRating(new matrixPacket.Rating(item, rating));
					}
					
					// Add user if not already in the list
					boolean isPresent = false;
					for(matrixPacket.User user : userList){
						if (user.modelUser!=null){
							if (user.modelUser.isEqual(mUser.modelUser)){
								isPresent = true;
								break;
							}
						}
					}
					
					if (!isPresent){
						userList.add(mUser);
					}
					
					
					
					
				}
			}
			
			System.out.println("Size of userList: " + userList.size());
			System.out.println("Size of itemList: " + itemList.size());
			
			

			RecommenderAlgorithm rec = new RecommenderAlgorithm(userList, itemList);

			rec.optimizeWeights();



			// Traverse users
			for (int i = 0; i < userList.size(); i++) {
				// Traverse items
				for (int j = 0; j < itemList.size(); j++) {
					System.out.println("Prediction user "+i+" on item "+j+ ": ");
					rec.rateItem(i, j);
				}
			}

			rec.rateGetBudgetCorrelation();
			matrixPacket.User temp = userList.get(0);
			for (matrixPacket.Rating ratings : temp.ratings) {
				System.out.println("True rating is "+ratings.rating);
				for (int i = -10; i < 10; i++) {
					System.out.println("Predicted rating is "+rec.calculateProbabilityContinuous((double)i/10., 0, ratings.item)+" for " +(double)i/10.);
				}
				System.out.println(rec.calculateProbabilityDiscrete(1, 0, ratings.item)+"Actual rating was "+ratings.rating);
			}
			
			RatingComparator rc = new RatingComparator();
			Collections.sort(temp.ratings, rc);
			
			// Find highest rating
			double highestScore = 0;
			int itemWHS = 0;
			for(matrixPacket.Rating r : temp.ratings) {
				if(r.rating>highestScore){
					highestScore = r.rating;
					itemWHS = r.item;
				}
			}
			
			Citynode recCN = new Citynode();
			// Find corresponding Citynode
			for(Item it : itemList){
				if(it.getItem()==itemWHS){
					recCN = it.getCitynode();
				}
			}
			
			Recommendation rr = new Recommendation();
			rr.setNode(recCN);
			returnRecommendation.add(rr);
			
			System.out.println("Recommended CN Title:" + recCN.getTitle());

			// Code for several items when applicable
			//			System.out.println("List size" + temp.ratings.size());
			//			
			//			int numberOfRecommendationsToBeSent = 6;
			//			for(int i=0; i<numberOfRecommendationsToBeSent; i++){
			//				try{
			//					Citynode recCN = new Citynode();
			//					// Find corresponding Citynode
			//					for(Item it : itemList){
			//						if(it.getItem()==temp.ratings.get(i).item){
			//							recCN = it.getCitynode();
			//						}
			//					}
			//
			//
			//					Recommendation rr = new Recommendation();
			//					rr.setNode(recCN);
			//
			//					returnRecommendation.add(rr);
			//
			//
			//					System.out.println("Recommended CN Title:" + recCN.getTitle());
			//				} catch (IndexOutOfBoundsException e){
			//					
			//				}
			//			}
		}

		Collections.sort(returnRecommendation); 

		List <Recommendation> retur = new ArrayList<Recommendation>(); 


		int numberToReturn = returnRecommendation.size()>3?3:returnRecommendation.size();

		for(int i=0;i<numberToReturn;i++)
		{
			retur.add(returnRecommendation.get(returnRecommendation.size()-1-i)); 
		}

		return retur;


		//	return userRatings; 
	}


	private HashMap <Citynode,List<User>>  getNodeUserMap(List<Citynode> nodes,User u)
	{

		HashMap <Citynode,List<User>> userRatings = new  HashMap <Citynode,List<User>>();

		for(Citynode node : nodes)
		{
			Set <User> raters = node.getRaters(); 
			for(User rater : raters)
			{
				double correlation = computeSim(rater,u); 
				if(true)
				{
					if((rater.getId()!=u.getId()))
					{
						if(userRatings.get(node)!=null)
						{
							userRatings.get(node).add(rater);  
						}
						else 
						{
							ArrayList<User> list = new ArrayList<User>(); 
							list.add(rater); 
							userRatings.put(node, list); 
						}

					}
				}	
			}

		}

		return userRatings;
	}


	private double computeMean(Set <Rating> ratins)
	{
		double mean = 0; 

		for(Rating rating:ratins)
		{
			mean+=rating.getRating();  
		}

		return mean/ratins.size(); 
	}



	private double computeSim(User a,User b)
	{
		Set <Rating> setU = a.getRatings().size()>b.getRatings().size()?a.getRatings():b.getRatings();
		Set <Rating> setV = setU.equals(a.getRatings())?b.getRatings():a.getRatings(); 


		HashMap<Double,String> explantion = new HashMap<Double,String>(); 


		double differnce = 0.0;
		double minDiff = 100000000; 

		int numberOfSimilar = 0; 

		for(Rating Ri : setU)
		{
			for(Rating Rj : setV)
			{
				if(Rj.getCitynode().getId()==Ri.getCitynode().getId())
				{
					differnce=+Math.abs(((Ri.getRating()-Rj.getRating())));
					explantion.put(Math.abs(Ri.getRating()-Rj.getRating()), Rj.getCitynode().getTitle()); 


					double max = Ri.getRating()+Rj.getRating(); 

					System.out.println("hva er dette:" + this.explantionTemp.get(Rj.getCitynode().getCategory()));

					if(!this.explantionTemp.containsValue(Rj.getCitynode().getCategory()))
					{
						this.explantionTemp.put(Rj.getCitynode().getCategory(),Rj.getCitynode().getTitle());
						this.diffMap.put(Rj.getCitynode().getTitle(),max);
						System.out.println("kommer inne her");
					}	//explantionTemp.put(Rj.getCitynode().getTitle(),1); 
					else 
					{
						this.diffMap.put(Rj.getCitynode().getTitle(),max);
						double diff = this.diffMap.get(this.explantionTemp.get(Rj.getCitynode().getCategory()));
						if(max>diff)
						{
							this.explantionTemp.put(Rj.getCitynode().getCategory(), Rj.getCitynode().getTitle());
						}
					}

				}
			}

		}


		return differnce; 


	}


	private double computeSim2(User a,User b)
	{

		Set <Rating> setU = a.getRatings().size()>b.getRatings().size()?a.getRatings():b.getRatings();
		Set <Rating> setV = setU.equals(a.getRatings())?b.getRatings():a.getRatings(); 

		double sdevU = computeStandardDeviation(setU);
		double sdevV = computeStandardDeviation(setV);





		double meanU = computeMean(setU);
		double meanV =  computeMean(setV);
		double sum = 0; 


		for(Rating Ri : setU)
		{
			for(Rating Rj : setV)
			{
				if(Rj.getCitynode().getId()==Ri.getCitynode().getId())
				{
					sum=+(Ri.getRating()-meanU)*(Rj.getRating()-meanV);
					//explantionTemp.put(Rj.getCitynode().getTitle(),1); ;
				}
			}

		}



		if(sdevU*sdevV!=0)
			return sum/(sdevU*sdevV); 
		else 
			return 0;

	}



	private double computeStandardDeviation(Set <Rating> ratings)
	{

		double mean = computeMean(ratings); 
		double dev = 0; 

		for(Rating rating:ratings)
		{
			dev+=Math.pow((rating.getRating()-mean),2.0); 
		}


		return Math.sqrt(dev/ratings.size());
	}






	//find citynodes 	

	public List <Recommendation> findRecommendationsFromUserRating(Context c,long userId,User u)
	{ 

		u.setCurrentRecommendations(new HashSet<Recommendation>()); 




		User userOfIntrest = udao.findByID(userId, false); 

		Set <Rating> ratings = userOfIntrest.getRatings(); 

		List <Recommendation> recommendations = new ArrayList<Recommendation>();  

		for(Rating r : ratings)
		{

			Recommendation newRec = new Recommendation();

			//newRec.setSystemRating(90); 
			//newRec.setTextualExplanation("Average rating from " + (((int)Math.random()+1)*10)+ " users");

			newRec.setPersonalized(false); 
			newRec.setNode(r.getCitynode()); 
			recommendations.add(newRec);

		}
		for(Recommendation r : recommendations)
		{
			u.getCurrentRecommendations().add(r);

		}

		for(Recommendation r : recommendations)
		{

			r.setUser(u); 
			rdao.makePersistent(r);
		}

		for(Recommendation r : recommendations)
		{

			Citynode n = r.getNode();
			double distance = DistanceOp.distance(c.getUserLocation(),r.getNode().getLocation());

			r.setDistanceToUser((int)(distance*100.0*1000.0)); 

			if(n.getRaters()!=null)
			{
				double sumRating = 0.0;
				int number = 0;
				for(User userRating : n.getRaters())
				{
					if(userRating.getRating(n)!=null)
					{
						number++;
						sumRating+=userRating.getRating(n).getRating();
					}	

				}

				r.setSystemRating((int)((sumRating/number)*100));
				r.setTextualExplanation("Average rating from " + number + " users");
				r.setPersonalized(true);
			}

		}





		return recommendations; 
	}



	public User findUser(Context c,long userId,User u) {

		User userOfIntrest = udao.findByID(userId, false); 

		Set returnRatings = new HashSet<Rating>();

		for(Rating rating : userOfIntrest.getRatings())
		{
			rating.setUserId(userOfIntrest.getId());
			double distance = DistanceOp.distance(c.getUserLocation(),rating.getCitynode().getLocation())*(100.0*1000.0);
			if(distance<10000)
				returnRatings.add(rating); 
		}

		userOfIntrest.setRatings(returnRatings);
		//return recommendations; 
		return userOfIntrest;
	}



	@Override
	public List<Recommendation> getRecommendationsForSpesificPoint(User u,
			Point p) {
		// TODO Auto-generated method stub
		return null;
	}



	@Override
	public UserModel getUserModel(User user) {
		// TODO Auto-generated method stub
		return null;
	}



	// #FEEDBACK
	public boolean handleExplicitFeedback(Citynode cityNode,
			User user,double feedback) {

		User u = udao.findByID(user.getId(),false); 


		cityNode = cdao.findByID(cityNode.getId(), false); 

		for(Rating rating : u.getRatings())
		{
			if(cityNode.getId()==rating.getId())
			{
				rating.setRating(feedback); 
				this.ratingdao.makePersistent(rating); 
				return true; 
			}
		}

		Rating newRating = new Rating(); 

		newRating.setCitynode(
				cityNode);
		newRating.setRating(feedback); 
		newRating.setUserId(user.getId()); 

		ratingdao.makePersistent(newRating); 


		cityNode.getRaters().add(u); 

		cdao.makePersistent(
				cityNode); 

		u.getRatings().add(newRating); 

		udao.makePersistent(u); 

		//Rating r = new 

		return true;
	}

	@Override
	public UserModel updateUserModel(
			HashMap<Long, Double> attributeIdProbValueMap, User user) {
		// TODO Auto-generated method stub
		return null;
	}


	// ADDED AI-CODE

//
//	public void createProbabilisticModel()
//	{
//		if(users.size()<1 || items.size()<1) return;
//		int uRow = users.get(0).getUserFeatures().getRowDimension();
//		int iRow = items.get(0).getItemFeatures().getRowDimension();
//		int dim = uRow*iRow;
//		
//		Matrix A = new Matrix(dim, dim);
//	    for (int i = 0; i < users.size(); i++) {
//	    	Matrix uZ = new Matrix(iRow,1);
//	    	for (int j = 0; j < users.get(i).getRatings().size(); j++) {
//				uZ = uZ.plus(items.get(users.get(i).getRatings().get(j).item).getItemFeatures());
//				if(i==4) uZ.print(iRow, 1);
//			}
//	    	uZ = uZ.times(1./(double)users.get(i).getRatings().size());
//	    	//if(i==4) uZ.print(iRow, 1);
//			for (int j = 0; j < users.get(i).getRatings().size(); j++) {
//				Item item=items.get(users.get(i).getRatings().get(j).item);
//				Matrix temp = item.getItemFeatures().times((item.getItemFeatures().minus(uZ)).transpose());
//				A = A.plus(temp.tensorProduct(users.get(i).getUserFeatures().times(users.get(i).getUserFeatures().transpose())));
//			}
//			//A.print(30, 2);
//		}
//	    Matrix B = new Matrix(dim,1);
//	    for (int i = 0; i < users.size(); i++) {
//	    	Matrix uZ = new Matrix(iRow,1);
//	    	for (int j = 0; j < users.get(i).getRatings().size(); j++) {
//				uZ = uZ.plus(items.get(users.get(i).getRatings().get(j).item).getItemFeatures());
//			}
//	    	uZ = uZ.times(1./(double)users.get(i).getRatings().size());
//			for (int j = 0; j < users.get(i).getRatings().size(); j++) {
//				Item item=items.get(users.get(i).getRatings().get(j).item);
//				Matrix temp = (item.getItemFeatures().minus(uZ)).times(users.get(i).getRatings().get(j).rating);
//				B = B.plus(temp.tensorProduct(users.get(i).getUserFeatures()));
//			}
//		}
//	    
//	    Matrix w = (A.plus((Matrix.identity(dim, dim).times(tradeoff/2.)))).inverse().times(B);
//	    
//	    
//	    // Calculate probable score
//	    Wab=w;
//	    
//	}
//	
//	public void optimizeWeights(){
//		if (Wab==null) {
//			Wab=new Matrix(users.get(0).getUserFeatures().getRowDimension(),items.get(0).getItemFeatures().getRowDimension());
//		}
//		System.out.println(Wab.getRowDimension() + " x " + Wab.getColumnDimension());
//		double precision = 0.1;
//		System.out.println("Pre var");
//		updateMeanAndVariance();
//		System.out.println("Post var");
//		double newE=999999.;
//		double oldE =1000.;
//		double gradient;
//		double temp = 0.;
//		double lastTemp = 999.;
//		Matrix oldW;
//		double flip = 1.0;
//		int iterations = 0;
//		//int[] shuffle = new int[users.size()];
//		do{
//			
//			
//			oldE=newE;
//			System.out.println("Pre like");
//			newE=likelihoodFunctionC();
//			System.out.println("likelihood is now "+newE);
//			oldW=Wab.copy();
//			for(int b = 0; b<Wab.getRowDimension();b++) {
//				for(int a = 0; a<Wab.getColumnDimension();a++) {
////					System.out.println("Pre-gradient");
//					gradient = Wab.get(b, a)*(1./likeliTradeOff);
////					System.out.println("Post-gradient");
//					for (int i = 0; i < users.size(); i++) {
//						matrixPacket.User user = users.get(i);
//						for (matrixPacket.Rating rating : user.getRatings()) {
//							//double sij = calculateSijAlt(i, rating.item);
//							//double derived = (sij*sij-rating.rating*rating.rating)/((sij*sij)*(noise*noise));
//							//double derived = (-(Math.E*rating.rating)/(Math.exp(rating.rating*sij)+Math.E));
//							double derived = (Wab.getArray()[b][a]*(1./likeliTradeOff))-getDerivedC(rating.rating, i ,rating.item);
//							matrixPacket.Item it = items.get(rating.item);
//							gradient -= derived*user.getUserFeatures().get(b, 0)*it.getItemFeatures().get(a, 0);
//							//Matrix minusPart = (items.get(rating.item).getItemFeatures().tensorProduct(user.getUserFeatures())).times(derived);
//						}
//					}
//					Wab.getArray()[b][a]=Wab.get(b,a)-(gradient*0.00000004*newE);
//				}
//				
//				
//			}
//			System.out.println("!");
//			
//			
//			temp = 0.;
//			double temp2 = 0.;
//			
//			updateMeanAndVariance();
//			for(int i = 0;i<oldW.getRowDimension();i++)
//			{
//				temp+=Math.abs(oldW.get(i, 0)-Wab.get(i, 0));
//			}
//			for(int i = 0;i<oldW.getRowDimension();i++)
//			{
//				temp2+=Wab.get(i, 0);
//			}
//			System.out.println("Difference is "+temp+" and the average weight is now "+temp2);
//			iterations++;
//			if(lastTemp<temp) flip*=-1.;
//			lastTemp=temp;
//		}while(newE<oldE&&iterations<10000);
//		
//	}
//	
//private double getDerivedC(double r, int i, int j) {
//		
//		return (calculateSij(i, j)-r)/(noise*noise);
//		
//	}
//	private double getDerivedD(double r, int i, int j) {
//		return r*(1-calculateProbabilityDiscrete(r, i, j));
//		
//	}
//	private double likelihoodFunctionC(){
//		double tempW=0.;
//		for (int i = 0; i < Wab.getRowDimension(); i++) {
//			for (int j = 0; j < Wab.getColumnDimension(); j++) {
//				tempW+=Math.pow(Wab.getArray()[i][j], 2);
//			}
//			
//		}
//		tempW*=(1./(2.*likeliTradeOff));
//		double returnValue = 0.;
//		for(int i = 0;i<users.size();i++){
//			for (matrixPacket.Rating r : users.get(i).getRatings()) {
//				double indicator=calculateSij(i, r.item);
//				returnValue +=(- (Math.pow(r.rating-indicator, 2)/(2*noise*noise))-0.5*Math.log(2*Math.PI*noise));
//			}
//		}
//		return tempW-returnValue;
//	}
//	private double likelihoodFunctionD(){
//		double returnValue = 0.;
//		for(int i = 0;i<users.size();i++){
//			for (matrixPacket.Rating r : users.get(i).getRatings()) {
//				double indicator=calculateSij(i, r.item);
//				returnValue -= Math.log(1+Math.exp(-r.rating*indicator+1));
//			}
//		}
//		return returnValue;
//	}
//
//
//	private void updateMeanAndVariance(){
//		for (int i = 0; i < Wab.getRowDimension(); i++) {
//			meanWeight+=Wab.getArray()[i][0];
//		}
//		meanWeight/=Wab.getRowDimension();
//		for (int i = 0; i < Wab.getRowDimension(); i++) {
//			varianceWeight+=Math.pow((meanWeight-Wab.getArray()[i][0]),2.);
//		}
//		varianceWeight/=Wab.getRowDimension();
//		//varianceWeight*=varianceWeight;
//	}
//	public double calculateProbabilityContinuous(double rating,int userID,int itemID)
//	{
//		double sij=calculateSij(userID, itemID);
//		//double sij=calculateSij(userID, itemID);
//		return (1./Math.sqrt(2*noise*Math.PI))*Math.exp(-(Math.pow(rating-sij,2))/Math.pow(noise, 2));
//	}
//	public double calculateProbabilityDiscrete(double rating,int userID,int itemID)
//	{
//		double sij=calculateSij(userID, itemID);
//		//Sij=(Wab.transpose()).times(items.get(itemID).getItemFeatures().tensorProduct(users.get(userID).getUserFeatures()));
//		return (1./(1+Math.exp(-rating*sij)));
//	}
//
//
//	public void rateItem(int user,int item)
//	{
//		double predictionPro = calculateProbabilityContinuous(1., user, item);
//		double predictionNeg = calculateProbabilityContinuous(0.1, user, item);
//		System.out.println("The prediction in favor is :" +predictionPro);
//		System.out.println("The prediction against is :" + predictionNeg);
//		System.out.println("Check the indicator: "+calculateSij(user, item));
////		for (int i = -10; i < 10; i+=1) {
////			double prediction = calculateProbabilityContinuous((double)i/10., user, item);
////			System.out.println("Value at "+(double)i/10.+" is "+prediction);
////			
////		}
//	}
//	
//	public void rateGetPredictors()
//	{
//		int counterU = 0;
//		for (int j=0;j<users.size();j++) {
//			String[] ratingList = new String[items.size()];
//			for (int k = 0;k<items.size();k++) {
//				ratingList[k] = "Item "+ k +":" + this.calculateSij(j, k) +" | ";
//			}
//			System.out.println("Ratings user "+j);
//			for(int i = 0;i<ratingList.length;i++){
//				System.out.print(ratingList[i]);
//			}
//			System.out.println("_");
//		}
//	}
//	
//	private double calculateSij(int i, int j){
//		return ((users.get(i).getUserFeatures().transpose().times(Wab)).times(items.get(j).getItemFeatures())).get(0, 0);
//		//return (Wab.transpose().times(users.get(i).getUserFeatures().tensorProduct(items.get(j).getItemFeatures()))).get(0, 0);
//		//return calculateSijAlt(i, j);
//	}
//	private double calculateSijAlt(int i, int j) {
//		double value = 0.;
//		for (int k = 0; k < users.get(i).getUserFeatures().getRowDimension(); k++) {
//			for (int l = 0; l < items.get(j).getItemFeatures().getRowDimension(); l++) {
//				value+=users.get(i).getUserFeatures().get(k, 0)*items.get(j).getItemFeatures().get(l, 0)*Wab.get(k+(l*users.get(k).getUserFeatures().getRowDimension()), 0);
//			}
//		}
//		return value;
//	}
//	
//	public void rateGetBudgetCorrelation()
//	{
//		double[][] uiClassMatrix = new double[3][3];
//		int[][] uiClassMatrixCounter = new int[3][3];
//		String[] simplify = {"low budget","medium budget","high budget"};
//		
//		
//		int budgetClassUser = 0;
//		int budgetClassItem = 0;
//		for (int i=0;i<users.size();i++) {
//			if(users.get(i).getUserFeatures().get(31, 0)==1.) budgetClassUser = 0;
//			else if(users.get(i).getUserFeatures().get(32, 0)==1.) budgetClassUser = 1;
//			else budgetClassUser = 2;	
//			for (matrixPacket.Rating rating : users.get(i).ratings) {
//				
//				Item item = items.get(rating.item);
//				
//				if(item.getItemFeatures().get(12, 0)==1.) budgetClassItem = 0;
//				else if(item.getItemFeatures().get(13, 0)==1.) budgetClassItem = 1;
//				else budgetClassItem = 2;
//				uiClassMatrixCounter[budgetClassUser][budgetClassItem]+=1;
//				uiClassMatrix[budgetClassUser][budgetClassItem]+=calculateProbabilityContinuous(rating.rating, i, rating.item);
//				
//			}
//		}
//		for (int i = 0; i < uiClassMatrix.length; i++) {
//			for (int j = 0; j < uiClassMatrix[i].length; j++) {
//				System.out.println(simplify[i]+" user and "+simplify[j]+ " item scores "+uiClassMatrix[i][j]/(double)uiClassMatrixCounter[i][j]);
//			}
//			
//		}
//	}
	
	
	
	
	public static Matrix createPseudoUser()
	{
		Matrix userM = new Matrix(new double[34][1]);
		double[][] occupationProbabilities = {{.55,.58,.65,.68,.75,.77,.85,.85,.95,1.},{.04,.20,.35,.57,.68,.75,.94,.95,.96,1.},{.01,.20,.25,.27,.28,.35,.40,.95,.96,1.}};
		
		// Set the age according to probabilities
		double rand = Math.random();
		if(rand<3./26.) userM.set(0, 0, 1.);
		else if(rand<14./26.) userM.set(1, 0, 1.);	
		else if(rand<23./26.) userM.set(2, 0, 1.);	
		else userM.set(3, 0, 1.);
		
		// Set the gender
		rand = Math.random();
		if(rand<11./28.) userM.set(4, 0, 1.);
		else userM.set(5, 0, 1.);
		
		// Set location
		rand = Math.random();
		if(rand<18.6/26.3) userM.set(6, 0, 1.);
		else if (rand<20.6/26.3) userM.set(7, 0, 1.);
		else if (rand<21.4/26.3) userM.set(8, 0, 1.);
		else if (rand<23.0/26.3) userM.set(9, 0, 1.);
		else if (rand<23.5/26.3) userM.set(10, 0, 1.);
		else if (rand<24.5/26.3) userM.set(11, 0, 1.);
		else if (rand<24.8/26.3) userM.set(12, 0, 1.);
		else if (rand<25.6/26.3) userM.set(13, 0, 1.);
		else if (rand<25.65/26.3) userM.set(14, 0, 1.);
		else if (rand<25.7/26.3) userM.set(15, 0, 1.);
		else if (rand<26.25/26.3) userM.set(16, 0, 1.);
		else userM.set(17, 0, 1.);
		
		// Set vacation type
		rand = Math.random();
		if(userM.get(0, 0)==1.){
			if(rand<0.4) userM.set(17,0,1.);
			else if (rand<0.8) userM.set(18,0,1.);
			else userM.set(19,0,1.);
		}
		else{
			if(rand<0.02) userM.set(17,0,1.);
			else if (rand<0.65) userM.set(18,0,1.);
			else userM.set(19,0,1.);
		}
		
		// Set occupation
		rand = Math.random();
		int age;
		if(userM.get(0, 0)==1.) age=0;
		else if(userM.get(3, 0)==1.) age = 2;
		else age = 1;
		
		for (int i = 0; i < occupationProbabilities[age].length; i++) {
			if(rand>=occupationProbabilities[age][i]){
				userM.set(19+i, 0, 1.);
				break;
			}
		}
		
		// Set budget
		rand = Math.random();
		if(userM.get(0, 0)==1.){
			if(rand<0.6) userM.set(31,0,1.);
			else if (rand<0.9) userM.set(32,0,1.);
			else userM.set(33,0,1.);
		}
		else{
			if(rand<0.1) userM.set(31,0,1.);
			else if (rand<0.7) userM.set(32,0,1.);
			else userM.set(33,0,1.);
		}
		
		return userM;
	}
	
	public static Matrix createPseudoItem(){
		/*
		 * 0 = Hotel
		 * 1 = Hostel
		 * 2 = Alcohol
		 * 3 = norwegiancouisine
		 * 4 = italiancouisine
		 * 5 = mexicancouisine
		 * 6 = asiancouisine
		 * 7 = fast-food
		 * 8 = nightclub
		 * 9 = artmuseum
		 * 10= othermuseum
		 * 11= architecturallandmark
		 * 
		 */
		
		Matrix itemM = new Matrix(new double[15][1]);
		double rand = Math.random();
		
		// Check if hotel, sightseeing or eating
		if(rand<0.2){
			// Hotel stuff
			if(rand<0.15){
				itemM.set(0, 0, 1.);
				//set budget
				if(rand<0.07){
					itemM.set(12, 0, 1.);
				}
				else if(rand<0.12){
					itemM.set(13, 0, 1.);
				}else itemM.set(14, 0, 1.);
			}
			else{
				itemM.set(1, 0, 1.);
				itemM.set(0, 0, 1.);
			}
			if(rand<0.16)itemM.set(2, 0, 1.);
			if(rand<0.13)itemM.set(3, 0, 1.);
			
		}
		else if (rand<0.4){
			// Eating
			if(rand<0.36)itemM.set(2, 0, 1.);
			if(rand<0.25)itemM.set(3, 0, 1.);
			else if(rand<0.30)itemM.set(4, 0, 1.);
			else if(rand<0.33)itemM.set(5, 0, 1.);
			else if(rand<0.36)itemM.set(6, 0, 1.);
			else itemM.set(7, 0, 1.);
			
			//set budget
			rand = Math.random();
			if(rand<0.22){
				itemM.set(12, 0, 1.);
			}
			else if(rand<0.9){
				itemM.set(13, 0, 1.);
			}else itemM.set(14, 0, 1.);
			
			
		}else {
			// Sightseeing stuff
			if(rand<0.5){
				itemM.set(2, 0, 1.);
				itemM.set(8, 0, 1.);
				//set budget
				if(rand<0.42){
					itemM.set(12, 0, 1.);
				}
				else if(rand<0.48){
					itemM.set(13, 0, 1.);
				}else itemM.set(14, 0, 1.);
			}
			if(rand<0.6)itemM.set(9, 0, 1.);
			else if(rand<0.7)itemM.set(10, 0, 1.);
			else itemM.set(11, 0, 1.);
			
			//set budget
			rand = Math.random();
			if(rand<0.22){
				itemM.set(12, 0, 1.);
			}
			else if(rand<0.9){
				itemM.set(13, 0, 1.);
			}else itemM.set(14, 0, 1.);
		}
		
		return itemM;
	}
	
	public static matrixPacket.Rating createRating(matrixPacket.User user, Item item, int index){
		double rating = 0.;
		
		//Simple check if budget correlations are caught
		
		if(user.getUserFeatures().get(31, 0)==1.){
			if(item.getItemFeatures().get(12, 0)==1.) rating = 1.0;
			else if(item.getItemFeatures().get(13, 0)==1.) rating = .5;
			else rating = .1;
		}
		if(user.getUserFeatures().get(32, 0)==1.){
			if(item.getItemFeatures().get(12, 0)==1.) rating = .2;
			else if(item.getItemFeatures().get(13, 0)==1.) rating = 1.0;
			else rating = .3;
		}
		if(user.getUserFeatures().get(33, 0)==1.){
			if(item.getItemFeatures().get(12, 0)==1.) rating = .1;
			else if(item.getItemFeatures().get(13, 0)==1.) rating = .4;
			else rating = 1.0;
		}
		
		return new matrixPacket.Rating(index, rating);
	}

}
