package recommendersystem.impl;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.Set;

import com.vividsolutions.jts.geom.Point;

import com.vividsolutions.jts.geom.Geometry;
import com.vividsolutions.jts.io.ParseException;
import com.vividsolutions.jts.io.WKTReader;

import matrixPacket.Item;
import matrixPacket.RecommenderAlgorithm;
import model.Citynode;
import model.Rating;
import model.User;
import Jama.Matrix;

public class Debugging {

	public static void main(String[] arg){
		
		// Create pseudousers
		User u1 = new User();
		u1.setUserFeatures("0100011000000000100100000000000010");
		User u2 = new User();
		u2.setUserFeatures("0100011000000000100100000000000010");
		User u3 = new User();
		u3.setUserFeatures("0100011000000000100100000000000010");
		User u4 = new User();
		u4.setUserFeatures("0100011000000000100100000000000010");
		User u5 = new User();
		u5.setUserFeatures("0100011000000000100100000000000010");
		User u6 = new User();
		u6.setUserFeatures("0100011000000000100100000000000010");
		User u7 = new User();
		u7.setUserFeatures("0100011000000000100100000000000010");
		User u8 = new User();
		u8.setUserFeatures("0100011000000000100100000000000010");
		User u9 = new User();
		u9.setUserFeatures("1000101000000000010000000100000100");
		User u10 = new User();
		u10.setUserFeatures("0010010000010000010000000100000001");
		
		
		
		// Create pseudo-Citynodes
		ArrayList<Citynode> nodes = new ArrayList<Citynode>();
		Citynode c1 = new Citynode();
		c1.setTitle("Burger");
		String wktPoint = "POINT(23.12313 21.23123)";
		//First interpret the WKT string to a point
        WKTReader fromText = new WKTReader();
        Geometry geom = null;
        try {
            geom = fromText.read(wktPoint);
        } catch (ParseException e) {
            throw new RuntimeException("Not a WKT string:" + wktPoint);
        }
        if (!geom.getGeometryType().equals("Point")) {
            throw new RuntimeException("Geometry must be a point. Got a " + geom.getGeometryType());
        }
		c1.setLocation((Point) geom);
		c1.setItemFeatures("00000010000010");
		Set<User> raters1 = new HashSet<User>(); 
		raters1.add(u1);
		raters1.add(u2);
		raters1.add(u3);
		c1.setRaters(raters1);
		
		Citynode c2 = new Citynode();
		c2.setTitle("Burger");
		wktPoint = "POINT(23.12313 21.23123)";
		//First interpret the WKT string to a point
        fromText = new WKTReader();
        geom = null;
        try {
            geom = fromText.read(wktPoint);
        } catch (ParseException e) {
            throw new RuntimeException("Not a WKT string:" + wktPoint);
        }
        if (!geom.getGeometryType().equals("Point")) {
            throw new RuntimeException("Geometry must be a point. Got a " + geom.getGeometryType());
        }
		c2.setLocation((Point) geom);
		c2.setItemFeatures("00000010000010");
		Set<User> raters2 = new HashSet<User>(); 
		raters2.add(u1);
		raters2.add(u2);
		raters2.add(u3);
		c2.setRaters(raters2);
		
		
		Citynode c3 = new Citynode();
		c3.setTitle("Burger");
		wktPoint = "POINT(23.12313 21.23123)";
		//First interpret the WKT string to a point
        fromText = new WKTReader();
        geom = null;
        try {
            geom = fromText.read(wktPoint);
        } catch (ParseException e) {
            throw new RuntimeException("Not a WKT string:" + wktPoint);
        }
        if (!geom.getGeometryType().equals("Point")) {
            throw new RuntimeException("Geometry must be a point. Got a " + geom.getGeometryType());
        }
		c3.setLocation((Point) geom);
		c3.setItemFeatures("00000010000010");
		Set<User> raters3 = new HashSet<User>(); 
		raters3.add(u1);
		raters3.add(u2);
		raters3.add(u3);
		c3.setRaters(raters3);
		
		nodes.add(c1);
		nodes.add(c2);
		nodes.add(c3);
		
		// Add rating #2
		Set <Rating> ur1 = new HashSet<Rating>();
		Rating r1 = new Rating();
		r1.setCitynode(c1);
		r1.setRating(0.6);
		Rating r2 = new Rating();
		r2.setCitynode(c2);
		r2.setRating(0.6);
		Rating r3 = new Rating();
		r3.setCitynode(c3);
		r3.setRating(0.6);
		ur1.add(r1);
		ur1.add(r2);
		ur1.add(r2);
		
		u1.setRatings(ur1);
		u2.setRatings(ur1);
		u3.setRatings(ur1);
		
		
		// Creation and conversion of necessary entities
		ArrayList<matrixPacket.User> userList = new ArrayList<matrixPacket.User>();
		Set<matrixPacket.User> tempUserList = new HashSet<matrixPacket.User>();
		ArrayList<Item> itemList = new ArrayList<Item>();
		
		// Get Citynodes/Items
		System.out.println("Getting items...");
		for(Citynode node : nodes){
			// Get features from node and create an AI-Item based on those
//			items.add(new matrixPacket.Item(node.getItemMatrix()));
			
			itemPortToMatrix(node);
			
			matrixPacket.Item it = new matrixPacket.Item(node.getItemMatrix());
			it.setCitynode(node);
			
			itemList.add(it);
		}
		
		
		// Get users
		System.out.println("Getting users...");
		for(Citynode node : nodes)
		{
			// ITEMS START
			itemPortToMatrix(node);
			
			itemList.add(new matrixPacket.Item(node.getItemMatrix()));
			// ITEMS END
			
			Set <User> raters = node.getRaters(); 
			for(User rater : raters)
			{
				// Get features from user and create an AI-User based on those
//				System.out.println("User " + rater.getUsername() + " has rated " + node.getTitle());
				
//				String userFeat = rater.getUserFeatures();
				
				userPortToMatrix(rater);
				
				matrixPacket.User mUser = new matrixPacket.User();
				mUser.setUserFeatures(rater.getUserMatrix());
				
				System.out.println("mUser...");
				for(int i=0; i<mUser.getUserFeatures().getRowDimension(); i++){
					System.out.println(mUser.getUserFeatures().get(i, 0));
				}
				
				// Convert ratings
				for(Rating r : rater.ratings){
					int item = 0;
					
					// Search for index of Item/Citynode
					for(Item it : itemList){
						if(it.getCitynode().getLocation().equals(r.getCitynode().getLocation())){
							item = itemList.indexOf(it);
							System.out.println("item: " + item);
							break;
						}
					}
					
					double rating = r.getRating();
					
					
					mUser.addRating(new matrixPacket.Rating(item, rating));
				}
				
				userList.add(mUser);
				
				System.out.println("Size of userList: " + userList.size());
				
				
			}
		}
		
		
		 RecommenderAlgorithm rec = new RecommenderAlgorithm(userList, itemList);
		   // rec.createProbabilisticModel();
		    rec.optimizeWeights();
	}
	
	
	
	
	// Ports user, from userFeatures (String) to userMatrix (Matrix)
	public static void userPortToMatrix(User us){
		Matrix m = new Matrix(us.getUserFeatures().length(), 1);
		
		for(int x=0; x < us.getUserFeatures().length(); x++){
			if (us.getUserFeatures().substring(x, x+1).equals("1")){
				m.set(x, 0, 1);
			}
		}
		
		us.setUserMatrix(m);
	}
	
	
	// Ports item, from itemFeatures (String) to itemMatrix (Matrix)
	public static void itemPortToMatrix(Citynode cn){
		Matrix m = new Matrix(cn.getItemFeatures().length(), 1);
		
		for(int x=0; x < cn.getItemFeatures().length(); x++){
			if (cn.getItemFeatures().substring(x, x+1).equals("1")){
				m.set(x, 0, 1);
			}
		}
		
//		// Print item matrix
//		for(int i=0; i<m.getRowDimension(); i++){
//			System.out.println("Itemsmatrix at " + i + ": " + m.get(i, 0));
//		}
		
		cn.setItemMatrix(m);
	}
	
}
