package recommendersystem.impl;

import java.sql.Time;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import model.Attribute;
import model.Citynode;
import model.Context;
import model.Preference;
import model.Rating;
import model.Recommendation;
import model.User;
import model.UserModel;
import model.Visit;

import org.apache.lucene.queryParser.ParseException;
import org.hibernate.Transaction;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

import com.sun.corba.se.impl.corba.TCUtility;
import com.vividsolutions.jts.geom.Point;
import com.vividsolutions.jts.operation.distance.DistanceOp;

import java.sql.Timestamp;

import dao.CitynodeDAO;
import dao.RecommendationDAO;
import dao.UserDAO;
import dao.UserModelDAO;
import dao.VisitDAO;

import recommendersystem.RecommenderSystem;
import util.HibernateUtil;

/*
 * The AI-dummy's approach to recommendations .. . 
 */

/*
 * TODO: With simple inserts and updates of e.g the travel plan, the methods returns a list to recommendations back . This generates unnecessary network traffic. 
 * 		 consider : sending less
 */

public class DummyRecommenderSystem implements RecommenderSystem{

	private CitynodeDAO cdao;  
	
	private RecommendationDAO rdao; 
	
	private UserDAO udao; 
	
	private UserModelDAO umdao; 
	
	private VisitDAO vdao; 
	
	private boolean isBinaryFeedback = true; 
	
	
	public DummyRecommenderSystem(CitynodeDAO cdao,RecommendationDAO rdao,UserDAO udao,UserModelDAO umdao,VisitDAO vdao)
	{ 
		this.cdao = cdao; 
		this.rdao = rdao; 
		this.udao = udao;
		this.umdao = umdao; 
		this.vdao = vdao; 
	}
	
	
	
	public boolean handleExplicitFeedback(long recommendationId,User user,double feedback)
	{ 
		Recommendation recommendation = this.rdao.findByID(recommendationId, true); 
		recommendation.setUserRating((int)feedback); 
		
		this.rdao.makePersistent(recommendation); 
		
		User u = this.udao.findByID(user.getId(), false); 
		
		UserModel userModel = u.getUserModel(); 
		
	
		//update user model
		propagateFeedback(recommendation.getNode().getAttributes(),u,feedback); 

		//calculate new rateing on current recommendations 
		
		return true;//updateRating(u.getCurrentRecommendations(), userModel); 
	
	}
	
	
	/*
	 * TODO:
	 * -     -Make use of context properties for filtering  
	 * 		 -Do filtering based on system prediction 
	 * 		 
	 */
	public List<Recommendation> getRecommendations(User user, Context context, String searchstring, boolean filterOnUserPreferences)
	{
		
		/*
		 * 1)Fetch citynodes based on the key words and location
		 * 2)For all citynodes, fetch recommendations (if any) given to the user for the citynode 
		 * 3)Fetch the user model
		 * 4)Generate a compete set of recommendations with a calculated prediction 
		 * 5)Filter on prediction rating  
		 * 5)Set the filtered sub set as the users current recommendations 
		 * 6)Return list of recommendations  
		 */
		
		List<Citynode> nodes = null; 
		User u = udao.findByID(user.getId(), false); 
		
		UserModel usermodel = u.getUserModel(); 
		
		System.out.println("I Dummy");
		if(searchstring.trim().equals("Restaurant"))
			nodes = cdao.findCitynodesEat(context);
		else if(searchstring.trim().equals("Hotel"))
			nodes = cdao.findCitynodesSleep(context);
		else if(searchstring.trim().equals("Activity"))
			nodes = cdao.findCitynodeExperience(context); 
		else
			nodes  = cdao.findBySearch(searchstring, context); 
		
		System.out.println("I dummy: " + nodes.size());
		
		List freshNodes = new ArrayList<Citynode>(); 
		Set <Recommendation>previouslyRecivedRecommendations = new HashSet<Recommendation>();  
		
		for(Citynode n : nodes)
		{ 
			Recommendation r = rdao.findByUserAndNode(n, u); 
			if(r!=null)
				previouslyRecivedRecommendations.add(r);
			else
				freshNodes.add(n); 
		}
		
		HashMap <Citynode,List<User>> userRatings = new  HashMap <Citynode,List<User>>();
		
		
		//TODO : Handle already received
		for(Citynode node : nodes)
		{
			Set <User> raters = node.getRaters(); 
			for(User rater : raters)
			{
				double correlation = computeSim(rater,u); 
				System.out.println("dette er correlation:" + correlation);
				if((rater.getId()!=u.getId()))
				{
					if(userRatings.get(node)!=null)
					{
						System.out.println("legges til");
						userRatings.get(node).add(user);  
					}
					else 
					{
						ArrayList<User> list = new ArrayList<User>(); 
						list.add(user); 
						userRatings.put(node, list); 
					}
						
				}
					
			}
			
	
		}
		
		
		System.out.println("In DummyRecommenderSystem");
		System.out.println("Nodes: " + nodes.size());
		//List <Recommendation> returnRecommendations = buildRecommendationList(freshNodes, usermodel); 
		List <Recommendation> returnRecommendations = buildRecommendationList(userRatings); 
		///returnRecommendations.addAll(updateRating(previouslyRecivedRecommendations, usermodel)); 
		
		
		u.setCurrentRecommendations(new HashSet<Recommendation>()); 
		
		
		for(Recommendation r : returnRecommendations)
		{
			u.getCurrentRecommendations().add(r);
	
		}
		
		udao.makePersistent(u);
		
		//add user
		for(Recommendation r : returnRecommendations)
		{
			
			r.setUser(u); 
			rdao.makePersistent(r);
		}
		
		//add distance (not persistent information) 
		
		
		for(Recommendation r : returnRecommendations)
		{
			System.out.print("User:" + context.getUserLocation().getX() + " " + context.getUserLocation().getY());
			System.out.println("Hocker:" + r.getNode().getLocation().getX() +" " + r.getNode().getLocation().getY());
			System.out.println("distance:" +DistanceOp.distance(context.getUserLocation(),r.getNode().getLocation()));
			
			double distance = DistanceOp.distance(context.getUserLocation(),r.getNode().getLocation());
			
			r.setDistanceToUser((int)(distance*100.0*1000.0)); 
		}
		
		return returnRecommendations; 
	}
	
	
	

	
	private void propagateFeedback(Set <Attribute> attributes,User user,double feedback)
	{ 
		System.out.println("knall");
		User u = this.udao.findByID(user.getId(), false); 
		
		UserModel userModel = u.getUserModel(); 
		
		//update user model
		for(Attribute a : attributes)
		{ 
			for(Preference p : userModel.getPreferences())
			{ 
				if(p.getAttribute().getId()==a.getId())
				{ 
					p.setProbability(getNewPreference(p.getProbability(),feedback)); 
				}
			}
		}
		
		this.umdao.makePersistent(userModel); 
	}
	
	private List<Recommendation> buildRecommendationList(List <Citynode> nodes, UserModel usermodel)
	{
		List <Recommendation> returnRecommendation = new ArrayList<Recommendation>();
		
		for(Citynode n:nodes)
		{ 
		
				Recommendation newRec = new Recommendation();
				
				newRec.setNode(n); 
				
				double systemRating = calculateSystemRating(usermodel,n); 
			
				newRec.setTextualExplanation(buildTextualExplanation((int)(systemRating*100), n)); 
				
				newRec.setSystemRating((int)(systemRating*100)); 
				
				returnRecommendation.add(newRec);
				
			}
		

		
		return returnRecommendation; 
	}
	
	private double calculateSystemRating(UserModel model, Citynode n)
	{ 
		double sumUserPref = 0; 
		for (Attribute att : n.getAttributes())
		{ 
			sumUserPref+=model.getPreferenceByAttributeId(att.getId()).getProbability(); 
		
		}
		return (sumUserPref/n.getAttributes().size()); 
	}
	
	private List<Recommendation> updateRating(Set <Recommendation> recommendations,UserModel m)
	{
		List <Recommendation> updatetRecList = new ArrayList<Recommendation>();
		for(Recommendation r : recommendations)
		{
			int oldRating = r.getSystemRating(); 
			int newRating = (int)(100*calculateSystemRating(m,r.getNode())); 
			r.setSystemRating(newRating);
			
			if(oldRating==newRating)
			{
				r.setRateChange(0); 
			}
			else if(oldRating>newRating)
			{
				r.setRateChange(-1); 
			}
			else 
			{ 
				r.setRateChange(1); 
			}
			
			rdao.makePersistent(r); 
			updatetRecList.add(r);
		}
		return updatetRecList; 
	}
	
	
	private String buildTextualExplanation(double systemRating,Citynode n)
	{
		String textualExplantion =""; 
		
		String attributes =""; 
		
		Iterator<Attribute> itr = n.getAttributes().iterator();
		Attribute prev = null; 
		while(itr.hasNext())
		{ 
			Attribute a = itr.next(); 
			
			if(itr.hasNext())
				attributes+=a.getParent().getDescription().toLowerCase() +",";
			else
			{ 
				if(prev==null)
					attributes+=a.getParent().getDescription().toLowerCase(); 
				else 
					attributes+=" and " + a.getParent().getDescription().toLowerCase(); 
			}
			
			prev = a; 
		}
		
		if(systemRating>70) 
			textualExplantion+="Average from  " + n.getCategory().toLowerCase()+"s with smiliar " + attributes; 
		else if(systemRating>50)
			textualExplantion+="We predict that may you will like this,based on visting history and feedback on " + n.getCategory().toLowerCase()+"s with smiliar " + attributes;
		else 
			textualExplantion+="We predict you will dislike this,based on your visting history and feedback on " + n.getCategory().toLowerCase()+"s with smiliar " + attributes;
		
		return textualExplantion; 
	}
	
 
	//TODO : Do something better .. 
	private double getNewPreference(double oldPref,double rating)
	{ 
		double returnPref = oldPref; 
		
		if(isBinaryFeedback)
		{
			double dPref = rating==0?-0.1:0.1;  
			returnPref =returnPref + dPref; 
			
			if(returnPref>1)
				returnPref  =1; 
			if(returnPref<0)
				returnPref=0; 
			
			return returnPref; 
		}
		
		return returnPref; 
	}

	
	

	@Override
	public UserModel updateUserModel(HashMap<Long, Double> values, User user) {
	
		UserModel oldModel = user.getUserModel(); 
		
		for (Preference p : oldModel.getPreferences())
		{ 
			if(values.containsKey(p.getAttribute().getId())) 
			{ 
				p.setProbability(values.get(p.getAttribute().getId())); 
			}
		}
		
		this.umdao.makePersistent(oldModel); 
		
		return oldModel; 
		
	}



	@Override
	public UserModel getUserModel(User user) {
		
		User u = udao.findByID(user.getId(),false); 
		
		return u.getUserModel(); 
	}

                                 
	public List<Recommendation> handleContextChange(User user, Context context) {
		
		List <Recommendation> returnList = new ArrayList<Recommendation>(); 
		//if implicit feedback is found ..
		
		user = this.udao.findByID(user.getId(), false); 
		
		if(!context.isCheckingForTravelPlan())
			returnList = checkForRecommendations(user, context); 
		else 
			returnList = checkForTravelPlan(user, context); 
		
		return returnList; 
		 
	}

	/*
	 * If the user has not recvied at travel plan today , generate a new one 
	 * and relate it to the user in db
	 */
	private List<Recommendation> checkForTravelPlan(User user, Context context)
	{ 
		List <Recommendation> returnRecs = new ArrayList<Recommendation>(); 
		Date userTime = new Date(); //TODO: use time from context
		if(user.getRecivedTravelPlan().getDay()!=userTime.getDay())
		{ 
			returnRecs = this.getTravelPlan(user, context); 
		}
		else 
		{
			returnRecs.addAll(user.getTravelPlan()); 
		}
		
		return returnRecs;
		
		
		
	}
	
	

		/*
	 	* TODO : Filter the resulting recommendations on rating (right now we are returning everything) 
	 	* 
	 	* This method serve two  purposes :  1) Find out if it is possible to derive implicit feedback from the users movement 
		 * 									 2) Find out if there are interesting places nearby we can send to the user. 
		 * 							 		
		 */  
	private List<Recommendation> checkForRecommendations(User user, Context context)
	{ 
		List <Recommendation> returnList = new ArrayList<Recommendation>(); 
		
		if(deriveImplicitFeedback(user, context)) 
		{
			//..we should look for new recommendations close to the user  (using radius of 40 meters for testing purposes )
			returnList = buildRecommendationList(cdao.findCityNodeWithin(context.getUserLocation(), 60.0),user.getUserModel());  
			//TODO : filter on  rating .. 
		}
		
		user.setCurrentRecommendations(new HashSet<Recommendation>()); 
		
		
		for(Recommendation r : returnList)
		{
			user.getCurrentRecommendations().add(r);
	
		}
		
		udao.makePersistent(user);
		// .. and add distance (not persistent information) 
		//TODO : This code can be place somewher else , move it .. 
		for(Recommendation r : returnList)
		{
			double distance = DistanceOp.distance(context.getUserLocation(),r.getNode().getLocation());
			r.setDistanceToUser((int)(distance*100.0*1000.0)); 
		}
		
		return returnList; 
	}
	
	
	/* TDOD : Do something cooler 
	 * TODO : Handle more than one "visting nodes"(right now we just pick the first one) 
	if this method manages to derive feedback, it will automatically propagate this to change the users preference model
	*/
	private boolean deriveImplicitFeedback(User user,Context context) 
	{
		
		boolean hasDerivedFeedback = false; 
		
		user = udao.findByID(user.getId(), false); 
		 
		 //TODO : Handle more than one node
		 List <Citynode> l  = cdao.contains(context.getUserLocation()); 
		 
		 Citynode currentNode = l==null?null:l.get(0); 
		 
		 Visit currentVisit = user.getCurrentVisit(); 
		 
		 
		 
		 Date sysTime = new Date(); 
		
			 //Find the approximately spent time and set the visit to null (also generate a feedback )  
			 if(currentNode==null)
			 { 
				 if(currentVisit!=null)
				 {
					 Date arrived = currentVisit.getArrived();
					 
					 //work around (can't seem to store full date, only time stamp)
					 arrived.setDate(sysTime.getDate()); 
					 arrived.setYear(sysTime.getYear());
					 arrived.setMonth(sysTime.getMonth());
					 
					 
					 long vistingTime = currentVisit.getTimeSpent() + (sysTime.getTime()-arrived.getTime()); 
					
					 currentVisit.setTimeSpent(vistingTime); 
					 vdao.makePersistent(currentVisit);
					 //If the user spent more than 10 minutes, we can assume he or she liked it(?)  
					 if(((vistingTime/1000)/60)>0.01)
					 {
						 propagateFeedback(currentVisit.getPlace().getAttributes(), user, 1.0); 
						 hasDerivedFeedback = true; 
					 }
					 user.setCurrentVisit(null); 
					
				 }
				
			}
			 else 
			 {
			
				if(currentVisit!=null)
				{
					
					Date arrived = currentVisit.getArrived();
					 
					 //work around (can't seem to store full date, only time stamp)
					 arrived.setDate(sysTime.getDate()); 
					 arrived.setYear(sysTime.getYear());
					 arrived.setMonth(sysTime.getMonth());
					
					 if(currentNode.getId()==currentVisit.getPlace().getId())
					 {
						 currentVisit.setTimeSpent(sysTime.getTime()-arrived.getTime()); 
						 this.vdao.makePersistent(currentVisit); 
					 }
					 else 
					 {
						 long vistingTime = currentVisit.getTimeSpent(); 
						 if(((vistingTime/1000)/60)>0.1)
						 {
							 propagateFeedback(currentVisit.getPlace().getAttributes(), user, 1.0); 
						 }
						 
						 Visit v = new Visit(); 
						 Date d = new Date();    
						 v.setArrived(new Date());
						 v.setTimeSpent(0);
						 v.setPlace(currentNode); 
						 this.vdao.makePersistent(v); 
						 user.setCurrentVisit(v); 
						
					 }
				}
				else 
				{ 
					 Visit v = new Visit(); 
					 Date d = new Date();    
					 v.setArrived(new java.sql.Date(d.getTime()));
					 v.setTimeSpent(0);
					 v.setPlace(currentNode); 
					 
					 user.setCurrentVisit(v); 
					
					 this.vdao.makePersistent(v); 
				}
			 }
			 
		 udao.makePersistent(user); 
			 
	     return true; 
	}
	
	


	
	
	
/*
 * Recommended travel plan  based on the algorithm presented by 
 * Chien-Chih Yu and Hsiao-ping Chang in Personalized Location-Based Recommendation Services
 * for Tour Planning in Mobile Tourism Applications 2008
 * 
 * Discovered a weakness : It forces movement in a certain direction, TODO: Resolve this
 * 
 * 
 */
	public List<Recommendation> getTravelPlan(User u, Context context)
	{ 
		
		//no activities later than 
		int bedTime = 21; 
		u = udao.findByID(u.getId(), false); 
		
		
		List <Recommendation> travelPlan = new ArrayList<Recommendation>();
		
		List <Recommendation> resturants = getRecommendations(u, context, "Restaurant", true); 
		List <Recommendation> activities= getRecommendations(u, context, "Activity", true); 
		
		
		
		boolean hasDinnerRecommendation = false; 
		boolean hasLunchRecommendation = false; 
		
		Date tempTime = new Date() ;//TODO: use usertime context.getUsertime();
		Point tempLocation = context.getUserLocation(); 
		
		
		int itterations = 0; 
		
		while(tempTime.getHours()<bedTime && itterations<20)
		{ 
			itterations++; 
			System.out.println("Evig lkke" + itterations);
			//if dinner time , and not yet had dinner ->try to find dinner 
			if(tempTime.getHours()>16 && tempTime.getHours()<21 && !hasDinnerRecommendation)
			{ 
				Recommendation dinner = pickRecommendation(tempLocation, resturants); 
				if(dinner!=null && !conationsRecommendation(travelPlan,dinner))
				{ 
					resturants.remove(dinner);
					travelPlan.add(dinner); 
					tempLocation = dinner.getNode().getLocation(); 
					//TODO : Find a better estimate for this 
					tempTime.setHours(tempTime.getHours()+2); 
					
					hasDinnerRecommendation = true; 
					
				}
			}
			if(tempTime.getHours()>11 && tempTime.getHours()<14 && !hasLunchRecommendation)
			{ 
				Recommendation lunch = pickRecommendation(tempLocation, resturants); 
				if(lunch!=null && !conationsRecommendation(travelPlan,lunch))
				{ 
					resturants.remove(lunch);
					travelPlan.add(lunch); 
					tempLocation = lunch.getNode().getLocation(); 
					//TODO : Find a better estimate for this 
					tempTime.setHours(tempTime.getHours()+2); 
					
					hasLunchRecommendation = true; 
					
				}
			}
			if(tempTime.getHours()<bedTime)
			{

				Recommendation activity =  pickRecommendation(tempLocation, activities); 
				if(activity!=null && !conationsRecommendation(travelPlan, activity))
				{
					travelPlan.add(activity); 
					activities.remove(activity);
					tempLocation = activity.getNode().getLocation(); 
					//TODO : Find a better estimate for this 
					tempTime.setHours(tempTime.getHours()+2); 
					
				}
			}
		
		}
		
		
		
		Set<Recommendation> travelPlanToDb = new HashSet<Recommendation>();
		
		for(Recommendation recommendation : travelPlan)
		{ 
			recommendation.setIsTravelPlanRecommendation(1); 
			travelPlanToDb.add(recommendation); 
		}
		
		u.setRecivedTravelPlan(new Date()); 
		u.setTravelPlan(travelPlanToDb); 
		
		udao.makePersistent(u); 
		
		return travelPlan; 
	}
	
	private boolean conationsRecommendation(List <Recommendation> recs, Recommendation rec)
	{
		for(Recommendation r : recs)
		{
			if(r.getId()==rec.getId())
				return true;
		}
		
		return false; 
	}
	
	//finds the closet recommendation above the threshold
	private Recommendation pickRecommendation(Point tempPoint, List <Recommendation> recs)
	{ 
		Recommendation bestSoFar = null; 
		int threshHold = 60; 
		
		for(Recommendation r : recs)
		{ 
			if(bestSoFar==null)
			{
				bestSoFar = r; 
			}
			else 
			{
				double newDistance = DistanceOp.distance(tempPoint,r.getNode().getLocation());
				double oldDistance = DistanceOp.distance(bestSoFar.getNode().getLocation(),tempPoint);
				
				if(newDistance<oldDistance && bestSoFar.getSystemRating()>threshHold)
				{ 
					bestSoFar = r; 
				}
			}
		}
		return bestSoFar; 
	}
	
	


	/*
	 * Used for finding information on a specific point (should not do any filtering) , client should take care of this  
	 * 
	 */
	public List<Recommendation> getRecommendationsForSpesificPoint(User u,
			Point p) {
		
		List<Citynode> nodes = cdao.contains(p); 
		
		u = udao.findByID(u.getId(), false);
		
		List <Citynode>freshNodes = new ArrayList<Citynode>(); 
		
		Set <Recommendation>previouslyRecivedRecommendations = new HashSet<Recommendation>();  
		
		for(Citynode n : nodes)
		{ 
			Recommendation r = rdao.findByUserAndNode(n, u); 
			if(r!=null)
				previouslyRecivedRecommendations.add(r);
			else
				freshNodes.add(n); 
		}
		
		
		List <Recommendation> returnRecommendations = buildRecommendationList(freshNodes, u.getUserModel()); 
		returnRecommendations.addAll(updateRating(previouslyRecivedRecommendations, u.getUserModel())); 
		
		
		u.setCurrentRecommendations(new HashSet<Recommendation>()); 
		
		
		for(Recommendation r : returnRecommendations)
		{
			u.getCurrentRecommendations().add(r);
	
		}
		
		udao.makePersistent(u);
		
		//add user
		for(Recommendation r : returnRecommendations)
		{
			
			r.setUser(u); 
			rdao.makePersistent(r);
		}
		
		//add distance (not persistent information) 
		
		
		for(Recommendation r : returnRecommendations)
		{
			
			
			double distance = DistanceOp.distance(p,r.getNode().getLocation());
			
			r.setDistanceToUser((int)(distance*100.0*1000.0)); 
		}
		
		return returnRecommendations; 
		
	}



	@Override
	public Recommendation addRecommendationToPlan(User user,
			long recommendationId) {
		
		user = udao.findByID(user.getId(), false); 
		
		Recommendation recommendation = rdao.findByID(recommendationId, false);
		
		if(recommendation.getIsTravelPlanRecommendation()==0)
		{	
			System.out.println("Is about to add ");
			recommendation.setIsTravelPlanRecommendation(1); 
			user.getTravelPlan().add(recommendation); 
			udao.makePersistent(user); 
		}
		

		return recommendation;
	}



	@Override
	public Recommendation removeRecommendationFromList(User user,
			long recommendationId) {
	
		user = udao.findByID(user.getId(), false); 
		
		Recommendation recommendation = rdao.findByID(recommendationId, false);
		

		System.out.println("travelplan: " + recommendation.getIsTravelPlanRecommendation());
		
		if(recommendation.getIsTravelPlanRecommendation()==1)
		{	
			
			System.out.println("kommer seg inn: " + recommendation.getIsTravelPlanRecommendation());
			for(Recommendation r : user.getTravelPlan())
			{
				if(r.getId()==recommendation.getId())
				{ 
					user.getTravelPlan().remove(r); 
				}
			
			}
			
			user.setTravelPlan(user.getTravelPlan()); 
			
			recommendation.setIsTravelPlanRecommendation(0); 
			udao.makePersistent(user); 
			
			return recommendation; 
		}
		

		return null;
		
	}



	@Override
	public boolean removeTravelPlan(User user) {
		
		user = udao.findByID(user.getId(), false);
		
		user.setTravelPlan(new HashSet<Recommendation>()); 
		udao.makePersistent(user); 
		
		return true;
	}





	private double computeMean(Set <Rating> ratins)
	{
		double mean = 0; 
		
		for(Rating rating:ratins)
		{
			mean+=rating.getRating();  
		}
		
		return mean/ratins.size(); 
	}
	
	
	
	private double computeSim(User a,User b)
	{
		
		Set <Rating> setU = a.getRatings().size()>b.getRatings().size()?a.getRatings():b.getRatings();
		Set <Rating> setV = setU.equals(a.getRatings())?b.getRatings():a.getRatings(); 
		
		double sdevU = computeStandardDeviation(setU);
		double sdevV = computeStandardDeviation(setV);
		
		System.out.println("Sdev u:" + sdevU);
		System.out.println("Sdev v:" + sdevV);
		
		

		
		double meanU = computeMean(setU);
		double meanV =  computeMean(setV);
		System.out.println("Mean :" + meanU);
		System.out.println("Mean :" + meanV);
		double sum = 0; 
		
		
		for(Rating Ri : setU)
		{
			for(Rating Rj : setV)
			{
				if(Rj.getCitynode().getId()==Ri.getCitynode().getId())
				{
					System.out.println("kommer inn her");
					sum=+(Ri.getRating()-meanU)*(Rj.getRating()-meanV);
				}
			}
	
			}
		
		System.out.println("Sum:" + sum);
		System.out.println("SIM:" + sum/(sdevU*sdevV));
		
		if(sdevU*sdevV!=0)
			return sum/(sdevU*sdevV); 
		else 
			return 0;
		
	}
	
	
	
	private double computeStandardDeviation(Set <Rating> ratings)
	{
	
		double mean = computeMean(ratings); 
		double dev = 0; 
		
		for(Rating rating:ratings)
		{
			dev+=Math.pow((rating.getRating()-mean),2.0); 
		}
		
		
		return Math.sqrt(dev/ratings.size());
	}
	
	
	
	private List <Recommendation> buildRecommendationList(HashMap<Citynode, List<User>> userRatings)
	{
		List <Recommendation> returnRecommendation = new ArrayList<Recommendation>();
		
		
		for(Citynode n:userRatings.keySet())
		{ 
		
				Recommendation newRec = new Recommendation();
				
				newRec.setNode(n); 
				
				double rating = n.getRaters().size(); 
				double numberOfraters = 0; 
				
				
				
				for(User user :userRatings.get(n))
				{
					Rating r =  user.getRating(n);
					if(r!=null)
					{
						if(	newRec.getSelectedRatings()!=null)
							newRec.getSelectedRatings().add(r); 
						else 
						{
							ArrayList <Rating> rs = new ArrayList<Rating>(); 
							rs.add(r); 
							newRec.setSelectedRatings(rs);
						}
						System.out.println("prver  mkke rating");
						rating+=r.getRating(); 
					}
				}
				
			
				newRec.setTextualExplanation("Average rating from "+ numberOfraters +" that is smiliar to you"); 
				
				newRec.setSystemRating((int)((rating/userRatings.size())*100)); 
				
				returnRecommendation.add(newRec);
				
			}
		

		
		
		return returnRecommendation; 
	}



	@Override
	public User findUser(Context c, long userId, User u) {
		// TODO Auto-generated method stub
		return null;
	}



	@Override
	public Citynode handleImplicitFeedback(User user, Context context) {
		// TODO Auto-generated method stub
		return null;
	}



	@Override
	public boolean handleExplicitFeedback(Citynode n, User user, double feeback) {
		// TODO Auto-generated method stub
		return false;
	}



	@Override
	public User createUser() {
		// TODO Auto-generated method stub
		return null;
	}




	@Override
	public List<Citynode> getInitSet() {
		// TODO Auto-generated method stub
		return null;
	}




	
	
	
}
