<!DOCTYPE html>
<html>
<head>
	<meta name="viewport" content="initial-scale=1.0, user-scalable=no" />
	<meta http-equiv="content-type" content="text/html; charset=UTF-8"/>
	<style type="text/css">
	  html { height: 100% }
	  body { height: 100%; margin: 0px; padding: 0px }

	  #map_canvas { height: 500px;width: 700px }
	</style>

	</script>
	<script type="text/javascript">
		var map;
		var geocoder;
		var markerArray = [];

	  function initialize() {
		  geocoder = new google.maps.Geocoder();
		  var test = document.getElementById('googleLatLng').value;
		  
		  indexOfComma = test.indexOf(',');
		  var t1 = test.substring(1, indexOfComma);
		  var t2 = test.substring(indexOfComma+1, test.length-1);
	  
	    var myLatlng = new google.maps.LatLng(t1, t2);
	    var myOptions = {
	      zoom: 12,
	      center: myLatlng,
	      mapTypeId: google.maps.MapTypeId.ROADMAP
	    }
	    map = new google.maps.Map(document.getElementById("map_canvas"), myOptions);
	    
	    var marker = new google.maps.Marker({
	    	              map: map,
	    	              position: map.getCenter()
	          });

	    google.maps.event.addListener(map, 'click', function(event) {
		    placeMarker(event.latLng);
 		 });
	  }

	  function loadScript() {
	    var script = document.createElement("script");
	    script.type = "text/javascript";
	    script.src = "http://maps.google.com/maps/api/js?sensor=false&callback=initialize";
	    document.body.appendChild(script);
  	  }


	window.onload = loadScript;
</script>

</head>

<body>

<%

	String title = request.getParameter("title");
	String address = request.getParameter("address");
	String description = request.getParameter("description");
	String phonenumber = request.getParameter("phonenumber");
	String openinghours = request.getParameter("openinghours");
	String category = request.getParameter("category");
	String type = request.getParameter("type");
	String location = request.getParameter("location");
	String googleLatLng = request.getParameter("googleLatLng");
	String googleLat = request.getParameter("googleLat");
	String googleLng = request.getParameter("googleLng");
%>

<%
	
	// Convert category to match model, and convert type so it matches with icons
	String convertedCategory = "";
	String convertedType = "";
	if (category.equals("Place to eat")) {
		convertedCategory = "Restaurant";
		
		if (type.equals("Italian cuisine")){
			convertedType = "restaurantitalian";
		} else if (type.equals("Mexican cuisine")){
			convertedType = "restaurantmexican";
		} else if (type.equals("Norwegian cuisine")){
			convertedType = "restaurant";
		} else if (type.equals("Fast-food")){
			convertedType = "fastfood";
		} else if (type.equals("Asian cuisine")){
			convertedType = "restaurantchinese";
		}
	} else if (category.equals("Sightseeing")) {
		convertedCategory = "Activity";
		
		if (type.equals("Art museum")){
			convertedType = "museumhistorical";
		} else if (type.equals("Other museum")){
			convertedType = "museumhistorical";
		} else if (type.equals("Architectural landmark")){
			convertedType = "museumhistorical";
		}
	} else if (category.equals("Hotel, motel, etc")) {
		convertedCategory = "Hotel";
		
		if (type.equals("Hotel")){
			convertedType = "hotel";
		} else if (type.equals("Motel")){
			convertedType = "hotel";
		} else if (type.equals("Hostel")){
			convertedType = "hotel";
		}
	} else if (category.equals("Nightlife")) {
		convertedCategory = "nightlife";
		
		if (type.equals("Nightclub")){
			convertedType = "nightclub";
		} else if (type.equals("Pub")){
			convertedType = "bar";
		} else if (type.equals("Alcoholic beverage")){
			convertedType = "bar";
		}
	}
		
%>	

<form action="insert" method="POST" name="ele">
Please look over the details you provided. <br><br>
<table>
	<tr>
		<td>Title:*</td>
		<td><%=title%></td>
	</tr>
	<tr>
		<td>Address:</td>
		<td><%=address%></td>
	</tr>
	<tr>
		<td>Description:</td>
		<td><%=description%></td>
	</tr>
	<tr>
		<td>Phonenumber:</td>
		<td><%=phonenumber%></td>
	</tr>
	<tr>
		<td>Opening hours:</td>
		<td><%=openinghours%></td>
	</tr>
	<tr>
		<td>Category:</td>
		<td><%=category%></td>
	</tr>
	<tr>
		<td>Type:</td>
		<td><%=type%></td>
	</tr>
	<tr>
		<td>Location:</td>
		<td><%=location%></td>
	</tr>
	<tr>
		<td>Google Lat:</td>
		<td><%=googleLat%></td>
	</tr>
	<tr>
		<td>Google Lng:</td>
		<td><%=googleLng%></td>
	</tr>
</table>
<br>


	
	<input type="hidden" name="title" value="<%=title%>" >
	<input type="hidden" name="address" value="<%=address%>" />
	<input type="hidden" name="description" value="<%=description%>" />
	<input type="hidden" name="phonenumber" value="<%=phonenumber%>" />
	<input type="hidden" name="openinghours" value="<%=openinghours%>" />
	<input type="hidden" name="category" value="<%=convertedCategory%>" />
	<input type="hidden" name="type" value="<%=convertedType%>" />
	<input type="hidden" name="location" value="<%=location%>" />
	<input type="hidden" id="googleLatLng" name="googleLatLng" value="<%=googleLatLng%>" />
	<input type="hidden" id="googleLat" name="googleLat" value="<%=googleLat%>" />
	<input type="hidden" id="googleLng" name="googleLng" value="<%=googleLng%>" />
	
	<input type="submit" name="submit" value="Submit">
</form>

<br>
<center>
<div id="map_canvas"></div>


<br><br>

We appreciate your effort in making this project better!
</center>

</body>
</html>