package web;


import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.StringReader;
import java.io.UnsupportedEncodingException;
import java.io.Writer;
import java.net.URLDecoder;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import matrixPacket.Item;
import matrixPacket.RecommenderAlgorithm;
import model.Attribute;
import model.Citynode;
import model.Context;
import model.Preference;
import model.Rating;
import model.Recommendation;
import model.User;
import model.UserModel;
import model.Visit;
import model.XmlNode;
import net.sf.cglib.proxy.Factory;

import org.apache.lucene.analysis.standard.StandardAnalyzer;
import org.apache.lucene.queryParser.MultiFieldQueryParser;
import org.hibernate.Transaction;
import org.hibernate.connection.UserSuppliedConnectionProvider;
import org.hibernate.search.FullTextSession;
import org.hibernate.search.Search;
import org.postgis.Geometry;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

import recommendersystem.RecommenderSystem;
import recommendersystem.impl.CollaborativeRecommenderSystem;
import recommendersystem.impl.DummyRecommenderSystem;


import Jama.Matrix;

import com.vividsolutions.jts.geom.Coordinate;
import com.vividsolutions.jts.geom.GeometryFactory;
import com.vividsolutions.jts.geom.LinearRing;
import com.vividsolutions.jts.geom.Polygon;

import com.vividsolutions.jts.geom.Point;

import com.vividsolutions.jts.geom.PrecisionModel;

import util.HibernateUtil;
import util.XmlUtil;



import dao.AttributeDAO;
import dao.CitynodeDAO;
import dao.GenericDAO;
import dao.PreferenceDAO;
import dao.RatingDAO;
import dao.UserDAO;
import dao.UserModelDAO;
import dao.VisitDAO;
import dao.factory.DAOFactory;
import dao.factory.HibernateDAOFactory;
import dao.impl.VisitDAOimpl;
public class RecommenderServlet extends HttpServlet {

	/*
	 * MERK : Denne servleten er kun ment til bruk ifbm proof of concept .
	 * Den er IKKE trdsikker, og er generelt ikke godt skrevet  
	 * 
	 * TODO : -Make use of sessions
	 *        -Do input validation  
	 *        -Make thread safe
	 * 
	 * 
	 */
	private DocumentBuilderFactory documentBuilderFactory;
	
	//TODO : this gets used by several threads  
	private HashMap<Integer,User> userMap = new HashMap<Integer,User>(); 
	
	//TODO : do something proper with sessions 
	private int sessionid = 0; 
	
	protected void doGet(
            HttpServletRequest request,
            HttpServletResponse response) throws ServletException, IOException 
     { 
		doPost(request, response);
		
		System.out.println("Finished doGet");
     }
	
	//for debugging
	 public void doPostff(
	            HttpServletRequest request,
	            HttpServletResponse response) throws ServletException, IOException { 
		 
		 
		 DAOFactory factory = DAOFactory.instance(DAOFactory.HIBERNATE);
		// this.initdb(factory.getAttributeDAO(),factory.getCitynodeDAO(),factory);
		 intiCollobrative(factory);
		  Writer w = response.getWriter(); 
		  w.write("ok");
		  w.close();
	 }
	
	
	//for debugging 
	 public void doPostSearchDebug(
	            HttpServletRequest request,
	            HttpServletResponse response) throws ServletException, IOException { 
		 
		   DAOFactory factory = DAOFactory.instance(DAOFactory.HIBERNATE);
		   
		  // HibernateUtil.getSessionFactory().getCurrentSession()
	         // .beginTransaction();
		   
		   factory.getAttributeDAO();
		   
		   FullTextSession fullTextSession = Search.getFullTextSession(HibernateUtil.getSessionFactory().getCurrentSession());
		   Transaction tx = fullTextSession.beginTransaction();

		   List <Citynode> books = HibernateUtil.getSessionFactory().getCurrentSession().createQuery("from Citynode as citynode").list();
		   for (Citynode book : books) {
		       fullTextSession.index(book);
		   }

		 //  tx.commit();
		   
		   //this.initdb(factory.getAttributeDAO(),factory.getCitynodeDAO(),factory);
			/*
		  VisitDAO vdao = factory.getVisitDAO();
		  
		  Visit v = new Visit();
		  Date d = new Date();
		  java.sql.Date timestamp = new java.sql.Date(d.getTime());
		//  v.setArrived(timestamp);
		  System.out.println("dette for lagring:" + timestamp.getTime());
		  
		  
		  try { 
		  vdao.makePersistent(v);
		 
		  HibernateUtil.getSessionFactory().getCurrentSession().getTransaction().commit();
		 
		//  System.out.println("dette for etter lagring:" + v.getArrived().getTime());
		 */ 
		   
		   String[] fields = new String[]{"title", "subtitle", "authors.name", "publicationDate"};
		   MultiFieldQueryParser parser = new MultiFieldQueryParser(fields, new StandardAnalyzer());
		   org.apache.lucene.search.Query query;
		 query = null;  
		   
		 try {
			query = parser.parse( "Solsiden" );
		} catch (org.apache.lucene.queryParser.ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		   // wrap Lucene query in a org.hibernate.Query
		   org.hibernate.Query hibQuery = fullTextSession.createFullTextQuery(query, Citynode.class);

		   // execute search
		   List <Citynode> result = hibQuery.list();
		   System.out.println("antall shit som ble funnet:" + result.size());  
		
		   for(Citynode n : result)
		   { 
			   System.out.println(n.getTitle());
		   }
		   
		   tx.commit();
		//   session.close();  
  
		   HibernateUtil.getSessionFactory().getCurrentSession().close();
		   
		   
			  Writer w = response.getWriter(); 
			  w.write("ok");
			  w.close();
		
	  

			  
	 }
	
	 public void doPost(
	            HttpServletRequest request,
	            HttpServletResponse response) throws ServletException, IOException { 
		 
		 
		 RecommenderSystem rcontroller; 
		 
		 documentBuilderFactory = 
			    DocumentBuilderFactory.newInstance();
				DocumentBuilder documentBuilder;
				Document userActionDocument = null;
				Document reponseDocument = null; 
				
				try {
					documentBuilder = documentBuilderFactory.newDocumentBuilder();
					userActionDocument = documentBuilder.newDocument();
					reponseDocument = documentBuilder.newDocument();
				
					HibernateDAOFactory factory = 	(HibernateDAOFactory)DAOFactory.instance(DAOFactory.HIBERNATE);
	           
					rcontroller = new  DummyRecommenderSystem(factory.getCitynodeDAO(),factory.getRecommendationDAO(),
			    										  factory.getUserDAO(),factory.getUserModelDAO(),
			    										  factory.getVisitDAO()); 
			    
			
					BufferedReader reader = new BufferedReader(new InputStreamReader(request.getInputStream()));
					
					String line;
					String returnString=""; 
					while ((line = reader.readLine()) != null) 
					{
						returnString+=(line);
					}
					
					Document clientPost = XmlUtil.fromStringToXml(returnString);   
					Writer  w = response.getWriter(); 
					
					if(clientPost.getFirstChild()!=null && clientPost.getFirstChild().getNodeName().equals("Request"))
					{ 
						w.write(handleRequest((Element)clientPost.getFirstChild(),rcontroller,factory,reponseDocument)); 
						System.out.println("handleRequest: Done");
					}
					else
					{ 
						w.write("error"); 
					}
				  
					factory.closeSession();
				}
					
				catch (ParserConfigurationException e) 
				{
						e.printStackTrace();
					}
					 catch (ParseException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					 System.out.println("doPost: Done");
	 }
	
	 //avoids thread problems for now (as its currently the only method accessing the usermap
	 private synchronized String handleRequest(Element request, RecommenderSystem recsys,DAOFactory factory,Document respons) throws ParseException 
	 {
		 System.out.println("Handling request...");
		 CollaborativeRecommenderSystem hybrib = new CollaborativeRecommenderSystem(factory.getCitynodeDAO(), factory.getRecommendationDAO(), factory.getUserDAO(), factory.getUserModelDAO(), factory.getVisitDAO(),factory.getRatingDAO());
		 
		 
		 if(request.getAttribute("type").equals("login"))
		 { 
			 System.out.println("User attempts to login");
			 String username = request.getAttribute("username");
			 String password = request.getAttribute("password");
			 UserDAO userdao = factory.getUserDAO(); 
			
	
			 Element e = respons.createElement("response");
			 respons.appendChild(e); 
			 
			 
			// Temporary hack to get through the login-phase
			 User user = userdao.findUser(password, username);
//			 User userHack = new User();
//			 userHack.setUsername("marianne2");
//			 userHack.setPassword("marianne2");
//			 User user = userHack;
			 
			 System.out.println("username:" + user.getUsername());
			 System.out.println("password:" + user.getPassword());
			 
			 if(!user.equals(null))
			 {
				 this.userMap.put(this.sessionid+1,user); 
				
				 e.setAttribute("type", "login"); 
				 e.setAttribute("value", "ok");
				 e.setAttribute("sessionid",String.valueOf(this.sessionid+1)); 
				 this.sessionid++;
			 }
			 else 
			 { 
				 e.setAttribute("type", "login"); 
				 e.setAttribute("value", "failed"); 
			 }

			 return XmlUtil.xmlToString(respons); 
		 }
		 else if(request.getAttribute("type").equals("getrecommendations")
		&& this.userMap.containsKey(Integer.parseInt(request.getAttribute("sessionid"))))
		 { 
			 System.out.println("Handling request: getrecommendations");
			 Context context = new Context(); 
			 Element xmlContext = (Element)request.getElementsByTagName("Context").item(0);
			 String [] coordinatesAsString = xmlContext.getAttribute("location").split(" "); 
			 Coordinate c = new Coordinate(); 
			 System.out.println("Coordinates provided: x: " + c.x +" y: " + c.y);
			 c.x = Double.valueOf(coordinatesAsString[0]); 
			 c.y = Double.valueOf(coordinatesAsString[1]); 
			 context.setUserLocation(new Point(c, new PrecisionModel(), 4326));
			 
			 
			 Element intrestField = (Element)xmlContext.getElementsByTagName("Field").item(0);
			 
			 // Get area of interest
			 if(intrestField!=null)
			 {
				 String [] array1   = intrestField.getAttribute("point1").split(" ");
				 Coordinate c1 = new Coordinate(Double.valueOf(array1[0]), Double.valueOf(array1[1]));
				 
				 String [] array2   = intrestField.getAttribute("point2").split(" ");
				 Coordinate c2 = new Coordinate(Double.valueOf(array2[0]), Double.valueOf(array2[1]));
				 
				 String [] array3   = intrestField.getAttribute("point3").split(" ");
				 Coordinate c3 = new Coordinate(Double.valueOf(array3[0]), Double.valueOf(array3[1]));
				 
				 String [] array4   = intrestField.getAttribute("point4").split(" ");
				 Coordinate c4 = new Coordinate(Double.valueOf(array4[0]), Double.valueOf(array4[1]));
				 
				 String [] array5   = intrestField.getAttribute("point5").split(" ");
				 Coordinate c5 = new Coordinate(Double.valueOf(array5[0]), Double.valueOf(array5[1]));
				 
				 Coordinate [] cors = new  Coordinate []{c1,c2,c3,c4,c5}; 
				 
				 LinearRing ring = new LinearRing(cors,new PrecisionModel(), 4326);  
				 
				 Polygon areaOfIntrest = new Polygon(ring, new PrecisionModel(), 4326);
				 
				 context.setIntrestField(areaOfIntrest); 
				 
			 }
			 
			boolean personal = Boolean.parseBoolean(request.getAttribute("personal"));
			 
			 return XmlUtil.xmlToString(createXml(hybrib.getRecommendations(this.userMap.get(Integer.parseInt(request.getAttribute("sessionid"))),context,request.getAttribute("value"),personal),respons)); 
		 }
		 else if(request.getAttribute("type").equals("giveexplicitfeedback")
			&& this.userMap.containsKey(Integer.parseInt(request.getAttribute("sessionid"))))
		 { 
			 long citynodeid = Long.parseLong(request.getAttribute("citynodeid")); 
			 
			 Citynode n = new Citynode(); 
			 n.setId(citynodeid); 
			 
			 
			 long userId = this.userMap.get(Integer.parseInt(request.getAttribute("sessionid"))).getId(); 
			 double feedback = Double.parseDouble(request.getAttribute("feedback"));
			 
			 boolean responsBolean = hybrib.handleExplicitFeedback(n,this.userMap.get(Integer.parseInt(request.getAttribute("sessionid"))), feedback);
			 
			 //List <Recommendation> returnRecs = recsys.handleExplicitFeedback(recommendationId, this.userMap.get(Integer.parseInt(request.getAttribute("sessionid"))),feedback); 
			 
			// System.out.println("lengde :" + returnRecs.size());
			 
			 Element resElement = respons.createElement("respons"); 
			 resElement.setAttribute("respons",String.valueOf(responsBolean));
			 
			 respons.appendChild(resElement); 
			 
			 // Update AI-model --- START
			// Creation and conversion of necessary entities
				ArrayList<matrixPacket.User> userList = new ArrayList<matrixPacket.User>();
				Set<matrixPacket.User> tempUserList = new HashSet<matrixPacket.User>();
				ArrayList<Item> itemList = new ArrayList<Item>();
				
				// Get Citynodes/Items
				System.out.println("Getting items...");
				// Get all nodes
				ArrayList<Citynode> nodes = new ArrayList<Citynode>();
				nodes.addAll(factory.getCitynodeDAO().findCitynodeExperience(null));
				nodes.addAll(factory.getCitynodeDAO().findCitynodesEat(null));
				nodes.addAll(factory.getCitynodeDAO().findCitynodesSleep(null));
				for(Citynode node : nodes){
					// Get features from node and create an AI-Item based on those
//					items.add(new matrixPacket.Item(node.getItemMatrix()));
					
					itemPortToMatrix(node);
					
					matrixPacket.Item it = new matrixPacket.Item(node.getItemMatrix());
					it.setCitynode(node);
					
					itemList.add(it);
				}
				
				
				// Get users
				System.out.println("Getting users...");
				for(Citynode node : nodes)
				{
					
					Set <User> raters = node.getRaters(); 
					for(User rater : raters)
					{
						// Get features from user and create an AI-User based on those
						userPortToMatrix(rater);
						
						matrixPacket.User mUser = new matrixPacket.User();
						mUser.setUserFeatures(rater.getUserMatrix());
						mUser.modelUser = rater;
						
						// Convert ratings
						for(Rating r : rater.ratings){
							int item = 0;
							
							// Search for index of Item/Citynode
							for(Item it : itemList){
								if(it.getCitynode().getLocation().equals(r.getCitynode().getLocation())){
									item = itemList.indexOf(it);
									it.setItem(item);
									System.out.println("item: " + item);
									break;
								}
							}
							
							double rating = r.getRating();
							
							System.out.println("Adding rating: " + rating);
							mUser.addRating(new matrixPacket.Rating(item, rating));
						}
						
						// Add user if not already in the list
						boolean isPresent = false;
						for(matrixPacket.User user : userList){
							if (user.modelUser!=null){
								if (user.modelUser.isEqual(mUser.modelUser)){
									isPresent = true;
									break;
								}
							}
						}
						
						if (!isPresent){
							userList.add(mUser);
						}
						
						
						
						
					}
				}
				
				System.out.println("Size of userList: " + userList.size());
				System.out.println("Size of itemList: " + itemList.size());
				
				

				RecommenderAlgorithm rec = new RecommenderAlgorithm(userList, itemList);
			 rec.createProbabilisticModel();

			 
			 
			 
			 // Update AI-model --- END
			 
			 return XmlUtil.xmlToString(respons);
			 
		 }
		 else if(request.getAttribute("type").equals("update")
					&& this.userMap.containsKey(Integer.parseInt(request.getAttribute("sessionid"))))
		 { 
			 Context context = new Context(); 
			 Element xmlContext = (Element)request.getElementsByTagName("Context").item(0);
			 
			 String [] coordinatesAsString = xmlContext.getAttribute("location").split(" "); 
			 
			 Coordinate c = new Coordinate(); 
			 c.x = Double.valueOf(coordinatesAsString[0]); c.y = Double.valueOf(coordinatesAsString[1]); 
			 System.out.println("x : " + c.x +" y:" + c.y);
			 context.setUserLocation(new Point(c, new PrecisionModel(), 4326));
			 
			 boolean checkForTravelPlan = Integer.valueOf(xmlContext.getAttribute("checkfortravelplan"))==1?true:false; 
			 
			 context.setCheckingForTravelPlan(checkForTravelPlan); 
			 
			 String l =  XmlUtil.xmlToString(createXml(hybrib.handleContextChange(this.userMap.get(Integer.parseInt(request.getAttribute("sessionid"))), context),respons)); 
			 System.out.println(l);
			 return l; 
		 }
		 else if( request.getAttribute("type").equals("getusermodel")
					&& this.userMap.containsKey(Integer.parseInt(request.getAttribute("sessionid"))))
		 {
			 UserModel usermodel = recsys.getUserModel(this.userMap.get(Integer.parseInt(request.getAttribute("sessionid"))));
			 
			 List <UserModel> modles = new ArrayList<UserModel>(); 
			 modles.add(usermodel); 
			 
			 return XmlUtil.xmlToString(createXml(modles,respons)); 
			 
		 }
		 else if ( request.getAttribute("type").equals("getrecommendationsfrompoint")
					&& this.userMap.containsKey(Integer.parseInt(request.getAttribute("sessionid"))))
		 { 
			 
			 Context context = new Context(); 
			 Element xmlContext = (Element)request.getElementsByTagName("Context").item(0);
			 
			 String [] coordinatesAsString = xmlContext.getAttribute("location").split(" "); 
			 
			 Coordinate c = new Coordinate(); 
			 c.x = Double.valueOf(coordinatesAsString[0]); c.y = Double.valueOf(coordinatesAsString[1]); 
			 System.out.println("x : " + c.x +" y:" + c.y);
			 
			 return XmlUtil.xmlToString(createXml(recsys.getRecommendationsForSpesificPoint(this.userMap.get(Integer.parseInt(request.getAttribute("sessionid"))),new Point(c, new PrecisionModel(), 4326)),respons));
			 
			 
		 }
		 else if ( request.getAttribute("type").equals("gettravelplan")
					&& this.userMap.containsKey(Integer.parseInt(request.getAttribute("sessionid"))))
		 { 
			 
			 Context context = new Context(); 
			 Element xmlContext = (Element)request.getElementsByTagName("Context").item(0);
			 String [] coordinatesAsString = xmlContext.getAttribute("location").split(" "); 
			 Coordinate c = new Coordinate(); 
			 System.out.println("x : " + c.x +" y:" + c.y);
			 c.x = Double.valueOf(coordinatesAsString[0]); c.y = Double.valueOf(coordinatesAsString[1]); 
			 context.setUserLocation(new Point(c, new PrecisionModel(), 4326));
			 Element intrestField = (Element)xmlContext.getElementsByTagName("Field").item(0);
			 
			 if(intrestField!=null)
			 {
				 String [] array1   = intrestField.getAttribute("point1").split(" ");
				 Coordinate c1 = new Coordinate(Double.valueOf(array1[0]), Double.valueOf(array1[1]));
				 
				 String [] array2   = intrestField.getAttribute("point2").split(" ");
				 Coordinate c2 = new Coordinate(Double.valueOf(array2[0]), Double.valueOf(array2[1]));
				 
				 String [] array3   = intrestField.getAttribute("point3").split(" ");
				 Coordinate c3 = new Coordinate(Double.valueOf(array3[0]), Double.valueOf(array3[1]));
				 
				 String [] array4   = intrestField.getAttribute("point4").split(" ");
				 Coordinate c4 = new Coordinate(Double.valueOf(array4[0]), Double.valueOf(array4[1]));
				 
				 String [] array5   = intrestField.getAttribute("point5").split(" ");
				 Coordinate c5 = new Coordinate(Double.valueOf(array5[0]), Double.valueOf(array5[1]));
				 
				 Coordinate [] cors = new  Coordinate []{c1,c2,c3,c4,c5}; 
				 
				 LinearRing ring = new LinearRing(cors,new PrecisionModel(), 4326);  
				 
				 Polygon areaOfIntrest = new Polygon(ring, new PrecisionModel(), 4326);
				 
				 context.setIntrestField(areaOfIntrest); 
				 
			 }
			 
			 
			 return XmlUtil.xmlToString(createXml(hybrib.getTravelPlan(this.userMap.get(Integer.parseInt(request.getAttribute("sessionid"))),context),respons)); 
		 }
		 
		 else if ( request.getAttribute("type").equals("removefromtravelplan")
					&& this.userMap.containsKey(Integer.parseInt(request.getAttribute("sessionid"))))
		 { 
			
			 long recommendationId = Long.valueOf(request.getAttribute("recommendationid"));
			 Recommendation r = hybrib.removeRecommendationFromList(this.userMap.get(Integer.parseInt(request.getAttribute("sessionid"))), recommendationId); 
			 
			 respons.appendChild(r.getXmlRepresentation(respons)); 
			 
			 return XmlUtil.xmlToString(respons);
			 
		 }
		 else if ( request.getAttribute("type").equals("addtotravelplan")
					&& this.userMap.containsKey(Integer.parseInt(request.getAttribute("sessionid"))))
		 { 
			 long recommendationId = Long.valueOf(request.getAttribute("recommendationid"));
			 Recommendation r = hybrib.addRecommendationToPlan(this.userMap.get(Integer.parseInt(request.getAttribute("sessionid"))), recommendationId); 
			 
			 respons.appendChild(r.getXmlRepresentation(respons)); 
			 
			 return XmlUtil.xmlToString(respons);
		 }
		 else if ( request.getAttribute("type").equals("removetravelplan")
					&& this.userMap.containsKey(Integer.parseInt(request.getAttribute("sessionid"))))
		 { 
			 boolean sucsess = hybrib.removeTravelPlan(this.userMap.get(Integer.parseInt(request.getAttribute("sessionid"))));
			 
			 Element r = respons.createElement("respons"); 
			 r.setAttribute("sucsess", String.valueOf(sucsess));
			 
			 return XmlUtil.xmlToString(respons);
			 
		 }
		 else if ( request.getAttribute("type").equals("finduser")
					&& this.userMap.containsKey(Integer.parseInt(request.getAttribute("sessionid"))))
		 { 
			 Context context = new Context(); 
			 Element xmlContext = (Element)request.getElementsByTagName("Context").item(0);
			 
			 String [] coordinatesAsString = xmlContext.getAttribute("location").split(" "); 
			 
			 Coordinate c = new Coordinate(); 
			 c.x = Double.valueOf(coordinatesAsString[0]); c.y = Double.valueOf(coordinatesAsString[1]); 
			 System.out.println("x : " + c.x +" y:" + c.y);
			 context.setUserLocation(new Point(c, new PrecisionModel(), 4326));
			 
			 long userOfIntrest = Long.parseLong(request.getAttribute("otheruserid"));
			 
			 return XmlUtil.xmlToString(hybrib.findUser(context, userOfIntrest, this.userMap.get(Integer.parseInt(request.getAttribute("sessionid")))).getXmlRepresentation(respons)); 
			 
		 }
		 else if ( request.getAttribute("type").equals("ratingsfromuser")
					&& this.userMap.containsKey(Integer.parseInt(request.getAttribute("sessionid"))))
		 { 
			 Context context = new Context(); 
			 Element xmlContext = (Element)request.getElementsByTagName("Context").item(0);
			 
			 String [] coordinatesAsString = xmlContext.getAttribute("location").split(" "); 
			 
			 Coordinate c = new Coordinate(); 
			 c.x = Double.valueOf(coordinatesAsString[0]); c.y = Double.valueOf(coordinatesAsString[1]); 
			 System.out.println("x : " + c.x +" y:" + c.y);
			 context.setUserLocation(new Point(c, new PrecisionModel(), 4326));
			 
			 Element intrestField = (Element)xmlContext.getElementsByTagName("Field").item(0);
			 
			 if(intrestField!=null)
			 {
				 String [] array1   = intrestField.getAttribute("point1").split(" ");
				 Coordinate c1 = new Coordinate(Double.valueOf(array1[0]), Double.valueOf(array1[1]));
				 
				 String [] array2   = intrestField.getAttribute("point2").split(" ");
				 Coordinate c2 = new Coordinate(Double.valueOf(array2[0]), Double.valueOf(array2[1]));
				 
				 String [] array3   = intrestField.getAttribute("point3").split(" ");
				 Coordinate c3 = new Coordinate(Double.valueOf(array3[0]), Double.valueOf(array3[1]));
				 
				 String [] array4   = intrestField.getAttribute("point4").split(" ");
				 Coordinate c4 = new Coordinate(Double.valueOf(array4[0]), Double.valueOf(array4[1]));
				 
				 String [] array5   = intrestField.getAttribute("point5").split(" ");
				 Coordinate c5 = new Coordinate(Double.valueOf(array5[0]), Double.valueOf(array5[1]));
				 
				 Coordinate [] cors = new  Coordinate []{c1,c2,c3,c4,c5}; 
				 
				 LinearRing ring = new LinearRing(cors,new PrecisionModel(), 4326);  
				 
				 Polygon areaOfIntrest = new Polygon(ring, new PrecisionModel(), 4326);
				 
				 context.setIntrestField(areaOfIntrest); 
				 
			 }
			 
			 
			 long userOfIntrest = Long.parseLong(request.getAttribute("otheruserid"));
			 
			 return XmlUtil.xmlToString(createXml(hybrib.findRecommendationsFromUserRating(context, userOfIntrest, this.userMap.get(Integer.parseInt(request.getAttribute("sessionid")))),respons)); 
			 
		 }
		 else if ( request.getAttribute("type").equals("newratings")
					&& this.userMap.containsKey(Integer.parseInt(request.getAttribute("sessionid"))))
		 { 
			 Context context = new Context(); 
			 Element xmlContext = (Element)request.getElementsByTagName("Context").item(0);
			 
			 String [] coordinatesAsString = xmlContext.getAttribute("location").split(" "); 
			 
			 Coordinate c = new Coordinate(); 
			 c.x = Double.valueOf(coordinatesAsString[0]); c.y = Double.valueOf(coordinatesAsString[1]); 
			 System.out.println("x : " + c.x +" y:" + c.y);
			 context.setUserLocation(new Point(c, new PrecisionModel(), 4326));
			 
			 Citynode node = hybrib.handleImplicitFeedback(this.userMap.get(Integer.parseInt(request.getAttribute("sessionid"))), context);
			 if(node!=null)
			 	return XmlUtil.xmlToString(node.getXmlRepresentation(respons)); 
			 else
			 {
				 
				 Element e = respons.createElement("respons"); 
				 e.setAttribute("respons", "error"); 
				 respons.appendChild(e); 
				
				 return XmlUtil.xmlToString(respons); 
			 }
				
		 }
		 else if ( request.getAttribute("type").equals("initset")
					&& this.userMap.containsKey(Integer.parseInt(request.getAttribute("sessionid"))))
		 { 
			return XmlUtil.xmlToString(createXml(hybrib.getInitSet(), respons)); 
		
				
		 }
		 else if ( request.getAttribute("type").equals("getrecommendationfromcitymode")
					&& this.userMap.containsKey(Integer.parseInt(request.getAttribute("sessionid"))))
		 {
			 Context context = new Context(); 
			 Element xmlContext = (Element)request.getElementsByTagName("Context").item(0);
			 
			 String [] coordinatesAsString = xmlContext.getAttribute("location").split(" "); 
			 
			 Coordinate c = new Coordinate(); 
			 c.x = Double.valueOf(coordinatesAsString[0]); c.y = Double.valueOf(coordinatesAsString[1]); 
			 System.out.println("x : " + c.x +" y:" + c.y);
			 context.setUserLocation(new Point(c, new PrecisionModel(), 4326));
			 
			 long nodeId =  Long.valueOf(request.getAttribute("ciynodeid"));
			 
			 
			 return XmlUtil.xmlToString(hybrib.getRecommendationFromCityNode(nodeId, this.userMap.get(Integer.parseInt(request.getAttribute("sessionid"))), context).getXmlRepresentation(respons));
		 }

		 
		 
		 
		 
	
		 
		 return XmlUtil.xmlToString(respons); 
	 }
	 
	 
	 private Document createXml(List nodelist, Document response)
	 { 
		 if(nodelist.size()>0)
		 {
		 	Element list = response.createElement(((XmlNode) nodelist.get(0)).getNodeType() +"list"); 
		 
		 	for (Object node : nodelist)
		 	{ 
		 		list.appendChild(((XmlNode) node).getXmlRepresentation(response)); 
		 	}
		 
		 	response.appendChild(list); 
		
		 }	
		 
		 return response; 
	 }
	 
	 
	 private void intiCollobrative(DAOFactory f)
	 {
		 CitynodeDAO cdao = f.getCitynodeDAO(); 
		 RatingDAO rddat = f.getRatingDAO(); 
		 UserDAO udao = f.getUserDAO(); 
		 
		 List <Citynode> nodes = cdao.findAll(); 
		 
		 
		 
		 //1)lag en user 2)Rate alle noder 3)Legg bruker til som rater av alle noder
		 for(int i=0;i<5;i++)
		 {
			User u = new User(); 
		//	udao.makePersistent(u); 
			for(Citynode node : nodes)
			{
				Rating r = new Rating();
				 
			
				r.setCitynode(node); 
				r.setRating(Math.random()); 
				
			
				
				
				u.getRatings().add(r); 
				node.getRaters().add(u); 
				
				udao.makePersistent(u); 
				cdao.makePersistent(node);
				
				
				
				
			}
		 }
		 
		 
		
		 
		 
		 
		 
	 
	 }
	 
	 
	 
	 
	 private void initdb(AttributeDAO gdao,CitynodeDAO cdao, DAOFactory f)
	 { 
		 
		 
	
		 /*
			*
			 * Ontologi .. So far
			 * Restaurant 
			 * -Price
			 * --Budget  
			 * --Mid range 
			 * --High end
			 * -Cuisine 
			 * --Chinese 
			 * --Italian
			 * --Fast food
			 * --Local 
			 * Hotel 
			 * -Price 
			 * --Budget  
			 * --Mid range 
			 * --High end
			 * -Category
			 * --Family 
			 * --Youth 
			 * --Business
			 * Activity 
			 * --indoor 
			 * ---Museum
			 * ----Historical 
			 * ----War 
			 * ----Science 
			 * ---Theatre 
			 * --outdoor 
			 *

		 */
		 System.out.println("initDB");
		 
		 UserDAO uf = f.getUserDAO(); 
		 UserModelDAO um = f.getUserModelDAO();  
		 PreferenceDAO pdao = f.getPreferenceDAO();  
		 
		 
		 User magnar = new User(); 
		
		 magnar.setId(1);
		 magnar.setPassword("magnar"); 
		 magnar.setUsername("magnar");
		 
	
		  
		 
		 List <model.Attribute> attributes = new ArrayList<model.Attribute>(); 
		 
		 
		 model.Attribute a1 = new Attribute(1, null, "restaurant", false,"Restaurant",0);
		 	model.Attribute a2 = new Attribute(2, a1, "price", false,"Price",1); 
		 		model.Attribute a3 = new Attribute(3, a2, "bugdet", true,"Bugdet",2);  
		 		model.Attribute a4 = new Attribute(4, a2, "mid_range", true,"Mid range",2); 
		 		model.Attribute a5 = new Attribute(5, a2, "high_end", true,"High end",2); 
		 	model.Attribute a6 = new Attribute(6, a1, "cuisine ", false,"Cuisine",1);
		 		model.Attribute a7 = new Attribute(7, a6, "restaurantchinese", true,"Chinese restaurant",2); 
		 		model.Attribute a8 = new Attribute(8, a6, "restaurantitalian", true,"Italian restaurant",2); 
		 		model.Attribute a9 = new Attribute(9, a6, "fastfood", true,"Fast food",2); 
		 		model.Attribute a23 = new Attribute(23, a6, "pizza", true,"Pizza place",2); 
		 		model.Attribute a24 = new Attribute(24, a6, "cafe", true,"Cafe",2); 
		 		model.Attribute a28 = new Attribute(28, a6, "barbeque", true,"Barbeque",2); 
		 model.Attribute a10 =  new Attribute(10, null, "hotel", false,"hotel",0);
		 	model.Attribute a11 =  new Attribute(11, a10, "price", false,"Price",1);
		 		model.Attribute a12 = new Attribute(12, a11, "bugdet", true,"Bugdet",2);  
		 		model.Attribute a13 = new Attribute(13, a11, "mid_range", true,"Mid range",2); 
		 		model.Attribute a14 = new Attribute(14, a11, "high_end", true,"High end",2); 
		 	model.Attribute a25 = new Attribute(25, a10, "category", false,"Category",1);
		 		model.Attribute a26 = new Attribute(26, a25, "family", true,"Family",3);  
		 		model.Attribute a27 = new Attribute(27, a25, "backpacker", true,"backpacker",3);  
		 model.Attribute a15 = new Attribute(15, null, "activity", false,"activity",0);
		 	model.Attribute a16 = new Attribute(16, a15, "museum", false, "Museum",1); 
		 		model.Attribute a17 = new Attribute(17, a16, "museumhistorical", true, "Historical museum",2);
		 		model.Attribute a18 = new Attribute(18, a16, "museumwar", true, "War museum",2);
		 	model.Attribute a19 = new Attribute(19, a15, "buldinghistorical", false, "Historical building",1);
		 		model.Attribute a20 = new Attribute(20, a19, "cathedral", true, "Cathedral",2);
		 		model.Attribute a29 = new Attribute(29, a19, "cathedral", true, "University building",2);
		 	model.Attribute a21 = new Attribute(21, a15, "cinema", true, "Cinema",1); 
		 	model.Attribute a22 = new Attribute(22, a15, "theater", true, "Theater",1); 
		 	
		 	
		 	
		 	
			 gdao.makePersistent(a1);
			 gdao.makePersistent(a2);
			 gdao.makePersistent(a3);
			 gdao.makePersistent(a4);
			 gdao.makePersistent(a5);
			 gdao.makePersistent(a6);
			 gdao.makePersistent(a7);
			 gdao.makePersistent(a8);
			 gdao.makePersistent(a9);
			 gdao.makePersistent(a10);
			 gdao.makePersistent(a11);
			 gdao.makePersistent(a12);
			 gdao.makePersistent(a13);
			 gdao.makePersistent(a14);
			 gdao.makePersistent(a15);
			 gdao.makePersistent(a16);
			 gdao.makePersistent(a17);
			 gdao.makePersistent(a18);
			 gdao.makePersistent(a19);
			 gdao.makePersistent(a20);
			 gdao.makePersistent(a21);
			 gdao.makePersistent(a22);
			 gdao.makePersistent(a23);
			 gdao.makePersistent(a24);
			 gdao.makePersistent(a25);
			 gdao.makePersistent(a26);
			 gdao.makePersistent(a27);
			 gdao.makePersistent(a28);
			 gdao.makePersistent(a29);
			 
		
	
		 Citynode node1 = cdao.findByID((long)1, true); 
		 node1.getAttributes().add(a4);
		 node1.getAttributes().add(a28);
		 cdao.makePersistent(node1); 
		 
		 Citynode node2 = cdao.findByID((long)2, true); 
		 node2.getAttributes().add(a13); 
		 node2.getAttributes().add(a3); 
		 cdao.makePersistent(node2); 
	 
		 Citynode node3 = cdao.findByID((long)3, true); 
		 node3.getAttributes().add(a20);
		 cdao.makePersistent(node3); 
		 
		 Citynode node4 = cdao.findByID((long)4, true); 
		 cdao.makePersistent(node4); 
		 
		 Citynode node6 = cdao.findByID((long)6, true);
		 node6.getAttributes().add(a4);
		 node6.getAttributes().add(a24);
		 cdao.makePersistent(node6); 
		 
		 Citynode node7 = cdao.findByID((long)7, true);
		 node7.getAttributes().add(a26);
		 node7.getAttributes().add(a13);
		 cdao.makePersistent(node6); 
		 

		 Citynode node10 = cdao.findByID((long)10, true);
		 node10.getAttributes().add(a29);
		 cdao.makePersistent(node10); 
		 
		 Citynode node11 = cdao.findByID((long)11, true);
		 node11.getAttributes().add(a3);
		 node11.getAttributes().add(a9);
		 cdao.makePersistent(node11); 
		 
		 
		 //create a random user model
		 List <Attribute> attributeList = gdao.findAll(); 
		
		 Set <Preference> preferences = new HashSet(); 
		 
		 for(Attribute a : attributeList)
		 { 
				Preference p = new Preference(); 
				p.setAttribute(a); 
				p.setProbability(Math.random()); 
				
				pdao.makePersistent(p); 
				preferences.add(p); 
		 }
		  
		 
		 /*
		 
		Preference p1 = new Preference(); 
		p1.setAttribute(a3); 
		p1.setProbability(0.9); 
		
		Preference p2 = new Preference(); 
		p2.setAttribute(a4); 
		p2.setProbability(0.01);
		
		
		Preference p3 = new Preference(); 
		p3.setAttribute(a5); 
		p3.setProbability(0.0);
		
		Preference p4 = new Preference(); 
		p4.setAttribute(a7); 
		p4.setProbability(0.5);
		
		
		Preference p5 = new Preference(); 
		p5.setAttribute(a8); 
		p5.setProbability(1.0);
		
		
		Preference p6 = new Preference(); 
		p6.setAttribute(a9); 
		p6.setProbability(0.1);
		

		pdao.makePersistent(p1);
		pdao.makePersistent(p2);
		pdao.makePersistent(p3);
		pdao.makePersistent(p4);
		pdao.makePersistent(p5);
		pdao.makePersistent(p6);
	
		Set <Preference> preferences = new HashSet(); 
		preferences.add(p1);
		preferences.add(p2);
		preferences.add(p3);
		preferences.add(p4);
		preferences.add(p5);
		preferences.add(p6);
		*/
		UserModel model = new UserModel(); 
		
		model.setPreferences(preferences);
		
		um.makePersistent(model);

	 }
	 
	 
	// Ports user, from userFeatures (String) to userMatrix (Matrix)
		public void userPortToMatrix(User us){
			Matrix m = new Matrix(us.getUserFeatures().length(), 1);
			
			for(int x=0; x < us.getUserFeatures().length(); x++){
				if (us.getUserFeatures().substring(x, x+1).equals("1")){
					m.set(x, 0, 1);
				}
			}
			
//			// Print user matrix
//			for(int i=0; i<m.getRowDimension(); i++){
//				System.out.println("Usermatrix at " + i + ": " + m.get(i, 0));
//			}
			
			us.setUserMatrix(m);
		}
		
		
		// Ports item, from itemFeatures (String) to itemMatrix (Matrix)
		public void itemPortToMatrix(Citynode cn){
			Matrix m = new Matrix(cn.getItemFeatures().length(), 1);
			
			for(int x=0; x < cn.getItemFeatures().length(); x++){
				if (cn.getItemFeatures().substring(x, x+1).equals("1")){
					m.set(x, 0, 1);
				}
			}
			
//			// Print item matrix
//			for(int i=0; i<m.getRowDimension(); i++){
//				System.out.println("Itemsmatrix at " + i + ": " + m.get(i, 0));
//			}
			
			cn.setItemMatrix(m);
		}

	 
}
